
This is a patch file against 0.2.18.

Change to directory gnupg-0.2.18 (or however you renamed it)
and give this command:

     zcat somepath/gnupg-0.2.19.diff.gz | patch -p1

It is a good idea to rename your current directory to gnupg-0.2.19 now.



Prereq: 0.2.18

diff -urN gnupg-0.2.18/VERSION gnupg-0.2.19/VERSION
--- gnupg-0.2.18/VERSION	Fri May 15 18:43:27 1998
+++ gnupg-0.2.19/VERSION	Fri May 29 12:54:06 1998
@@ -1 +1 @@
-0.2.18
+0.2.19

diff -urN gnupg-0.2.18/AUTHORS gnupg-0.2.19/AUTHORS
--- gnupg-0.2.18/AUTHORS	Tue Nov 18 11:00:09 1997
+++ gnupg-0.2.19/AUTHORS	Thu May 28 18:22:19 1998
@@ -0,0 +1,8 @@
+Authors of GNU Privacy Guard (gnupg).
+
+Werner Koch.  Designed and implemented gnupg.
+
+
+TRANSLATIONS	Marco d'Itri    1997-02-22
+Disclaim
+
diff -urN gnupg-0.2.18/ChangeLog gnupg-0.2.19/ChangeLog
--- gnupg-0.2.18/ChangeLog	Mon May 11 10:21:58 1998
+++ gnupg-0.2.19/ChangeLog	Mon May 25 19:11:38 1998
@@ -1,3 +1,7 @@
+Mon May 25 19:10:59 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* rand-unix.c (fast_random_poll): fixed syntax bug.
+
 Mon May 11 10:21:31 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* configure.in (PRINTABLE_OS_NAME): Linux is now GNU/Linux
diff -urN gnupg-0.2.18/NEWS gnupg-0.2.19/NEWS
--- gnupg-0.2.18/NEWS	Fri May 15 15:57:29 1998
+++ gnupg-0.2.19/NEWS	Thu May 28 15:40:04 1998
@@ -1,3 +1,25 @@
+Noteworthy changes in version 0.2.19
+------------------------------------
+
+    * Replaced /dev/urandom in checks with new tool mk-tdata.
+
+    * Some assembler file cleanups; some more functions for the Alpha.
+
+    * Tiger has now the OpenPGP assigned number 6.  Because the OID has
+      changed, old signatures using this algorithm can't be verified.
+
+    * gnupg now encrypts the compressed packed and not any longer in the
+      reverse order; anyway it can decrypt both versions. Thanks to Tom
+      for telling me this (not security related) bug.
+
+    * --add-key works and you are now able to generate subkeys.
+
+    * It is now possible to generate ElGamal keys in v4 packets to create
+      valid OpenPGP keys.
+
+    * Some new features for better integration into MUAs.
+
+
 Noteworthy changes in version 0.2.18
 ------------------------------------
 
diff -urN gnupg-0.2.18/README gnupg-0.2.19/README
--- gnupg-0.2.18/README	Mon May  4 20:20:28 1998
+++ gnupg-0.2.19/README	Fri May 29 12:53:55 1998
@@ -30,11 +30,10 @@
     the United States until Sep 20, 2000).  I'm sorry about this, but
     this is the world we have created (e.g. by using proprietary software).
 
-    Because the OpenPGP standard is still a draft, GNUPG is not yet
-    compatible with it (or PGP 5) - but it will be.  The data structures
-    used are compatible with PGP 2.x, so it can parse and list such files
-    and PGP should be able to parse data created by GNUPG and complain
-    about unsupported algorithms.
+    Because the OpenPGP standard is still a draft, GNUPG now interoperates
+    with it and PGP 5.	The MUA Mutt will soon support GNUPG; it has a
+    mode to fallback to another program if the received message has been
+    created with RSA or IDEA.
 
     The default algorithms used by GNUPG are ElGamal for public-key
     encryption and signing; Blowfish with a 128 bit key for protecting
@@ -76,31 +75,6 @@
     Because we have no hardware device to generate randomness we have to
     use this method.
 
-    Key generation shows progress by printing different characters to
-    stderr:
-	     "."  Last 10 Miller-Rabin tests failed
-	     "+"  Miller-Rabin test succeeded
-	     "!"  Reloading the pool with fresh prime numbers
-	     "^"  Checking a new value for the generator
-	     "<"  Size of one factor decreased
-	     ">"  Size of one factor increased
-
-    The prime number for ElGamal is generated this way:
-
-    1) Make a prime number q of 160, 200, 240 bits (depending on the keysize)
-    2) Select the length of the other prime factors to be at least the size
-       of q and calculate the number of prime factors needed
-    3) Make a pool of prime numbers, each of the length determined in step 2
-    4) Get a new permutation out of the pool or continue with step 3
-       if we have tested all permutations.
-    5) Calculate a candidate prime p = 2 * q * p[1] * ... * p[n] + 1
-    6) Check that this prime has the correct length (this may change q if
-       it seems not to be possible to make a prime of the desired length)
-    7) Check whether this is a prime using trial divisions and the
-       Miller-Rabin test.
-    8) Continue with step 4 if we did not find a prime in step 7.
-    9) Find a generator for that prime.
-
     You should make a revocation certificate in case someone gets
     knowledge of your secret key or you forgot your passphrase:
 
@@ -109,6 +83,13 @@
     Run this command and store it away; output is always ASCII armored,
     so that you can print it and (hopefully never) re-create it if
     your electronic media fails.
+
+    If you decided to create a DSA key, you should add an ElGamal
+    for encryption:
+
+	gpg --add-key user_id_of_your_key
+
+    and follow the displayed instructions (select "ElGamal using v4 packets").
 
 
     You can sign a key with this command:
diff -urN gnupg-0.2.18/TODO gnupg-0.2.19/TODO
--- gnupg-0.2.18/TODO	Fri May 15 17:39:16 1998
+++ gnupg-0.2.19/TODO	Thu May 28 15:38:50 1998
@@ -1,5 +1,9 @@
 
-    * make --add-key work (to add an ElGamal key to a DSA key).
+    * add usage arguments to get_key_byname or return a PKC_LIST with
+      all keys and add a selection.
+
+    * add expiration date and other stuff from v4 sigs to the trust
+      checking.
 
     * add readline support. Must enhance libreadline - Anyone?
 
diff -urN gnupg-0.2.18/checks/ChangeLog gnupg-0.2.19/checks/ChangeLog
--- gnupg-0.2.18/checks/ChangeLog	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/checks/ChangeLog	Mon May 18 15:40:55 1998
@@ -0,0 +1,6 @@
+Mon May 18 15:40:02 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* Makefile.am: Now uses mk-tdata to produce random test data.
+
+	* ChangeLog: New.
+
diff -urN gnupg-0.2.18/checks/Makefile.am gnupg-0.2.19/checks/Makefile.am
--- gnupg-0.2.18/checks/Makefile.am	Sun May 10 20:31:53 1998
+++ gnupg-0.2.19/checks/Makefile.am	Mon May 18 15:39:14 1998
@@ -42,12 +42,12 @@
 	../g10/gpgm --yes --dearmor -o secring.skr secring.skr.asc
 
 data-500:
-	head -c 500 /dev/urandom >data-500
+	../tools/mk-tdata   500 /dev/urandom >data-500
 data-9000:
-	head -c 9000 /dev/urandom >data-9000
+	../tools/mk-tdata  9000 /dev/urandom >data-9000
 data-32000:
-	head -c 32000 /dev/urandom >data-32000
+	../tools/mk-tdata 32000 /dev/urandom >data-32000
 data-80000:
-	head -c 80000 /dev/urandom >data-80000
+	../tools/mk-tdata 80000 /dev/urandom >data-80000
 
 
diff -urN gnupg-0.2.18/checks/Makefile.in gnupg-0.2.19/checks/Makefile.in
--- gnupg-0.2.18/checks/Makefile.in	Fri May 15 18:45:48 1998
+++ gnupg-0.2.19/checks/Makefile.in	Fri May 29 12:56:33 1998
@@ -114,7 +114,7 @@
 mkinstalldirs = $(SHELL) $(top_srcdir)/scripts/mkinstalldirs
 CONFIG_HEADER = ../config.h
 CONFIG_CLEAN_FILES = 
-DIST_COMMON =  Makefile.am Makefile.in
+DIST_COMMON =  ChangeLog Makefile.am Makefile.in
 
 
 DISTFILES = $(DIST_COMMON) $(SOURCES) $(HEADERS) $(TEXINFOS) $(EXTRA_DIST)
@@ -246,13 +246,13 @@
 	../g10/gpgm --yes --dearmor -o secring.skr secring.skr.asc
 
 data-500:
-	head -c 500 /dev/urandom >data-500
+	../tools/mk-tdata   500 /dev/urandom >data-500
 data-9000:
-	head -c 9000 /dev/urandom >data-9000
+	../tools/mk-tdata  9000 /dev/urandom >data-9000
 data-32000:
-	head -c 32000 /dev/urandom >data-32000
+	../tools/mk-tdata 32000 /dev/urandom >data-32000
 data-80000:
-	head -c 80000 /dev/urandom >data-80000
+	../tools/mk-tdata 80000 /dev/urandom >data-80000
 
 # Tell versions [3.59,3.63) of GNU make to not export all variables.
 # Otherwise a system limit (for SysV at least) may be exceeded.
diff -urN gnupg-0.2.18/cipher/ChangeLog gnupg-0.2.19/cipher/ChangeLog
--- gnupg-0.2.18/cipher/ChangeLog	Thu May 14 15:44:04 1998
+++ gnupg-0.2.19/cipher/ChangeLog	Fri May 22 07:31:02 1998
@@ -1,3 +1,11 @@
+Fri May 22 07:30:39 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* md.c (md_get_oid): Add a new one for TIGER.
+
+Thu May 21 13:24:52 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* cipher.c: Add support for a dummy cipher
+
 Thu May 14 15:40:36 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* rmd160.c (transform): fixed sigbus - I should better
diff -urN gnupg-0.2.18/cipher/Makefile.am gnupg-0.2.19/cipher/Makefile.am
--- gnupg-0.2.18/cipher/Makefile.am	Fri May  8 17:58:26 1998
+++ gnupg-0.2.19/cipher/Makefile.am	Fri May 29 12:11:46 1998
@@ -11,6 +11,7 @@
 		 blowfish.h	\
 		 cast5.c	\
 		 cast5.h	\
+		 des.h		\
 		 elgamal.c	\
 		 elgamal.h	\
 		 md5.c		\
diff -urN gnupg-0.2.18/cipher/Makefile.in gnupg-0.2.19/cipher/Makefile.in
--- gnupg-0.2.18/cipher/Makefile.in	Fri May 15 18:45:35 1998
+++ gnupg-0.2.19/cipher/Makefile.in	Fri May 29 12:56:17 1998
@@ -102,6 +102,7 @@
 		 blowfish.h	\
 		 cast5.c	\
 		 cast5.h	\
+		 des.h		\
 		 elgamal.c	\
 		 elgamal.h	\
 		 md5.c		\
@@ -249,7 +250,7 @@
 	../include/../cipher/sha1.h ../include/../cipher/md5.h \
 	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
 	../include/../cipher/dsa.h ../include/../cipher/random.h \
-	blowfish.h cast5.h
+	blowfish.h cast5.h des.h
 dsa.o: dsa.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h ../include/cipher.h \
diff -urN gnupg-0.2.18/cipher/cipher.c gnupg-0.2.19/cipher/cipher.c
--- gnupg-0.2.18/cipher/cipher.c	Mon Apr 27 14:44:26 1998
+++ gnupg-0.2.19/cipher/cipher.c	Wed May 27 15:18:15 1998
@@ -31,6 +31,7 @@
 #include "cipher.h"
 #include "blowfish.h"
 #include "cast5.h"
+#include "des.h"
 
 #define STD_BLOCKSIZE 8
 
@@ -38,18 +39,20 @@
   #error Invalid BLOWFISH blocksize
 #elif CAST5_BLOCKSIZE != STD_BLOCKSIZE
   #error Invalid CAST blocksize
+#elif DES_BLOCKSIZE != STD_BLOCKSIZE
+  #error Invalid DES blocksize
 #endif
 
 
 static struct { const char *name; int algo; int keylen; } cipher_names[] = {
     { "IDEA",        CIPHER_ALGO_IDEA        ,0   },
-    { "3DES",        CIPHER_ALGO_3DES        ,0   },
+    { "3DES",        CIPHER_ALGO_3DES        ,168 },
     { "CAST",        CIPHER_ALGO_CAST        ,128 },
     { "BLOWFISH160", CIPHER_ALGO_BLOWFISH160 ,160 },
-    { "ROT_N",       CIPHER_ALGO_ROT_N       ,0   },
     { "SAFER_SK128", CIPHER_ALGO_SAFER_SK128 ,0   },
     { "DES_SK",      CIPHER_ALGO_DES_SK      ,0   },
     { "BLOWFISH",    CIPHER_ALGO_BLOWFISH    ,128 },
+    { "DUMMY"   ,    CIPHER_ALGO_DUMMY       ,128 },
     {NULL} };
 
 
@@ -76,6 +79,14 @@
 };
 
 
+static void
+dummy_setkey( void *c, byte *key, unsigned keylen ) { }
+static void
+dummy_encrypt_block( void *c, byte *outbuf, byte *inbuf ) { BUG(); }
+static void
+dummy_decrypt_block( void *c, byte *outbuf, byte *inbuf ) { BUG(); }
+
+
 /****************
  * Map a string to the cipher algo
  */
@@ -115,6 +126,8 @@
       case CIPHER_ALGO_BLOWFISH160:
       case CIPHER_ALGO_BLOWFISH:
       case CIPHER_ALGO_CAST:
+      case CIPHER_ALGO_3DES:
+      case CIPHER_ALGO_DUMMY:
 	return 0;
       default:
 	return G10ERR_CIPHER_ALGO;
@@ -154,7 +167,9 @@
     hd = secure ? m_alloc_secure_clear( sizeof *hd )
 		: m_alloc_clear( sizeof *hd );
     hd->algo = algo;
-    if( mode == CIPHER_MODE_AUTO_CFB ) {
+    if( algo == CIPHER_ALGO_DUMMY )
+	hd->mode = CIPHER_MODE_DUMMY;
+    else if( mode == CIPHER_MODE_AUTO_CFB ) {
 	if( algo != CIPHER_ALGO_BLOWFISH160 )
 	    hd->mode = CIPHER_MODE_PHILS_CFB;
 	else
@@ -175,6 +190,18 @@
 	hd->encrypt = FNCCAST_CRYPT(cast5_encrypt_block);
 	hd->decrypt = FNCCAST_CRYPT(cast5_decrypt_block);
 	break;
+#if 0
+      case CIPHER_ALGO_3DES:
+	hd->setkey  = FNCCAST_SETKEY(des_3des_setkey);
+	hd->encrypt = FNCCAST_CRYPT(des_encrypt_block);
+	hd->decrypt = FNCCAST_CRYPT(des_decrypt_block);
+	break;
+#endif
+      case CIPHER_ALGO_DUMMY:
+	hd->setkey  = FNCCAST_SETKEY(dummy_setkey);
+	hd->encrypt = FNCCAST_CRYPT(dummy_encrypt_block);
+	hd->decrypt = FNCCAST_CRYPT(dummy_decrypt_block);
+	break;
 
       default: log_fatal("cipher_open: invalid algo %d\n", algo );
     }
@@ -217,8 +244,8 @@
 
     for(n=0; n < nblocks; n++ ) {
 	(*c->encrypt)( &c->c.context, outbuf, inbuf );
-	inbuf  += CAST5_BLOCKSIZE;;
-	outbuf += CAST5_BLOCKSIZE;
+	inbuf  += STD_BLOCKSIZE;;
+	outbuf += STD_BLOCKSIZE;
     }
 }
 
@@ -229,8 +256,8 @@
 
     for(n=0; n < nblocks; n++ ) {
 	(*c->decrypt)( &c->c.context, outbuf, inbuf );
-	inbuf  += CAST5_BLOCKSIZE;;
-	outbuf += CAST5_BLOCKSIZE;
+	inbuf  += STD_BLOCKSIZE;;
+	outbuf += STD_BLOCKSIZE;
     }
 }
 
@@ -397,6 +424,10 @@
       case CIPHER_MODE_PHILS_CFB:
 	do_cfb_encrypt(c, outbuf, inbuf, nbytes );
 	break;
+      case CIPHER_MODE_DUMMY:
+	if( inbuf != outbuf )
+	    memmove( outbuf, inbuf, nbytes );
+	break;
       default: log_fatal("cipher_encrypt: invalid mode %d\n", c->mode );
     }
 }
@@ -419,6 +450,10 @@
       case CIPHER_MODE_PHILS_CFB:
 	do_cfb_decrypt(c, outbuf, inbuf, nbytes );
 	break;
+      case CIPHER_MODE_DUMMY:
+	if( inbuf != outbuf )
+	    memmove( outbuf, inbuf, nbytes );
+	break;
       default: log_fatal("cipher_decrypt: invalid mode %d\n", c->mode );
     }
 }
@@ -433,8 +468,8 @@
 cipher_sync( CIPHER_HANDLE c )
 {
     if( c->mode == CIPHER_MODE_PHILS_CFB && c->unused ) {
-	memmove(c->iv + c->unused, c->iv, CAST5_BLOCKSIZE - c->unused );
-	memcpy(c->iv, c->lastiv + CAST5_BLOCKSIZE - c->unused, c->unused);
+	memmove(c->iv + c->unused, c->iv, STD_BLOCKSIZE - c->unused );
+	memcpy(c->iv, c->lastiv + STD_BLOCKSIZE - c->unused, c->unused);
 	c->unused = 0;
     }
 }
diff -urN gnupg-0.2.18/cipher/des.h gnupg-0.2.19/cipher/des.h
--- gnupg-0.2.18/cipher/des.h	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/cipher/des.h	Fri May 29 12:11:27 1998
@@ -0,0 +1,37 @@
+/* des.h
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+#ifndef G10_DES_H
+#define G10_DES_H
+
+#include "types.h"
+
+#define DES_BLOCKSIZE 8
+#define DES_ROUNDS 16
+
+typedef struct {
+    int tripledes;
+} DES_context;
+
+void des_setkey( DES_context *c, byte *key, unsigned keylen );
+void des_3des_setkey( DES_context *c, byte *key, unsigned keylen );
+void des_encrypt_block( DES_context *bc, byte *outbuf, byte *inbuf );
+void des_decrypt_block( DES_context *bc, byte *outbuf, byte *inbuf );
+
+#endif /*G10_DES_H*/
diff -urN gnupg-0.2.18/cipher/md.c gnupg-0.2.19/cipher/md.c
--- gnupg-0.2.18/cipher/md.c	Wed May 13 19:01:15 1998
+++ gnupg-0.2.19/cipher/md.c	Fri May 22 07:39:53 1998
@@ -216,35 +216,48 @@
 }
 
 
+/* fixme: put the oids in a table and add a mode to enumerate the OIDs
+ * to make g10/sig-check.c more portable */
 const byte *
 md_asn_oid( int algo, size_t *asnlen, size_t *mdlen )
 {
-    size_t alen, mlen;
+    size_t alen;
     byte *p;
 
     if( algo == DIGEST_ALGO_MD5 ) {
 	static byte asn[18] = /* Object ID is 1.2.840.113549.2.5 */
 		    { 0x30, 0x20, 0x30, 0x0c, 0x06, 0x08, 0x2a, 0x86,0x48,
 		      0x86, 0xf7, 0x0d, 0x02, 0x05, 0x05, 0x00, 0x04, 0x10 };
-	mlen = 16; alen = DIM(asn); p = asn;
+	alen = DIM(asn); p = asn;
     }
     else if( algo == DIGEST_ALGO_RMD160 ) {
 	static byte asn[15] = /* Object ID is 1.3.36.3.2.1 */
 	  { 0x30, 0x21, 0x30, 0x09, 0x06, 0x05, 0x2b, 0x24, 0x03,
 	    0x02, 0x01, 0x05, 0x00, 0x04, 0x14 };
-	mlen = 20; alen = DIM(asn); p = asn;
+	alen = DIM(asn); p = asn;
     }
     else if( algo == DIGEST_ALGO_TIGER ) {
-	static byte asn[15] = /* FIXME: Object ID is ???????????? */
-	  { 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42,
-	    0x42, 0x42, 0x42, 0x42, 0x42, 0x42 };
-	mlen = 24; alen = DIM(asn); p = asn;
+	/* 40: SEQUENCE {
+	 * 12:	 SEQUENCE {
+	 *  8:	   OCTET STRING   :54 49 47 45 52 31 39 32
+	 *  0:	   NULL
+	 *   :	   }
+	 * 24:	 OCTET STRING
+	 *   :	 }
+	 *
+	 * By replacing the 5th byte (0x04) with 0x16 we would have;
+	 *	  8:	 IA5String 'TIGER192'
+	 */
+	static byte asn[18] =
+		    { 0x30, 0x28, 0x30, 0x0c, 0x04, 0x08, 0x54, 0x49, 0x47,
+		      0x45, 0x52, 0x31, 0x39, 0x32, 0x05, 0x00, 0x04, 0x18 };
+	alen = DIM(asn); p = asn;
     }
     else if( algo == DIGEST_ALGO_SHA1 ) {
-	static byte asn[15] = /* Objet ID is 1.3.14.3.2.26 */
+	static byte asn[15] = /* Object ID is 1.3.14.3.2.26 */
 		    { 0x30, 0x21, 0x30, 0x09, 0x06, 0x05, 0x2b, 0x0e, 0x03,
 		      0x02, 0x1a, 0x05, 0x00, 0x04, 0x14 };
-	mlen = 20; alen = DIM(asn); p = asn;
+	alen = DIM(asn); p = asn;
     }
     else
 	log_bug("md_asn_oid(%d)", algo );
@@ -252,7 +265,7 @@
     if( asnlen )
 	*asnlen = alen;
     if( mdlen )
-	*mdlen = mlen;
+	*mdlen = p[alen-1];
     return p;
 }
 
diff -urN gnupg-0.2.18/cipher/misc.c gnupg-0.2.19/cipher/misc.c
--- gnupg-0.2.18/cipher/misc.c	Mon May  4 16:01:40 1998
+++ gnupg-0.2.19/cipher/misc.c	Thu May 28 15:28:15 1998
@@ -31,8 +31,9 @@
     { "RSA",           PUBKEY_ALGO_RSA     },
     { "RSA-E",         PUBKEY_ALGO_RSA_E   },
     { "RSA-S",         PUBKEY_ALGO_RSA_S   },
-    { "ELGAMAL",       PUBKEY_ALGO_ELGAMAL },
     { "ELG",           PUBKEY_ALGO_ELGAMAL },
+    { "ELG-E",         PUBKEY_ALGO_ELGAMAL_E },
+    { "ELGAMAL",       PUBKEY_ALGO_ELGAMAL },
     { "DSA",           PUBKEY_ALGO_DSA     },
     {NULL} };
 
@@ -75,6 +76,11 @@
 pubkey_algo_to_string( int algo )
 {
     int i;
+
+    if( is_ELGAMAL(algo) )
+	algo = PUBKEY_ALGO_ELGAMAL;
+    else if( is_RSA(algo) )
+	algo = PUBKEY_ALGO_RSA;
 
     for(i=0; pubkey_names[i].name; i++ )
 	if( pubkey_names[i].algo == algo )
diff -urN gnupg-0.2.18/cipher/rand-unix.c gnupg-0.2.19/cipher/rand-unix.c
--- gnupg-0.2.18/cipher/rand-unix.c	Sun May 10 21:56:54 1998
+++ gnupg-0.2.19/cipher/rand-unix.c	Mon May 25 19:11:45 1998
@@ -62,7 +62,7 @@
 {
   #if HAVE_GETHRTIME
     {	hrtime_t tv;
-	tv = gethrtime(void);
+	tv = gethrtime();
 	add_randomness( &tv, sizeof(tv), 1 );
     }
   #elif HAVE_GETTIMEOFTIME
diff -urN gnupg-0.2.18/doc/DETAILS gnupg-0.2.19/doc/DETAILS
--- gnupg-0.2.18/doc/DETAILS	Fri Apr 17 19:03:11 1998
+++ gnupg-0.2.19/doc/DETAILS	Fri May 29 12:47:06 1998
@@ -11,6 +11,32 @@
       to keep them small.
 
 
+    Key generation shows progress by printing different characters to
+    stderr:
+	     "."  Last 10 Miller-Rabin tests failed
+	     "+"  Miller-Rabin test succeeded
+	     "!"  Reloading the pool with fresh prime numbers
+	     "^"  Checking a new value for the generator
+	     "<"  Size of one factor decreased
+	     ">"  Size of one factor increased
+
+    The prime number for ElGamal is generated this way:
+
+    1) Make a prime number q of 160, 200, 240 bits (depending on the keysize)
+    2) Select the length of the other prime factors to be at least the size
+       of q and calculate the number of prime factors needed
+    3) Make a pool of prime numbers, each of the length determined in step 2
+    4) Get a new permutation out of the pool or continue with step 3
+       if we have tested all permutations.
+    5) Calculate a candidate prime p = 2 * q * p[1] * ... * p[n] + 1
+    6) Check that this prime has the correct length (this may change q if
+       it seems not to be possible to make a prime of the desired length)
+    7) Check whether this is a prime using trial divisions and the
+       Miller-Rabin test.
+    8) Continue with step 4 if we did not find a prime in step 7.
+    9) Find a generator for that prime.
+
+
 
 
 Layout of the TrustDB
@@ -283,4 +309,31 @@
 	valid request
 
 
+
+Ich werde jetzt doch das HKP Protokoll implementieren:
+
+Naja, die Doku ist so gut wie nichtexistent, da gebe ich Dir recht.
+In kurzen Worten:
+
+(Minimal-)HTTP-Server auf Port 11371, versteht ein GET auf /pks/lookup,
+wobei die Query-Parameter (Key-Value-Paare mit = zwischen Key und
+Value; die Paare sind hinter ? und durch & getrennt). Gltige
+Operationen sind:
+
+- - op (Operation) mit den Mglichkeiten index (gleich wie -kv bei
+  PGP), vindex (-kvv) und get (-kxa)
+- - search: Liste der Worte, die im Key vorkommen mssen. Worte sind
+  mit Worttrennzeichen wie Space, Punkt, @, ... getrennt, Worttrennzeichen
+  werden nicht betrachtet, die Reihenfolge der Worte ist egal.
+- - exact: (on=aktiv, alles andere inaktiv) Nur die Schlssel
+  zurckgeben, die auch den "search"-String beinhalten (d.h.
+  Wortreihenfolge und Sonderzeichen sind wichtig)
+- - fingerprint (Bei [v]index auch den Fingerprint ausgeben), "on"
+  fr aktiv, alles andere inaktiv
+
+Neu (wird von GNUPG benutzt):
+   /pks/lookup/<gnupg_formatierte_user_id>?op=<operation>
+
+Zustzlich versteht der Keyserver auch ein POST auf /pks/add, womit
+man Keys hochladen kann.
 
diff -urN gnupg-0.2.18/g10/ChangeLog gnupg-0.2.19/g10/ChangeLog
--- gnupg-0.2.18/g10/ChangeLog	Fri May 15 17:58:28 1998
+++ gnupg-0.2.19/g10/ChangeLog	Fri May 29 10:31:45 1998
@@ -1,3 +1,75 @@
+Fri May 29 10:00:28 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* trustdb.c (query_trust_info): New.
+	* keylist.c (list_one): Add output of trust info
+	* mainproc (list_node): ditto.
+	* g10.c (main): full trustdb init if -with-colons and any of the
+	key list modes.
+
+Thu May 28 10:34:42 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* status.c (STATUS_RSA_OR_IDEA): New.
+	* sig-check.c (check_signature): Output special status message.
+	* pubkey-enc.c (get_session_key): Ditto.
+
+	* mainproc.c (check_sig_and_print): Changed format of output.
+	* passpharse.c (passphrase_to_dek): Likewise.
+
+Wed May 27 13:46:48 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* g10.c (aListSecretKeys): New option --list-secret-keys
+	* keylist.c (std_key_list): Renamed to public_key_list.
+	(secret_key_list): New
+	(list_one, list_all): Add support for secret keys.
+	* getkey.c (get_secret_keyring): New.
+	* mainproc.c (list_node): Add option --with-colons for secret keys
+
+	* sig-check.c (check_key_signature): detection of selfsigs
+	* mainproc.c (list_node): fixed listing.
+
+	* g10.c (aListSecretKeys): New option --always-trust
+	* pkclist.c (do_we_trust): Override per option added
+
+	* status.c (write_status_text): Add a prefix to every output line.
+
+Wed May 27 07:49:21 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* g10 (--compress-keys): New.
+	* options.h (compress_keys): New.
+	* export.c (export_pubkeys): Only compresses with the new option.
+
+Tue May 26 11:24:33 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* passphrase.c (get_last_passphrase): New
+	(set_next_passphrase): New.
+	(passphrase_to_dek): add support for the above functions.
+	* keyedit.c (make_keysig_packet): Add sigclass 0x18,
+	changed all callers due to a new argument.
+	* keygen.c (write_keybinding): New
+	(generate_subkeypair): Add functionality
+	(ask_algo, ask_keysize, ask_valid_days): Broke out of generate_keypair
+	(ask_user_id, ask_passphrase): Ditto.
+
+Thu May 21 11:26:13 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* g10.c,gpgd.c (main): Does now return an int, so that egcs does
+	not complain.
+
+	* armor.c (fake_packet): Removed erro message and add a noticed
+	that this part should be fixed.
+
+	* sign.c (sign_file): Compression now comes in front of encryption.
+	* encode.c (encode_simple): Ditto.
+	(encode_crypt): Ditto.
+
+Tue May 19 16:18:19 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* armor.c (fake_packet): Changed assertion to log_error
+
+Sat May 16 16:02:06 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* build-packet.c (build_packet): Add SUBKEY packets.
+
 Fri May 15 17:57:23 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* sign.c (hash_for): New and used in all places here.
diff -urN gnupg-0.2.18/g10/Makefile.am gnupg-0.2.19/g10/Makefile.am
--- gnupg-0.2.18/g10/Makefile.am	Fri Apr 17 19:09:04 1998
+++ gnupg-0.2.19/g10/Makefile.am	Thu May 28 10:16:19 1998
@@ -5,7 +5,8 @@
 OMIT_DEPENDENCIES = zlib.h zconf.h
 needed_libs = ../cipher/libcipher.a ../mpi/libmpi.a ../util/libutil.a
 
-bin_PROGRAMS = gpg gpgm gpgd
+noinst_PROGRAMS = gpgd
+bin_PROGRAMS = gpg gpgm
 
 common_source =  \
 	      build-packet.c	\
diff -urN gnupg-0.2.18/g10/Makefile.in gnupg-0.2.19/g10/Makefile.in
--- gnupg-0.2.18/g10/Makefile.in	Fri May 15 18:45:43 1998
+++ gnupg-0.2.19/g10/Makefile.in	Fri May 29 12:56:28 1998
@@ -97,7 +97,8 @@
 OMIT_DEPENDENCIES = zlib.h zconf.h
 needed_libs = ../cipher/libcipher.a ../mpi/libmpi.a ../util/libutil.a
 
-bin_PROGRAMS = gpg gpgm gpgd
+noinst_PROGRAMS = gpgd
+bin_PROGRAMS = gpg gpgm
 
 common_source =  \
 	      build-packet.c	\
@@ -166,7 +167,7 @@
 mkinstalldirs = $(SHELL) $(top_srcdir)/scripts/mkinstalldirs
 CONFIG_HEADER = ../config.h
 CONFIG_CLEAN_FILES = 
-PROGRAMS =  $(bin_PROGRAMS)
+PROGRAMS =  $(bin_PROGRAMS) $(noinst_PROGRAMS)
 
 
 DEFS = @DEFS@ -I. -I$(srcdir) -I..
@@ -255,6 +256,15 @@
 	  rm -f $(bindir)/`echo $$p|sed '$(transform)'`; \
 	done
 
+mostlyclean-noinstPROGRAMS:
+
+clean-noinstPROGRAMS:
+	-test -z "$(noinst_PROGRAMS)" || rm -f $(noinst_PROGRAMS)
+
+distclean-noinstPROGRAMS:
+
+maintainer-clean-noinstPROGRAMS:
+
 .c.o:
 	$(COMPILE) -c $<
 
@@ -511,7 +521,8 @@
 	../include/../cipher/md5.h ../include/../cipher/tiger.h \
 	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
 	../include/../cipher/random.h filter.h options.h \
-	../include/util.h ../include/errors.h keydb.h main.h status.h
+	../include/util.h ../include/errors.h keydb.h main.h status.h \
+	../include/i18n.h trustdb.h
 mdfilter.o: mdfilter.c ../config.h ../include/errors.h \
 	../include/iobuf.h ../include/types.h ../include/memory.h \
 	../include/util.h ../include/mpi.h filter.h ../include/cipher.h \
@@ -551,7 +562,7 @@
 	../include/../cipher/sha1.h ../include/../cipher/md5.h \
 	../include/../cipher/tiger.h ../include/../cipher/elgamal.h \
 	../include/../cipher/dsa.h ../include/../cipher/random.h \
-	keydb.h packet.h filter.h main.h
+	keydb.h packet.h filter.h main.h ../include/i18n.h
 pkclist.o: pkclist.c ../config.h options.h packet.h ../include/types.h \
 	../include/iobuf.h ../include/mpi.h ../include/memory.h \
 	../include/cipher.h ../include/../cipher/md.h \
@@ -577,7 +588,7 @@
 	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
 	../include/../cipher/md5.h ../include/../cipher/tiger.h \
 	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h keydb.h
+	../include/../cipher/random.h filter.h keydb.h status.h
 revoke.o: revoke.c ../config.h options.h packet.h ../include/types.h \
 	../include/iobuf.h ../include/mpi.h ../include/memory.h \
 	../include/cipher.h ../include/../cipher/md.h \
@@ -609,7 +620,8 @@
 	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
 	../include/../cipher/md5.h ../include/../cipher/tiger.h \
 	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h keydb.h main.h options.h
+	../include/../cipher/random.h filter.h keydb.h main.h options.h \
+	../include/i18n.h
 seskey.o: seskey.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h ../include/cipher.h \
@@ -625,7 +637,7 @@
 	../include/../cipher/rmd.h ../include/../cipher/sha1.h \
 	../include/../cipher/md5.h ../include/../cipher/tiger.h \
 	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
-	../include/../cipher/random.h filter.h keydb.h main.h
+	../include/../cipher/random.h filter.h keydb.h main.h status.h
 sign.o: sign.c ../config.h options.h packet.h ../include/types.h \
 	../include/iobuf.h ../include/mpi.h ../include/memory.h \
 	../include/cipher.h ../include/../cipher/md.h \
@@ -716,25 +728,30 @@
 maintainer-clean-generic:
 	-test -z "$(MAINTAINERCLEANFILES)" || rm -f $(MAINTAINERCLEANFILES)
 	-test -z "$(BUILT_SOURCES)" || rm -f $(BUILT_SOURCES)
-mostlyclean:  mostlyclean-binPROGRAMS mostlyclean-compile \
-		mostlyclean-tags mostlyclean-generic
-
-clean:  clean-binPROGRAMS clean-compile clean-tags clean-generic \
-		mostlyclean
-
-distclean:  distclean-binPROGRAMS distclean-compile distclean-tags \
-		distclean-generic clean
+mostlyclean:  mostlyclean-binPROGRAMS mostlyclean-noinstPROGRAMS \
+		mostlyclean-compile mostlyclean-tags \
+		mostlyclean-generic
+
+clean:  clean-binPROGRAMS clean-noinstPROGRAMS clean-compile clean-tags \
+		clean-generic mostlyclean
+
+distclean:  distclean-binPROGRAMS distclean-noinstPROGRAMS \
+		distclean-compile distclean-tags distclean-generic \
+		clean
 	-rm -f config.status
 
-maintainer-clean:  maintainer-clean-binPROGRAMS maintainer-clean-compile \
-		maintainer-clean-tags maintainer-clean-generic \
-		distclean
+maintainer-clean:  maintainer-clean-binPROGRAMS \
+		maintainer-clean-noinstPROGRAMS \
+		maintainer-clean-compile maintainer-clean-tags \
+		maintainer-clean-generic distclean
 	@echo "This command is intended for maintainers to use;"
 	@echo "it deletes files that may require special tools to rebuild."
 
 .PHONY: default mostlyclean-binPROGRAMS distclean-binPROGRAMS \
 clean-binPROGRAMS maintainer-clean-binPROGRAMS uninstall-binPROGRAMS \
-install-binPROGRAMS mostlyclean-compile distclean-compile clean-compile \
+install-binPROGRAMS mostlyclean-noinstPROGRAMS distclean-noinstPROGRAMS \
+clean-noinstPROGRAMS maintainer-clean-noinstPROGRAMS \
+mostlyclean-compile distclean-compile clean-compile \
 maintainer-clean-compile tags mostlyclean-tags distclean-tags \
 clean-tags maintainer-clean-tags distdir info dvi installcheck \
 install-exec install-data install uninstall all installdirs \
diff -urN gnupg-0.2.18/g10/OPTIONS gnupg-0.2.19/g10/OPTIONS
--- gnupg-0.2.18/g10/OPTIONS	Fri May 15 13:25:17 1998
+++ gnupg-0.2.19/g10/OPTIONS	Wed May 27 13:47:47 1998
@@ -38,3 +38,17 @@
 store
 # simply packs the input data into a rfc1991 packet format
 
+list-secret-keys
+#
+
+
+#-----------------------------------------------
+#--- options
+#-----------------------------------------------
+
+compress-keys
+# compress exported key, compress level is still set with "-z" and
+# algorithm with --compress-algo" - Default is to not compress keys, as
+# this is better for interoperability.
+
+
diff -urN gnupg-0.2.18/g10/armor.c gnupg-0.2.19/g10/armor.c
--- gnupg-0.2.18/g10/armor.c	Fri May 15 15:38:07 1998
+++ gnupg-0.2.19/g10/armor.c	Thu May 21 11:26:53 1998
@@ -703,8 +703,13 @@
 	    break;
 
 	  case fhdrENDClearsig:
-	    assert( emplines );
-	    emplines--; /* don't count the last one */
+	    /* FIXME: this is wrong: Only the last CRLF should
+	     * not be included in the hash, muts rewrite the FSM again
+	     * This proble does only occur if the last line does not end
+	     * in with a LF?
+	     */
+	    if( emplines )
+		emplines--; /* don't count the last one */
 	    state = fhdrENDClearsigHelp;
 	    afx->helplen = n;
 	    break;
diff -urN gnupg-0.2.18/g10/build-packet.c gnupg-0.2.19/g10/build-packet.c
--- gnupg-0.2.18/g10/build-packet.c	Fri May 15 15:38:07 1998
+++ gnupg-0.2.19/g10/build-packet.c	Sat May 16 16:01:59 1998
@@ -82,9 +82,11 @@
       case PKT_COMMENT:
 	rc = do_comment( out, ctb, pkt->pkt.comment );
 	break;
+      case PKT_PUBKEY_SUBCERT:
       case PKT_PUBLIC_CERT:
 	rc = do_public_cert( out, ctb, pkt->pkt.public_cert );
 	break;
+      case PKT_SECKEY_SUBCERT:
       case PKT_SECRET_CERT:
 	rc = do_secret_cert( out, ctb, pkt->pkt.secret_cert );
 	break;
diff -urN gnupg-0.2.18/g10/compress.c gnupg-0.2.19/g10/compress.c
--- gnupg-0.2.18/g10/compress.c	Fri May 15 16:07:41 1998
+++ gnupg-0.2.19/g10/compress.c	Thu May 21 14:35:51 1998
@@ -75,6 +75,9 @@
     do {
 	zs->next_out = zfx->outbuf;
 	zs->avail_out = zfx->outbufsize;
+	if( DBG_FILTER )
+	    log_debug("call deflate: avail_in=%u, avail_out=%u\n",
+		    (unsigned)zs->avail_in, (unsigned)zs->avail_out);
 	zrc = deflate( zs, flush );
 	if( zrc == Z_STREAM_END && flush == Z_FINISH )
 	    ;
@@ -145,6 +148,9 @@
 	    }
 	    zs->avail_in = n;
 	}
+	if( DBG_FILTER )
+	    log_debug("call inflate: avail_in=%u, avail_out=%u\n",
+		    (unsigned)zs->avail_in, (unsigned)zs->avail_out);
 	zrc = inflate( zs, Z_PARTIAL_FLUSH );
 	if( DBG_FILTER )
 	    log_debug("inflate returned: avail_in=%u, avail_out=%u, zrc=%d\n",
diff -urN gnupg-0.2.18/g10/encode.c gnupg-0.2.19/g10/encode.c
--- gnupg-0.2.18/g10/encode.c	Fri May 15 17:59:53 1998
+++ gnupg-0.2.19/g10/encode.c	Tue May 26 13:54:05 1998
@@ -112,13 +112,10 @@
 
     if( opt.armor )
 	iobuf_push_filter( out, armor_filter, &afx );
-
-    write_comment( out, "#created by GNUPG v" VERSION " ("
+    else
+	write_comment( out, "#created by GNUPG v" VERSION " ("
 					    PRINTABLE_OS_NAME ")");
 
-    if( opt.compress )
-	iobuf_push_filter( out, compress_filter, &zfx );
-
     if( s2k ) {
 	PKT_symkey_enc *enc = m_alloc_clear( sizeof *enc );
 	enc->version = 4;
@@ -150,11 +147,14 @@
     pt->buf = inp;
     pkt.pkttype = PKT_PLAINTEXT;
     pkt.pkt.plaintext = pt;
-    cfx.datalen = filesize? calc_packet_length( &pkt ) : 0;
+    cfx.datalen = filesize && !opt.compress ? calc_packet_length( &pkt ) : 0;
 
     /* register the cipher filter */
     if( mode )
 	iobuf_push_filter( out, cipher_filter, &cfx );
+    /* register the compress filter */
+    if( opt.compress )
+	iobuf_push_filter( out, compress_filter, &zfx );
 
     /* do the work */
     if( (rc = build_packet( out, &pkt )) )
@@ -211,13 +211,10 @@
 
     if( opt.armor )
 	iobuf_push_filter( out, armor_filter, &afx );
-
-    write_comment( out, "#created by GNUPG v" VERSION " ("
+    else
+	write_comment( out, "#created by GNUPG v" VERSION " ("
 					    PRINTABLE_OS_NAME ")");
 
-    if( opt.compress )
-	iobuf_push_filter( out, compress_filter, &zfx );
-
     /* create a session key */
     cfx.dek = m_alloc_secure( sizeof *cfx.dek );
     cfx.dek->algo = opt.def_cipher_algo;
@@ -249,10 +246,13 @@
     init_packet(&pkt);
     pkt.pkttype = PKT_PLAINTEXT;
     pkt.pkt.plaintext = pt;
-    cfx.datalen = filesize? calc_packet_length( &pkt ) : 0;
+    cfx.datalen = filesize && !opt.compress? calc_packet_length( &pkt ) : 0;
 
     /* register the cipher filter */
     iobuf_push_filter( out, cipher_filter, &cfx );
+    /* register the compress filter */
+    if( opt.compress )
+	iobuf_push_filter( out, compress_filter, &zfx );
 
     /* do the work */
     if( (rc = build_packet( out, &pkt )) )
diff -urN gnupg-0.2.18/g10/export.c gnupg-0.2.19/g10/export.c
--- gnupg-0.2.18/g10/export.c	Fri May 15 15:38:07 1998
+++ gnupg-0.2.19/g10/export.c	Wed May 27 07:54:13 1998
@@ -67,7 +67,7 @@
 	afx.what = 1;
 	iobuf_push_filter( out, armor_filter, &afx );
     }
-    if( opt.compress )
+    if( opt.compress_keys && opt.compress )
 	iobuf_push_filter( out, compress_filter, &zfx );
 
     if( all ) {
diff -urN gnupg-0.2.18/g10/g10.c gnupg-0.2.19/g10/g10.c
--- gnupg-0.2.18/g10/g10.c	Fri May 15 18:12:29 1998
+++ gnupg-0.2.19/g10/g10.c	Fri May 29 10:15:27 1998
@@ -64,6 +64,7 @@
     { 552, "list-sigs", 0, N_("list keys and signatures")},
     { 508, "check-sigs",0, N_("check key signatures")},
     { 515, "fingerprint", 0, N_("list keys and fingerprints")},
+    { 558, "list-secret-keys", 0, N_("list secret keys")},
   #ifdef IS_G10
     { 503, "gen-key",   0, N_("generate a new key pair")},
     { 554, "add-key",   0, N_("add a subkey to a key pair")},
@@ -87,8 +88,8 @@
 
     { 301, NULL, 0, N_("@\nOptions:\n ") },
 
-  #ifdef IS_G10
     { 'a', "armor",     0, N_("create ascii armored output")},
+  #ifdef IS_G10
     { 'u', "local-user",2, N_("use this user-id to sign or decrypt")},
     { 'r', "remote-user", 2, N_("use this user-id for encryption")},
     { 'z', NULL,        1, N_("|N|set compress level N (0 disables)") },
@@ -159,6 +160,8 @@
     { 552, "list-sig", 0, "@" }, /* alias */
     { 508, "check-sig",0, "@" }, /* alias */
     { 553, "skip-verify",0, "@" },
+    { 557, "compress-keys",0, "@"},
+    { 559, "always-trust", 0, "@"},
 
 {0} };
 
@@ -169,7 +172,7 @@
     aSym, aStore, aEncr, aKeygen, aSign, aSignEncr,
     aSignKey, aClearsign, aListPackets, aEditSig, aDeleteKey, aDeleteSecretKey,
     aKMode, aKModeC, aChangePass, aImport, aVerify, aDecrypt, aListKeys,
-    aListSigs, aKeyadd,
+    aListSigs, aKeyadd, aListSecretKeys,
     aExport, aCheckKeys, aGenRevoke, aPrimegen, aPrintMD, aPrintMDs,
     aListTrustDB, aListTrustPath, aDeArmor, aEnArmor, aGenRandom, aTest,
 aNOP };
@@ -201,7 +204,7 @@
       case 13: p = VERSION; break;
       case 17: p = PRINTABLE_OS_NAME; break;
       case 19: p =
-	    _("Please report bugs to <gnupg-bugs@isil.d.shuttle.de>.\n");
+	    _("Please report bugs to <gnupg-bugs@gnu.org>.\n");
 	break;
       case 1:
       case 40:	p =
@@ -364,7 +367,7 @@
 
 
 
-void
+int
 main( int argc, char **argv )
 {
     ARGPARSE_ARGS pargs;
@@ -474,8 +477,8 @@
 						&pargs, opts) ) {
 	switch( pargs.r_opt ) {
 
-	#ifdef IS_G10
 	  case 'a': opt.armor = 1; opt.no_armor=0; break;
+	#ifdef IS_G10
 	  case 'b': detached_sig = 1; set_cmd( &cmd, aSign ); break;
 	  case 'c': set_cmd( &cmd, aSym); break;
 	  case 'd': set_cmd( &cmd, aDecrypt); break;
@@ -580,6 +583,9 @@
 	  case 553: opt.skip_verify=1; break;
 	  case 554: set_cmd( &cmd, aKeyadd); break;
 	  case 556: opt.def_compress_algo = pargs.r.ret_int; break;
+	  case 557: opt.compress_keys = 1; break;
+	  case 558: set_cmd( &cmd, aListSecretKeys); break;
+	  case 559: opt.always_trust = 1; break;
 	  default : errors++; pargs.err = configfp? 1:2; break;
 	}
     }
@@ -668,7 +674,10 @@
 	break;
       case aKMode:
       case aListKeys:
+      case aListSecretKeys:
       case aCheckKeys:
+	if( opt.with_colons ) /* need this to list the trust */
+	    rc = init_trustdb(1, trustdb_name );
 	break;
       case aListTrustDB: rc = init_trustdb( argc? 1:0, trustdb_name ); break;
       default: rc = init_trustdb(1, trustdb_name ); break;
@@ -796,12 +805,15 @@
       case aListSigs:
 	opt.list_sigs = 1;
       case aListKeys:
-	std_key_list( argc, argv );
+	public_key_list( argc, argv );
+	break;
+      case aListSecretKeys:
+	secret_key_list( argc, argv );
 	break;
 
       case aKMode: /* list keyring */
 	if( argc < 2 )	/* -kv [userid] */
-	    std_key_list( (argc && **argv)? 1:0, argv );
+	    public_key_list( (argc && **argv)? 1:0, argv );
 	else if( argc == 2 ) { /* -kv userid keyring */
 	    if( access( argv[1], R_OK ) ) {
 		log_error(_("can't open %s: %s\n"),
@@ -811,7 +823,7 @@
 		/* add keyring (default keyrings are not registered in this
 		 * special case */
 		add_keyring( argv[1] );
-		std_key_list( **argv?1:0, argv );
+		public_key_list( **argv?1:0, argv );
 	    }
 	}
 	else
@@ -1005,6 +1017,7 @@
     FREE_STRLIST(remusr);
     FREE_STRLIST(locusr);
     g10_exit(0);
+    return 8; /*NEVER REACHED*/
 }
 
 
diff -urN gnupg-0.2.18/g10/getkey.c gnupg-0.2.19/g10/getkey.c
--- gnupg-0.2.18/g10/getkey.c	Fri May 15 15:38:07 1998
+++ gnupg-0.2.19/g10/getkey.c	Wed May 27 13:41:10 1998
@@ -123,6 +123,16 @@
     return sl? sl->d : NULL;
 }
 
+const char *
+get_secret_keyring( int sequence )
+{
+    STRLIST sl;
+
+    for(sl = secret_keyrings; sl && sequence; sl = sl->next, sequence-- )
+	;
+    return sl? sl->d : NULL;
+}
+
 
 void
 add_secret_keyring( const char *name )
diff -urN gnupg-0.2.18/g10/gpgd.c gnupg-0.2.19/g10/gpgd.c
--- gnupg-0.2.18/g10/gpgd.c	Fri May 15 15:38:07 1998
+++ gnupg-0.2.19/g10/gpgd.c	Wed May 20 17:10:18 1998
@@ -58,7 +58,7 @@
       case 13: p = VERSION; break;
       case 17: p = PRINTABLE_OS_NAME; break;
       case 19: p =
-	    "Please report bugs to <gnupg-bugs@isil.d.shuttle.de>.\n";
+	    "Please report bugs to <gnupg-bugs@gnu.org>.\n";
 	break;
       case 1:
       case 40:	p = "Usage: gpgd [options] (-h for help)";
@@ -135,7 +135,7 @@
 }
 
 
-void
+int
 main( int argc, char **argv )
 {
     ARGPARSE_ARGS pargs;
@@ -236,9 +236,8 @@
 	become_daemon();
 
 
-
-
     g10_exit(0);
+    return 8; /*NEVER REACHED*/
 }
 
 
diff -urN gnupg-0.2.18/g10/import.c gnupg-0.2.19/g10/import.c
--- gnupg-0.2.18/g10/import.c	Fri May 15 15:38:07 1998
+++ gnupg-0.2.19/g10/import.c	Sat May 16 16:12:05 1998
@@ -43,7 +43,8 @@
 			  PKT_public_cert *pkc, u32 *keyid );
 static int delete_inv_parts( const char *fname, KBNODE keyblock, u32 *keyid );
 static int merge_blocks( const char *fname, KBNODE keyblock_orig,
-		       KBNODE keyblock, u32 *keyid, int *n_uids, int *n_sigs );
+			 KBNODE keyblock, u32 *keyid,
+			 int *n_uids, int *n_sigs, int *n_subk );
 static int append_uid( KBNODE keyblock, KBNODE node, int *n_sigs,
 			     const char *fname, u32 *keyid );
 static int merge_sigs( KBNODE dst, KBNODE src, int *n_sigs,
@@ -103,7 +104,7 @@
 	return G10ERR_OPEN_FILE;
     }
 
-    if( !opt.no_armor ) /* armored reading is not diabled */
+    if( !opt.no_armor ) /* armored reading is not disabled */
 	iobuf_push_filter( inp, armor_filter, &afx );
 
     while( !(rc = read_block( inp, &cfx, &pending_pkt, &keyblock) )) {
@@ -305,7 +306,7 @@
 	log_info("%s: key %08lX imported\n", fname, (ulong)keyid[1]);
     }
     else { /* merge */
-	int n_uids, n_sigs;
+	int n_uids, n_sigs, n_subk;
 
 	/* Compare the original against the new key; just to be sure nothing
 	 * weird is going on */
@@ -335,12 +336,13 @@
 	/* and try to merge the block */
 	clear_kbnode_flags( keyblock_orig );
 	clear_kbnode_flags( keyblock );
-	n_uids = n_sigs = 0;
+	n_uids = n_sigs = n_subk = 0;
 	rc = merge_blocks( fname, keyblock_orig, keyblock,
-				keyid, &n_uids, &n_sigs );
+				keyid, &n_uids, &n_sigs, &n_subk );
 	if( rc )
 	    goto leave;
-	if( n_uids || n_sigs ) { /* keyblock_orig has been updated; write */
+	if( n_uids || n_sigs || n_subk ) {
+	    /* keyblock_orig has been updated; write */
 	    if( opt.verbose > 1 )
 		log_info("%s: writing to '%s'\n",
 				    fname, keyblock_resource_name(&kbpos) );
@@ -364,6 +366,12 @@
 	    else if( n_sigs )
 		log_info("%s: key %08lX, %d new signatures\n",
 					 fname, (ulong)keyid[1], n_sigs );
+	    if( n_subk == 1 )
+		log_info("%s: key %08lX, 1 new subkey\n",
+					 fname, (ulong)keyid[1]);
+	    else if( n_subk )
+		log_info("%s: key %08lX, %d new subkeys\n",
+					 fname, (ulong)keyid[1], n_subk );
 	}
 	else
 	    log_info("%s: key %08lX, not changed\n", fname, (ulong)keyid[1] );
@@ -593,7 +601,7 @@
  */
 static int
 merge_blocks( const char *fname, KBNODE keyblock_orig, KBNODE keyblock,
-				   u32 *keyid, int *n_uids, int *n_sigs )
+	      u32 *keyid, int *n_uids, int *n_sigs, int *n_subk )
 {
     KBNODE onode, node;
     int rc, found;
@@ -666,6 +674,9 @@
 	    }
 	}
     }
+
+    /* 4th: add new subkeys */
+    /* FIXME */
 
     return 0;
 }
diff -urN gnupg-0.2.18/g10/keydb.h gnupg-0.2.19/g10/keydb.h
--- gnupg-0.2.18/g10/keydb.h	Mon May  4 13:54:56 1998
+++ gnupg-0.2.19/g10/keydb.h	Wed May 27 14:16:51 1998
@@ -98,10 +98,13 @@
 void set_passphrase_fd( int fd );
 int  get_passphrase_fd(void);
 DEK *passphrase_to_dek( u32 *keyid, int cipher_algo, STRING2KEY *s2k, int mode);
+void set_next_passphrase( const char *s );
+char *get_last_passphrase(void);
 
 /*-- getkey.c --*/
 void add_keyring( const char *name );
 const char *get_keyring( int sequence );
+const char *get_secret_keyring( int sequence );
 void add_secret_keyring( const char *name );
 int get_pubkey( PKT_public_cert *pkc, u32 *keyid );
 int get_pubkey_byname( PKT_public_cert *pkc, const char *name );
diff -urN gnupg-0.2.18/g10/keyedit.c gnupg-0.2.19/g10/keyedit.c
--- gnupg-0.2.18/g10/keyedit.c	Fri May 15 17:10:16 1998
+++ gnupg-0.2.19/g10/keyedit.c	Tue May 26 14:37:19 1998
@@ -169,10 +169,6 @@
 	    && (node->pkt->pkt.signature->sig_class&~3) == 0x10 ) {
 	    PKT_signature *sig = node->pkt->pkt.signature;
 
-	    if( keyid[0] == sig->keyid[0] && keyid[1] == sig->keyid[1] ) {
-		/* fixme: skip self-sig */
-	    }
-
 	    tty_printf("\n \"%08lX %s   ",
 			sig->keyid[1], datestr_from_sig(sig));
 	    if( node->flag & 6 )
@@ -349,6 +345,7 @@
 
 		    rc = make_keysig_packet( &sig, pkc,
 						   node->pkt->pkt.user_id,
+						   NULL,
 						   skc_rover->skc,
 						   0x10, 0 );
 		    if( rc ) {
@@ -568,9 +565,10 @@
     KBNODE node;
     KBPOS kbpos;
     PKT_secret_cert *skc;
-    u32 skc_keyid[2];
+    u32 keyid[2];
     char *answer;
     int changed=0;
+    char *passphrase = NULL;
 
     /* find the userid */
     rc = find_secret_keyblock_byname( &kbpos, username );
@@ -595,18 +593,28 @@
     }
 
     skc = node->pkt->pkt.secret_cert;
-    keyid_from_skc( skc, skc_keyid );
+    keyid_from_skc( skc, keyid );
     tty_printf("sec  %4u%c/%08lX %s   ",
 	      nbits_from_skc( skc ),
 	      pubkey_letter( skc->pubkey_algo ),
-	      skc_keyid[1], datestr_from_skc(skc) );
+	      keyid[1], datestr_from_skc(skc) );
     {
 	size_t n;
-	char *p = get_user_id( skc_keyid, &n );
+	char *p = get_user_id( keyid, &n );
 	tty_print_string( p, n );
 	m_free(p);
 	tty_printf("\n");
     }
+    for(node=keyblock; node; node = node->next ) {
+	if( node->pkt->pkttype == PKT_SECKEY_SUBCERT ) {
+	    PKT_secret_cert *subskc = node->pkt->pkt.secret_cert;
+	    keyid_from_skc( subskc, keyid );
+	    tty_printf("sub  %4u%c/%08lX %s\n",
+		      nbits_from_skc( subskc ),
+		      pubkey_letter( subskc->pubkey_algo ),
+		      keyid[1], datestr_from_skc(subskc) );
+	}
+    }
 
     clear_kbnode_flags( keyblock );
     switch( is_secret_key_protected( skc ) ) {
@@ -619,10 +627,21 @@
       default:
 	tty_printf("Key is protected.\n");
 	rc = check_secret_key( skc );
+	if( !rc )
+	    passphrase = get_last_passphrase();
 	break;
     }
 
-    /* fixme: unprotect all subkeys */
+    /* unprotect all subkeys (use the supplied passphrase or ask)*/
+    for(node=keyblock; node; node = node->next ) {
+	if( node->pkt->pkttype == PKT_SECKEY_SUBCERT ) {
+	    PKT_secret_cert *subskc = node->pkt->pkt.secret_cert;
+	    set_next_passphrase( passphrase );
+	    rc = check_secret_key( subskc );
+	    if( rc )
+		break;
+	}
+    }
 
     if( rc )
 	tty_printf("Can't edit this key: %s\n", g10_errstr(rc));
@@ -632,6 +651,7 @@
 
 	tty_printf(_("Enter the new passphrase for this secret key.\n\n") );
 
+	set_next_passphrase( NULL );
 	for(;;) {
 	    s2k->mode = 1;
 	    s2k->hash_algo = DIGEST_ALGO_RMD160;
@@ -651,10 +671,17 @@
 		break;
 	    }
 	    else { /* okay */
-		/* fixme: protect all subkeys too */
 		skc->protect.algo = dek->algo;
 		skc->protect.s2k = *s2k;
 		rc = protect_secret_key( skc, dek );
+		for(node=keyblock; !rc && node; node = node->next ) {
+		    if( node->pkt->pkttype == PKT_SECKEY_SUBCERT ) {
+			PKT_secret_cert *subskc = node->pkt->pkt.secret_cert;
+			subskc->protect.algo = dek->algo;
+			subskc->protect.s2k = *s2k;
+			rc = protect_secret_key( subskc, dek );
+		    }
+		}
 		if( rc )
 		    log_error("protect_secret_key failed: %s\n", g10_errstr(rc) );
 		else
@@ -676,7 +703,9 @@
     }
 
   leave:
+    m_free( passphrase );
     release_kbnode( keyblock );
+    set_next_passphrase( NULL );
     return rc;
 }
 
@@ -689,14 +718,16 @@
  */
 int
 make_keysig_packet( PKT_signature **ret_sig, PKT_public_cert *pkc,
-		    PKT_user_id *uid, PKT_secret_cert *skc,
+		    PKT_user_id *uid, PKT_public_cert *subpkc,
+		    PKT_secret_cert *skc,
 		    int sigclass, int digest_algo )
 {
     PKT_signature *sig;
     int rc=0;
     MD_HANDLE md;
 
-    assert( (sigclass >= 0x10 && sigclass <= 0x13) || sigclass == 0x20 );
+    assert( (sigclass >= 0x10 && sigclass <= 0x13)
+	    || sigclass == 0x20 || sigclass == 0x18 );
     if( !digest_algo ) {
 	switch( skc->pubkey_algo ) {
 	  case PUBKEY_ALGO_DSA: digest_algo = DIGEST_ALGO_SHA1; break;
@@ -706,11 +737,13 @@
 	}
     }
     md = md_open( digest_algo, 0 );
-    /*md_start_debug( md, "make" );*/
 
     /* hash the public key certificate and the user id */
     hash_public_cert( md, pkc );
-    if( sigclass != 0x20 ) {
+    if( sigclass == 0x18 ) { /* subkey binding */
+	hash_public_cert( md, subpkc );
+    }
+    else if( sigclass != 0x20 ) {
 	if( skc->version >=4 ) {
 	    byte buf[5];
 	    buf[0] = 0xb4;	      /* indicates a userid packet */
@@ -759,7 +792,7 @@
 	/* add some magic */
 	buf[0] = sig->version;
 	buf[1] = 0xff;
-	buf[2] = n >> 24; /* hmmm, n is only 16 bit, so tthis is always 0 */
+	buf[2] = n >> 24; /* hmmm, n is only 16 bit, so this is always 0 */
 	buf[3] = n >> 16;
 	buf[4] = n >>  8;
 	buf[5] = n;
diff -urN gnupg-0.2.18/g10/keygen.c gnupg-0.2.19/g10/keygen.c
--- gnupg-0.2.18/g10/keygen.c	Fri May 15 15:38:07 1998
+++ gnupg-0.2.19/g10/keygen.c	Tue May 26 15:20:31 1998
@@ -79,7 +79,47 @@
     pkc = node->pkt->pkt.public_cert;
 
     /* and make the signature */
-    rc = make_keysig_packet( &sig, pkc, uid, skc, 0x13, 0 );
+    rc = make_keysig_packet( &sig, pkc, uid, NULL, skc, 0x13, 0 );
+    if( rc ) {
+	log_error("make_keysig_packet failed: %s\n", g10_errstr(rc) );
+	return rc;
+    }
+
+    pkt = m_alloc_clear( sizeof *pkt );
+    pkt->pkttype = PKT_SIGNATURE;
+    pkt->pkt.signature = sig;
+    add_kbnode( root, new_kbnode( pkt ) );
+    return rc;
+}
+
+static int
+write_keybinding( KBNODE root, KBNODE pub_root, PKT_secret_cert *skc )
+{
+    PACKET *pkt;
+    PKT_signature *sig;
+    int rc=0;
+    KBNODE node;
+    PKT_public_cert *pkc, *subpkc;
+
+    if( opt.verbose )
+	log_info(_("writing key binding signature\n"));
+
+    /* get the pkc packet from the pub_tree */
+    node = find_kbnode( pub_root, PKT_PUBLIC_CERT );
+    if( !node )
+	BUG();
+    pkc = node->pkt->pkt.public_cert;
+    /* find the last subkey */
+    subpkc = NULL;
+    for(node=pub_root; node; node = node->next ) {
+	if( node->pkt->pkttype == PKT_PUBKEY_SUBCERT )
+	    subpkc = node->pkt->pkt.public_cert;
+    }
+    if( !subpkc )
+	BUG();
+
+    /* and make the signature */
+    rc = make_keysig_packet( &sig, pkc, NULL, subpkc, skc, 0x18, 0 );
     if( rc ) {
 	log_error("make_keysig_packet failed: %s\n", g10_errstr(rc) );
 	return rc;
@@ -95,7 +135,8 @@
 
 static int
 gen_elg(unsigned nbits, KBNODE pub_root, KBNODE sec_root, DEK *dek,
-	STRING2KEY *s2k, PKT_secret_cert **ret_skc, u16 valid_days )
+	STRING2KEY *s2k, PKT_secret_cert **ret_skc, u16 valid_days,
+							int version )
 {
     int rc;
     int i;
@@ -111,6 +152,7 @@
     skc = m_alloc_clear( sizeof *skc );
     pkc = m_alloc_clear( sizeof *pkc );
     skc->timestamp = pkc->timestamp = make_timestamp();
+    skc->version = pkc->version = version;
     skc->valid_days = pkc->valid_days = valid_days;
     skc->pubkey_algo = pkc->pubkey_algo = PUBKEY_ALGO_ELGAMAL;
 		       pkc->d.elg.p = pk.p;
@@ -124,8 +166,8 @@
     skc->protect.algo = 0;
 
     skc->csum = checksum_mpi( skc->d.elg.x );
-    /* return an unprotected version of the skc */
-    *ret_skc = copy_secret_cert( NULL, skc );
+    if( ret_skc ) /* not a subkey: return an unprotected version of the skc */
+	*ret_skc = copy_secret_cert( NULL, skc );
 
     if( dek ) {
 	skc->protect.algo = dek->algo;
@@ -140,14 +182,14 @@
     }
 
     pkt = m_alloc_clear(sizeof *pkt);
-    pkt->pkttype = PKT_PUBLIC_CERT;
+    pkt->pkttype = ret_skc ? PKT_PUBLIC_CERT : PKT_PUBKEY_SUBCERT;
     pkt->pkt.public_cert = pkc;
     add_kbnode(pub_root, new_kbnode( pkt ));
 
     /* don't know whether it makes sense to have the factors, so for now
      * we store them in the secret keyring (but they are not secret) */
     pkt = m_alloc_clear(sizeof *pkt);
-    pkt->pkttype = PKT_SECRET_CERT;
+    pkt->pkttype = ret_skc ? PKT_SECRET_CERT : PKT_SECKEY_SUBCERT;
     pkt->pkt.secret_cert = skc;
     add_kbnode(sec_root, new_kbnode( pkt ));
     for(i=0; factors[i]; i++ )
@@ -192,8 +234,8 @@
     skc->d.rsa.csum += checksum_mpi( skc->d.rsa.rsa_q );
     skc->d.rsa.csum += checksum_mpi( skc->d.rsa.rsa_u );
 
-    /* return an unprotected version of the skc */
-    *ret_skc = copy_secret_cert( NULL, skc );
+    if( ret_skc ) /* not a subkey: return an unprotected version of the skc */
+	*ret_skc = copy_secret_cert( NULL, skc );
 
     if( dek ) {
 	skc->d.rsa.is_protected = 1;
@@ -210,12 +252,12 @@
     }
 
     pkt = m_alloc_clear(sizeof *pkt);
-    pkt->pkttype = PKT_PUBLIC_CERT;
+    pkt->pkttype = ret_skc ? PKT_PUBLIC_CERT : PKT_PUBKEY_SUBCERT;
     pkt->pkt.public_cert = pkc;
     add_kbnode(pub_root, new_kbnode( pkt ));
 
     pkt = m_alloc_clear(sizeof *pkt);
-    pkt->pkttype = PKT_SECRET_CERT;
+    pkt->pkttype = ret_skc ? PKT_SECRET_CERT : PKT_SECKEY_SUBCERT;
     pkt->pkt.secret_cert = skc;
     add_kbnode(sec_root, new_kbnode( pkt ));
 
@@ -267,8 +309,8 @@
     skc->protect.algo = 0;
 
     skc->csum = checksum_mpi( skc->d.dsa.x );
-    /* return an unprotected version of the skc */
-    *ret_skc = copy_secret_cert( NULL, skc );
+    if( ret_skc ) /* not a subkey: return an unprotected version of the skc */
+	 *ret_skc = copy_secret_cert( NULL, skc );
 
     if( dek ) {
 	skc->protect.algo = dek->algo;
@@ -283,7 +325,7 @@
     }
 
     pkt = m_alloc_clear(sizeof *pkt);
-    pkt->pkttype = PKT_PUBLIC_CERT;
+    pkt->pkttype = ret_skc ? PKT_PUBLIC_CERT : PKT_PUBKEY_SUBCERT;
     pkt->pkt.public_cert = pkc;
     add_kbnode(pub_root, new_kbnode( pkt ));
 
@@ -294,7 +336,7 @@
      * are known.
      */
     pkt = m_alloc_clear(sizeof *pkt);
-    pkt->pkttype = PKT_SECRET_CERT;
+    pkt->pkttype = ret_skc ? PKT_SECRET_CERT : PKT_SECKEY_SUBCERT;
     pkt->pkt.secret_cert = skc;
     add_kbnode(sec_root, new_kbnode( pkt ));
     for(i=1; factors[i]; i++ )	/* the first one is q */
@@ -334,74 +376,63 @@
 }
 
 
-/****************
- * Generate a keypair
- */
-void
-generate_keypair()
+static int
+ask_algo( int *ret_v4 )
 {
     char *answer;
-    unsigned nbits;
-    char *pub_fname = NULL;
-    char *sec_fname = NULL;
-    char *uid = NULL;
-    KBNODE pub_root = NULL;
-    KBNODE sec_root = NULL;
-    PKT_secret_cert *skc = NULL;
-    DEK *dek = NULL;
-    STRING2KEY *s2k;
-    int rc;
     int algo;
-    const char *algo_name;
-    char *aname, *acomment, *amail;
-    int valid_days=0;
-
-    if( opt.batch || opt.answer_yes || opt.answer_no ) {
-	log_error(_("Key generation can only be used in interactive mode\n"));
-	return;
-    }
 
     tty_printf(_("Please select the algorithm to use:\n"
 		 "   (1) ElGamal is the suggested one.\n"
-		 "   (2) DSA can only be used for signatures.\n"));
+		 "   (2) ElGamal using v4 packets (OpenPGP)\n"
+		 "   (3) DSA can only be used for signatures.\n"));
   #ifdef ENABLE_RSA_KEYGEN
-    tty_printf(_("   (3) RSA cannot be used in the U.S.\n"));
+    tty_printf(_("   (4) RSA cannot be used in the U.S.\n"));
   #endif
 
+    *ret_v4 = 0;
     for(;;) {
       #ifdef ENABLE_RSA_KEYGEN
-	answer = tty_get(_("Your selection? (1,2,3) "));
+	answer = tty_get(_("Your selection? (1,2,3,4) "));
       #else
-	answer = tty_get(_("Your selection? (1,2) "));
+	answer = tty_get(_("Your selection? (1,2,3) "));
       #endif
 	tty_kill_prompt();
 	algo = *answer? atoi(answer): 1;
 	m_free(answer);
-	if( algo == 1 ) {
+	if( algo == 1 || algo == 2 ) {
+	    if( algo == 2 )
+		*ret_v4 = 1;
 	    algo = PUBKEY_ALGO_ELGAMAL;
-	    algo_name = "ElGamal";
 	    break;
 	}
-	else if( algo == 2 ) {
+	else if( algo == 3 ) {
+	    *ret_v4 = 1;
 	    algo = PUBKEY_ALGO_DSA;
-	    algo_name = "DSA";
 	    break;
 	}
       #ifdef ENABLE_RSA_KEYGEN
-	else if( algo == 3 ) {
+	else if( algo == 4 ) {
 	    algo = PUBKEY_ALGO_RSA;
-	    algo_name = "RSA";
 	    break;
 	}
       #endif
     }
+    return algo;
+}
 
 
+static unsigned
+ask_keysize( int algo )
+{
+    char *answer;
+    unsigned nbits;
 
     tty_printf(_("About to generate a new %s keypair.\n"
 		 "              minimum keysize is  768 bits\n"
 		 "              default keysize is 1024 bits\n"
-		 "    highest suggested keysize is 2048 bits\n"), algo_name );
+		 "    highest suggested keysize is 2048 bits\n"),
+					pubkey_algo_to_string(algo) );
     for(;;) {
 	answer = tty_get(_("What keysize do you want? (1024) "));
 	tty_kill_prompt();
@@ -446,6 +477,15 @@
 	nbits = ((nbits + 31) / 32) * 32;
 	tty_printf(_("rounded up to %u bits\n"), nbits );
     }
+    return nbits;
+}
+
+
+static int
+ask_valid_days()
+{
+    char *answer;
+    int valid_days=0;
 
     tty_printf(_("Please specify how long the key should be valid.\n"
 		 "         0 = key does not expire\n"
@@ -491,15 +531,21 @@
 	    break;
     }
     m_free(answer);
+    return valid_days;
+}
 
 
+static char *
+ask_user_id()
+{
+    char *answer;
+    char *aname, *acomment, *amail, *uid;
 
     tty_printf( _("\n"
 "You need a User-ID to identify your key; the software constructs the user id\n"
 "from Real Name, Comment and Email Address in this form:\n"
 "    \"Heinrich Heine (Der Dichter) <heinrichh@duesseldorf.de>\"\n\n") );
-    uid = NULL;
-    aname=acomment=amail=NULL;
+    uid = aname = acomment = amail = NULL;
     for(;;) {
 	char *p;
 
@@ -600,7 +646,15 @@
 	    break;
 	m_free(uid); uid = NULL;
     }
+    return uid;
+}
+
 
+static DEK *
+ask_passphrase( STRING2KEY **ret_s2k )
+{
+    DEK *dek = NULL;
+    STRING2KEY *s2k;
 
     tty_printf(_("You need a Passphrase to protect your secret key.\n\n") );
 
@@ -624,23 +678,17 @@
 	else
 	    break; /* okay */
     }
+    *ret_s2k = s2k;
+    return dek;
+}
 
 
-    /* now check whether we are allowed to write to the keyrings */
-    pub_fname = make_filename(opt.homedir, "pubring.gpg", NULL );
-    sec_fname = make_filename(opt.homedir, "secring.gpg", NULL );
-    if( opt.verbose ) {
-	tty_printf(_("writing public certificate to '%s'\n"), pub_fname );
-	tty_printf(_("writing secret certificate to '%s'\n"), sec_fname );
-    }
-
-    /* we create the packets as a tree of kbnodes. Because the structure
-     * we create is known in advance we simply generate a linked list
-     * The first packet is a dummy comment packet which we flag
-     * as deleted.  The very first packet must always be a CERT packet.
-     */
-    pub_root = make_comment_node("#"); delete_kbnode(pub_root);
-    sec_root = make_comment_node("#"); delete_kbnode(sec_root);
+static int
+do_create( int algo, unsigned nbits, KBNODE pub_root, KBNODE sec_root,
+	   DEK *dek, STRING2KEY *s2k, PKT_secret_cert **skc, int valid_days,
+							     int v4_packet )
+{
+    int rc=0;
 
     tty_printf(_(
 "We need to generate a lot of random bytes. It is a good idea to perform\n"
@@ -649,13 +697,14 @@
 "number generator a better chance to gain enough entropy.\n") );
 
     if( algo == PUBKEY_ALGO_ELGAMAL )
-	rc = gen_elg(nbits, pub_root, sec_root, dek, s2k,  &skc, valid_days );
+	rc = gen_elg(nbits, pub_root, sec_root, dek, s2k,
+			   skc, valid_days, v4_packet? 4:3 );
   #ifdef ENABLE_RSA_KEYGEN
     else if( algo == PUBKEY_ALGO_RSA )
-	rc = gen_rsa(nbits, pub_root, sec_root, dek, s2k, &skc, valid_days  );
+	rc = gen_rsa(nbits, pub_root, sec_root, dek, s2k, skc, valid_days  );
   #endif
     else if( algo == PUBKEY_ALGO_DSA )
-	rc = gen_dsa(nbits, pub_root, sec_root, dek, s2k, &skc, valid_days);
+	rc = gen_dsa(nbits, pub_root, sec_root, dek, s2k, skc, valid_days);
     else
 	BUG();
     if( !rc ) {
@@ -666,6 +715,59 @@
 		make_comment_node("#created by GNUPG v" VERSION " ("
 					    PRINTABLE_OS_NAME ")"));
     }
+    return rc;
+}
+
+
+/****************
+ * Generate a keypair
+ */
+void
+generate_keypair()
+{
+    unsigned nbits;
+    char *pub_fname = NULL;
+    char *sec_fname = NULL;
+    char *uid = NULL;
+    KBNODE pub_root = NULL;
+    KBNODE sec_root = NULL;
+    PKT_secret_cert *skc = NULL;
+    DEK *dek;
+    STRING2KEY *s2k;
+    int rc;
+    int algo;
+    int ndays;
+    int v4;
+
+    if( opt.batch || opt.answer_yes || opt.answer_no ) {
+	log_error(_("Key generation can only be used in interactive mode\n"));
+	return;
+    }
+
+    algo = ask_algo( &v4 );
+    nbits = ask_keysize( algo );
+    ndays = ask_valid_days();
+    uid = ask_user_id();
+    dek = ask_passphrase( &s2k );
+
+
+    /* now check whether we are allowed to write to the keyrings */
+    pub_fname = make_filename(opt.homedir, "pubring.gpg", NULL );
+    sec_fname = make_filename(opt.homedir, "secring.gpg", NULL );
+    if( opt.verbose ) {
+	tty_printf(_("writing public certificate to '%s'\n"), pub_fname );
+	tty_printf(_("writing secret certificate to '%s'\n"), sec_fname );
+    }
+
+    /* we create the packets as a tree of kbnodes. Because the structure
+     * we create is known in advance we simply generate a linked list
+     * The first packet is a dummy comment packet which we flag
+     * as deleted.  The very first packet must always be a CERT packet.
+     */
+    pub_root = make_comment_node("#"); delete_kbnode(pub_root);
+    sec_root = make_comment_node("#"); delete_kbnode(sec_root);
+
+    rc = do_create( algo, nbits, pub_root, sec_root, dek, s2k, &skc, ndays, v4);
     if( !rc )
 	write_uid(pub_root, uid );
     if( !rc )
@@ -718,6 +820,11 @@
 	    log_error("can't write secret key: %s\n", g10_errstr(rc) );
 	else {
 	    tty_printf(_("public and secret key created and signed.\n") );
+	    if( algo == PUBKEY_ALGO_DSA )
+		tty_printf(_("Note that this key cannot be used for "
+			     "encryption.  You may want to use\n"
+			     "the command \"--add-key\" to generate a "
+			     "secondary key for this purpose.\n") );
 	}
 
 	if( !rc1 )
@@ -745,8 +852,148 @@
  * add a new subkey to an existing key.
  */
 void
-generate_subkeypair( const char *userid )
+generate_subkeypair( const char *username )
 {
-    log_fatal("To be implemented :-)\n");
+    int rc=0;
+    KBPOS pub_kbpos, sec_kbpos;
+    KBNODE pub_keyblock = NULL;
+    KBNODE sec_keyblock = NULL;
+    KBNODE node;
+    PKT_secret_cert *skc = NULL; /* this is the primary skc */
+    u32 keyid[2];
+    int v4, algo, ndays;
+    unsigned nbits;
+    char *passphrase = NULL;
+    DEK *dek = NULL;
+    STRING2KEY *s2k = NULL;
+
+    if( opt.batch || opt.answer_yes || opt.answer_no ) {
+	log_error(_("Key generation can only be used in interactive mode\n"));
+	return;
+    }
+
+    /* search the userid */
+    rc = find_secret_keyblock_byname( &sec_kbpos, username );
+    if( rc ) {
+	log_error("user '%s' not found\n", username );
+	goto leave;
+    }
+    rc = read_keyblock( &sec_kbpos, &sec_keyblock );
+    if( rc ) {
+	log_error("error reading the secret key: %s\n", g10_errstr(rc) );
+	goto leave;
+    }
+    /* and the public key */
+    rc = find_keyblock_byname( &pub_kbpos, username );
+    if( rc ) {
+	log_error("user '%s' not found in public ring\n", username );
+	goto leave;
+    }
+    rc = read_keyblock( &pub_kbpos, &pub_keyblock );
+    if( rc ) {
+	log_error("error reading the public key: %s\n", g10_errstr(rc) );
+	goto leave;
+    }
+
+    /* break out the primary key */
+    node = find_kbnode( sec_keyblock, PKT_SECRET_CERT );
+    if( !node ) {
+	log_error("Oops; secret key not found anymore!\n");
+	rc = G10ERR_GENERAL;
+	goto leave;
+    }
+
+    /* make a copy of the skc to keep the protected one in the keyblock */
+    skc = copy_secret_cert( NULL, node->pkt->pkt.secret_cert );
+    keyid_from_skc( skc, keyid );
+    /* display primary and all secondary keys */
+    tty_printf("sec  %4u%c/%08lX %s   ",
+	      nbits_from_skc( skc ),
+	      pubkey_letter( skc->pubkey_algo ),
+	      keyid[1], datestr_from_skc(skc) );
+    {
+	size_t n;
+	char *p = get_user_id( keyid, &n );
+	tty_print_string( p, n );
+	m_free(p);
+	tty_printf("\n");
+    }
+    for(node=sec_keyblock; node; node = node->next ) {
+	if( node->pkt->pkttype == PKT_SECKEY_SUBCERT ) {
+	    PKT_secret_cert *subskc = node->pkt->pkt.secret_cert;
+	    keyid_from_skc( subskc, keyid );
+	    tty_printf("sub  %4u%c/%08lX %s\n",
+		      nbits_from_skc( subskc ),
+		      pubkey_letter( subskc->pubkey_algo ),
+		      keyid[1], datestr_from_skc(subskc) );
+	}
+    }
+    tty_printf("\n");
+
+
+
+    /* unprotect to get the passphrase */
+    switch( is_secret_key_protected( skc ) ) {
+      case -1:
+	rc = G10ERR_PUBKEY_ALGO;
+	break;
+      case 0:
+	tty_printf("This key is not protected.\n");
+	break;
+      default:
+	tty_printf("Key is protected.\n");
+	rc = check_secret_key( skc );
+	if( !rc )
+	    passphrase = get_last_passphrase();
+	break;
+    }
+    if( rc )
+	goto leave;
+
+
+    algo = ask_algo( &v4 );
+    nbits = ask_keysize( algo );
+    ndays = ask_valid_days();
+
+    if( passphrase ) {
+	s2k = m_alloc_secure( sizeof *s2k );
+	s2k->mode = 1;
+	s2k->hash_algo = DIGEST_ALGO_RMD160;
+	set_next_passphrase( passphrase );
+	dek = passphrase_to_dek( NULL, CIPHER_ALGO_BLOWFISH, s2k, 2 );
+    }
+
+    rc = do_create( algo, nbits, pub_keyblock, sec_keyblock,
+				      dek, s2k, NULL, ndays, v4 );
+    if( !rc )
+	rc = write_keybinding(pub_keyblock, pub_keyblock, skc);
+    if( !rc )
+	rc = write_keybinding(sec_keyblock, pub_keyblock, skc);
+    /* write back */
+    if( !rc ) {
+	rc = update_keyblock( &pub_kbpos, pub_keyblock );
+	if( rc )
+	    log_error("update_public_keyblock failed\n" );
+    }
+    if( !rc ) {
+	rc = update_keyblock( &sec_kbpos, sec_keyblock );
+	if( rc )
+	    log_error("update_secret_keyblock failed\n" );
+    }
+    if( !rc )
+	tty_printf(_("public and secret subkey created.\n") );
+
+
+  leave:
+    if( rc )
+	tty_printf(_("Key generation failed: %s\n"), g10_errstr(rc) );
+    m_free( passphrase );
+    m_free( dek );
+    m_free( s2k );
+    if( skc ) /* release the copy of the (now unprotected) secret key */
+	free_secret_cert(skc);
+    release_kbnode( sec_keyblock );
+    release_kbnode( pub_keyblock );
+    set_next_passphrase( NULL );
 }
 
diff -urN gnupg-0.2.18/g10/keylist.c gnupg-0.2.19/g10/keylist.c
--- gnupg-0.2.18/g10/keylist.c	Fri May 15 15:38:07 1998
+++ gnupg-0.2.19/g10/keylist.c	Fri May 29 10:31:59 1998
@@ -35,9 +35,9 @@
 #include "main.h"
 #include "i18n.h"
 
-static void list_all(void);
-static void list_one(const char *name);
-static void fingerprint( PKT_public_cert *pkc );
+static void list_all(int);
+static void list_one(const char *name, int secret);
+static void fingerprint( PKT_public_cert *pkc, PKT_secret_cert *skc );
 
 
 /****************
@@ -45,25 +45,36 @@
  * If NNAMES is 0; all available keys are listed
  */
 void
-std_key_list( int nnames, char **names )
+public_key_list( int nnames, char **names )
 {
     if( !nnames )
-	list_all();
+	list_all(0);
     else { /* List by user id */
 	for( ; nnames ; nnames--, names++ )
-	    list_one( *names );
+	    list_one( *names, 0 );
+    }
+}
+
+void
+secret_key_list( int nnames, char **names )
+{
+    if( !nnames )
+	list_all(1);
+    else { /* List by user id */
+	for( ; nnames ; nnames--, names++ )
+	    list_one( *names, 1 );
     }
 }
 
 
 static void
-list_all()
+list_all( int secret )
 {
     int i, seq=0;
     const char *s;
     IOBUF a;
 
-    while( (s=get_keyring(seq++)) ) {
+    while( (s=secret? get_secret_keyring(seq++):get_keyring(seq++)) ) {
 	if( !(a = iobuf_open(s)) ) {
 	    log_error(_("can't open %s: %s\n"), s, strerror(errno));
 	    continue;
@@ -80,9 +91,8 @@
     }
 }
 
-
 static void
-list_one( const char *name )
+list_one( const char *name, int secret )
 {
     int rc = 0;
     KBNODE keyblock = NULL;
@@ -90,11 +100,14 @@
     KBNODE node;
     KBPOS kbpos;
     PKT_public_cert *pkc;
+    PKT_secret_cert *skc;
     u32 keyid[2];
     int any=0;
+    int trustletter = 0;
 
     /* search the userid */
-    rc = find_keyblock_byname( &kbpos, name );
+    rc = secret? find_secret_keyblock_byname( &kbpos, name )
+	       : find_keyblock_byname( &kbpos, name );
     if( rc ) {
 	log_error("%s: user not found\n", name );
 	goto leave;
@@ -109,29 +122,55 @@
 
 
     /* get the keyid from the keyblock */
-    node = find_kbnode( keyblock, PKT_PUBLIC_CERT );
+    node = find_kbnode( keyblock, secret? PKT_SECRET_CERT : PKT_PUBLIC_CERT );
     if( !node ) {
-	log_error("Oops; public key lost!\n");
+	log_error("Oops; key lost!\n");
 	goto leave;
     }
 
-    pkc = node->pkt->pkt.public_cert;
-    keyid_from_pkc( pkc, keyid );
-    if( opt.with_colons )
-	printf("pub::%u:%d:%08lX%08lX:%s:%u:::",
-		/* fixme: add trust value here */
-		nbits_from_pkc( pkc ),
-		pkc->pubkey_algo,
-		(ulong)keyid[0],(ulong)keyid[1],
-		datestr_from_pkc( pkc ),
-		(unsigned)pkc->valid_days
-		/* fixme: add LID and ownertrust here */
-					);
-    else
-	printf("pub  %4u%c/%08lX %s ", nbits_from_pkc( pkc ),
-				   pubkey_letter( pkc->pubkey_algo ),
-				   (ulong)keyid[1],
-				   datestr_from_pkc( pkc ) );
+    if( secret ) {
+	pkc = NULL;
+	skc = node->pkt->pkt.secret_cert;
+	keyid_from_skc( skc, keyid );
+	if( opt.with_colons )
+	    printf("sec::%u:%d:%08lX%08lX:%s:%u:::",
+		    nbits_from_skc( skc ),
+		    skc->pubkey_algo,
+		    (ulong)keyid[0],(ulong)keyid[1],
+		    datestr_from_skc( skc ),
+		    (unsigned)skc->valid_days
+		    /* fixme: add LID here */ );
+	else
+	    printf("sec  %4u%c/%08lX %s ", nbits_from_skc( skc ),
+				       pubkey_letter( skc->pubkey_algo ),
+				       (ulong)keyid[1],
+				       datestr_from_skc( skc ) );
+    }
+    else {
+	pkc = node->pkt->pkt.public_cert;
+	skc = NULL;
+	keyid_from_pkc( pkc, keyid );
+	if( opt.with_colons ) {
+	    trustletter = query_trust_info( pkc );
+	    printf("pub:%c:%u:%d:%08lX%08lX:%s:%u:",
+		    trustletter,
+		    nbits_from_pkc( pkc ),
+		    pkc->pubkey_algo,
+		    (ulong)keyid[0],(ulong)keyid[1],
+		    datestr_from_pkc( pkc ),
+		    (unsigned)pkc->valid_days );
+	    if( pkc->local_id )
+		printf("%lu", pkc->local_id );
+	    putchar(':');
+	    /* fixme: add ownertrust here */
+	    putchar(':');
+	}
+	else
+	    printf("pub  %4u%c/%08lX %s ", nbits_from_pkc( pkc ),
+				       pubkey_letter( pkc->pubkey_algo ),
+				       (ulong)keyid[1],
+				       datestr_from_pkc( pkc ) );
+    }
 
     for( kbctx=NULL; (node=walk_kbnode( keyblock, &kbctx, 0)) ; ) {
 	if( node->pkt->pkttype == PKT_USER_ID ) {
@@ -148,7 +187,7 @@
 	    putchar('\n');
 	    if( !any ) {
 		if( opt.fingerprint )
-		    fingerprint( pkc );
+		    fingerprint( pkc, skc );
 		any = 1;
 	    }
 	}
@@ -159,14 +198,14 @@
 	    if( !any ) {
 		putchar('\n');
 		if( opt.fingerprint )
-		    fingerprint( pkc ); /* of the main key */
+		    fingerprint( pkc, skc ); /* of the main key */
 		any = 1;
 	    }
 
 	    keyid_from_pkc( pkc2, keyid2 );
-	    if( opt.with_colons )
-		printf("sub::%u:%d:%08lX%08lX:%s:%u:::\n",
-			/* fixme: add trust value here */
+	    if( opt.with_colons ) {
+		printf("sub:%c:%u:%d:%08lX%08lX:%s:%u:",
+			trustletter,
 			nbits_from_pkc( pkc2 ),
 			pkc2->pubkey_algo,
 			(ulong)keyid2[0],(ulong)keyid2[1],
@@ -174,12 +213,45 @@
 			(unsigned)pkc2->valid_days
 			/* fixme: add LID and ownertrust here */
 						);
+		if( pkc->local_id ) /* use the local_id of the main key??? */
+		    printf("%lu", pkc->local_id );
+		putchar(':');
+		putchar(':');
+		putchar('\n');
+	    }
 	    else
 		printf("sub  %4u%c/%08lX %s\n", nbits_from_pkc( pkc2 ),
 					   pubkey_letter( pkc2->pubkey_algo ),
 					   (ulong)keyid2[1],
 					   datestr_from_pkc( pkc2 ) );
 	}
+	else if( node->pkt->pkttype == PKT_SECKEY_SUBCERT ) {
+	    u32 keyid2[2];
+	    PKT_secret_cert *skc2 = node->pkt->pkt.secret_cert;
+
+	    if( !any ) {
+		putchar('\n');
+		if( opt.fingerprint )
+		    fingerprint( pkc, skc ); /* of the main key */
+		any = 1;
+	    }
+
+	    keyid_from_skc( skc2, keyid2 );
+	    if( opt.with_colons )
+		printf("ssb::%u:%d:%08lX%08lX:%s:%u:::\n",
+			nbits_from_skc( skc2 ),
+			skc2->pubkey_algo,
+			(ulong)keyid2[0],(ulong)keyid2[1],
+			datestr_from_skc( skc2 ),
+			(unsigned)skc2->valid_days
+			/* fixme: add LID */
+						);
+	    else
+		printf("ssb  %4u%c/%08lX %s\n", nbits_from_skc( skc2 ),
+					   pubkey_letter( skc2->pubkey_algo ),
+					   (ulong)keyid2[1],
+					   datestr_from_skc( skc2 ) );
+	}
 	else if( opt.list_sigs && node->pkt->pkttype == PKT_SIGNATURE ) {
 	    PKT_signature *sig = node->pkt->pkt.signature;
 	    int sigrc;
@@ -187,10 +259,12 @@
 	    if( !any ) { /* no user id, (maybe a revocation follows)*/
 		if( sig->sig_class == 0x20 )
 		    puts("[revoked]");
+		else if( sig->sig_class == 0x18 )
+		    puts("[key binding]");
 		else
 		    putchar('\n');
 		if( opt.fingerprint )
-		    fingerprint( pkc );
+		    fingerprint( pkc, skc );
 		any=1;
 	    }
 
@@ -259,12 +333,13 @@
 }
 
 static void
-fingerprint( PKT_public_cert *pkc )
+fingerprint( PKT_public_cert *pkc, PKT_secret_cert *skc )
 {
     byte *array, *p;
     size_t i, n;
 
-    p = array = fingerprint_from_pkc( pkc, &n );
+    p = array = pkc? fingerprint_from_pkc( pkc, &n )
+		   : fingerprint_from_skc( skc, &n );
     if( opt.with_colons ) {
 	printf("fpr:::::::::");
 	for(i=0; i < n ; i++, p++ )
diff -urN gnupg-0.2.18/g10/ks-proto.c gnupg-0.2.19/g10/ks-proto.c
--- gnupg-0.2.18/g10/ks-proto.c	Fri May 15 15:38:07 1998
+++ gnupg-0.2.19/g10/ks-proto.c	Tue May 19 18:11:29 1998
@@ -18,6 +18,32 @@
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
  */
 
+/****************
+ * The extended HKP protocol:
+ *
+ *  GET /pks/lookup[/<gnupg_user_id>][?[op=<cmd>][&armor=0][&search=<keywords>]]
+ *
+ * Default is: "armor=1", "op=get". "search" is only allowed if gnupg_user_id
+ * is not present.  GET maybe replaced by HEAD in which case only some status
+ * information is returned.
+ *
+ * Hmmm, I don't like it, the better solution is to use:
+ *
+ *  /pks/gnupg/get for binary lookups
+ *  /pks/gnupg/upd to update a key
+ *  /pks/gnupg/ins to insert a new key
+ *
+ * Optional a version string can be inserted as in:
+ *
+ *  /pks/gnupg/v1.0/get
+ *
+ * Returned HTTP options:
+ *  X-Key-Hash: <rmd160 hash value of the keyblock>
+ *  X-Key-MTime: <last modification time>
+ *  X-Key-LID: <local_key_id_used_for_update_etc>
+ * [fixme: is X-.... allowed?]
+ */
+
 #include <config.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -34,6 +60,226 @@
 {
     return -1;
 }
+
+
+
+
+/****************
+ * Send a HKP request
+ */
+int
+hkp_request( int operation, const char *user_id )
+{
+
+}
+
+
+
+
+
+/************************************************
+ ******* client communication stuff  ************
+ ************************************************/
+
+/****************
+ * Initialisieren des clients
+ * Es wird ein Handle zurckgegeben oder -1 bei einem fehler.
+ * z.Z. ist nut eine Verbindung gleichzeitig mglich.
+ * Wenn einer serverpid von 0 angegeben wird, so wird diese
+ * der environment  variabeln ATEXDB_PID entnommen.
+ */
+
+int
+hkp_open( const char *serverurl )
+{
+    const char *s;
+
+    s = SERVER_NAME_TEMPLATE;
+    client.serv_name = xmalloc(strlen(s) + 10 );
+    sprintf(client.serv_name,s, serverpid );
+    if( opt.verbose )
+	Info("Using unix domain stream '%s'", client.serv_name );
+
+    memset( &client.serv_addr, 0, sizeof client.serv_addr );
+    client.serv_addr.sun_family = AF_UNIX;
+    strcpy( client.serv_addr.sun_path, client.serv_name );
+    client.serv_addr_len = strlen(client.serv_addr.sun_path)
+			    + sizeof client.serv_addr.sun_family;
+
+    client.sockfd = -1;
+    if( DoCheckVersion() )
+	return -1;
+    return 0;
+}
+
+
+static int
+DoConnect()
+{
+    if( client.sockfd != -1 )
+	DoDisconnect();
+    if( (client.sockfd = socket(AF_UNIX, SOCK_STREAM, 0)) == -1 ) {
+	Error(1000,"can't open unix domain socket");
+	return 1;
+    }
+    if( connect(client.sockfd, (struct sockaddr*)&client.serv_addr,
+				client.serv_addr_len) == -1 ) {
+	Error(1000,"can't connect to '%s'",client.serv_addr.sun_path);
+	return 1;
+    }
+
+    return 0; /* okay */
+}
+
+static int
+DoDisconnect()
+{
+    if( client.sockfd != -1 ) {
+	close(client.sockfd);
+	client.sockfd = -1;
+    }
+    return 0; /* okay */
+}
+
+/****************
+ * NBYTES auf den aktuellen stream schreiben.
+ */
+static int
+DoWrite( void *buf, size_t nbytes )
+{
+    size_t nleft = nbytes;
+    ssize_t nwritten;
+
+    while( nleft > 0 ) {
+	/* FIXME: add EINTR handling */
+	nwritten = write(client.sockfd, buf, nleft);
+	if( nwritten < 0 ) {
+	    Error(1000,"error writing to server");
+	    return -1;
+	}
+	nleft -= nwritten;
+	buf = (char*)buf + nwritten;
+    }
+    return 0;
+}
+
+static int
+DoWriteStr( const char *s )
+{
+    return DoWrite((char *)s, strlen(s) );
+}
+
+
+static int
+DoRead( void *buf, size_t buflen, size_t *ret_nread, int stop)
+{
+    size_t nleft = buflen;
+    int nread;
+    char *p;
+
+    p = buf;
+    while( nleft > 0 ) {
+	/* FIXME: add EINTR handling */
+	nread = read(client.sockfd, buf, stop? 1 : nleft);
+	if( nread < 0 ) {
+	    Error(1000,"error reading from server");
+	    return -1;
+	}
+	else if( !nread )
+	    break; /* EOF */
+	nleft -= nread;
+	buf = (char*)buf + nread;
+	if( stop )
+	    for(; p < (char*)buf ; p++ )
+		if( *p == '\n' )
+		    goto leave;
+    }
+  leave:
+    if( ret_nread )
+	*ret_nread = buflen - nleft;
+    return 0;
+}
+
+/****************
+ * Like DoRead(), but append the received data to the given strgbuf.
+ * read a maximum of nbytes;
+ */
+static int
+DoReadIntoStrgbuf( strgbuf_t *strgbuf, size_t nbytes, size_t *ret_nread)
+{
+    size_t ntotal, nleft;
+    int nread;
+    byte *p, buffer[1000];
+
+    ntotal = 0;
+    nleft = nbytes;
+    while( nleft ) {
+	nread = read(client.sockfd, buffer,
+			    nleft > DIM(buffer)? DIM(buffer) : nleft);
+	if( nread < 0 ) {
+	    Error(1000,"error reading from server");
+	    return -1;
+	}
+	else if( !nread )
+	    break; /* EOF */
+	nleft -= nread;
+	ntotal += nread;
+	/* ab in den stringbuffer */
+	for(p=buffer; nread; nread--, p++ )
+	    PutStrgbuf(strgbuf, *p );
+    }
+
+    if( ret_nread )
+	*ret_nread = ntotal;
+    return 0;
+}
+
+
+/****************
+ * In retval wird das numerische argument nach OK zurckgegeben
+ */
+static int
+DoRequest( char *request, long *retval )
+{
+    if( DoWrite(request, strlen(request)) )
+	return -1;
+    return DoWaitReply( retval );
+}
+
+static int
+DoWaitReply( long *retval )
+{
+    char *p, buf[200]; /* enough room for messages */
+    size_t nread;
+
+    /* read but stop at the first newline */
+    if( DoRead(buf, DIM(buf)-2, &nread, 1 ) )
+	return -1;
+    buf[DIM(buf)-1] = 0;
+    /* fixme: should check, that we have the linefeed and otherwise
+     * perform a dummy read */
+    if( p = strchr(buf, '\n') )
+	*p = 0;
+    if( *buf == 'O' && buf[1] == 'K' && (buf[2]==' ' || !buf[2]) ) {
+	if( retval )
+	    *retval = buf[2]? strtol(buf+3, NULL, 10 ):0;
+	return 0;
+    }
+    Error(0, "Server replied: %.60s", buf );
+    return -1;
+}
+
+
+
+
+
+
+
+
+
+
+
+
 #endif
 
 
diff -urN gnupg-0.2.18/g10/main.h gnupg-0.2.19/g10/main.h
--- gnupg-0.2.18/g10/main.h	Fri May 15 17:44:17 1998
+++ gnupg-0.2.19/g10/main.h	Wed May 27 13:43:45 1998
@@ -117,7 +117,8 @@
 int gen_revoke( const char *uname );
 
 /*-- keylist.c --*/
-void std_key_list( int nnames, char **names );
+void public_key_list( int nnames, char **names );
+void secret_key_list( int nnames, char **names );
 
 /*-- verify.c --*/
 int verify_signatures( int nfiles, char **files );
diff -urN gnupg-0.2.18/g10/mainproc.c gnupg-0.2.19/g10/mainproc.c
--- gnupg-0.2.18/g10/mainproc.c	Fri May 15 17:12:47 1998
+++ gnupg-0.2.19/g10/mainproc.c	Fri May 29 11:14:49 1998
@@ -23,6 +23,7 @@
 #include <stdlib.h>
 #include <string.h>
 #include <assert.h>
+#include <time.h>
 
 #include "packet.h"
 #include "iobuf.h"
@@ -35,7 +36,8 @@
 #include "cipher.h"
 #include "main.h"
 #include "status.h"
-
+#include "i18n.h"
+#include "trustdb.h"
 
 /****************
  * Structure to hold the context
@@ -54,6 +56,8 @@
     KBNODE list;   /* the current list of packets */
     int have_data;
     IOBUF iobuf;    /* used to get the filename etc. */
+    int trustletter; /* temp usage in list_node */
+    ulong local_id;    /* ditto */
 } *CTX;
 
 
@@ -188,8 +192,9 @@
 	if( opt.verbose > 1 )
 	    log_info( "pubkey_enc packet: Good DEK\n" );
     }
-    else
-	log_error( "pubkey_enc packet: %s\n", g10_errstr(result));
+    else {
+	log_error(_("public key decryption failed: %s\n"), g10_errstr(result));
+    }
     free_packet(pkt);
 }
 
@@ -213,10 +218,10 @@
 	;
     else if( !result ) {
 	if( opt.verbose > 1 )
-	    log_info("encryption okay\n");
+	    log_info("decryption okay\n");
     }
     else {
-	log_error("encryption failed: %s\n", g10_errstr(result));
+	log_error(_("decryption failed: %s\n"), g10_errstr(result));
     }
     free_packet(pkt);
     c->last_was_session_key = 0;
@@ -238,7 +243,7 @@
      * textmode filter (sigclass 0x01)
      */
     c->mfx.md = md_open( DIGEST_ALGO_RMD160, 0);
-    md_start_debug(c->mfx.md, "proc_plaintext");
+    /*md_start_debug(c->mfx.md, "proc_plaintext");*/
     md_enable( c->mfx.md, DIGEST_ALGO_SHA1 );
     md_enable( c->mfx.md, DIGEST_ALGO_MD5 );
     md_enable( c->mfx.md, DIGEST_ALGO_TIGER );
@@ -289,13 +294,15 @@
  * Returns: 0 = valid signature or an error code
  */
 static int
-do_check_sig( CTX c, KBNODE node )
+do_check_sig( CTX c, KBNODE node, int *is_selfsig )
 {
     PKT_signature *sig;
     MD_HANDLE md;
     int algo, rc;
 
     assert( node->pkt->pkttype == PKT_SIGNATURE );
+    if( is_selfsig )
+	*is_selfsig = 0;
     sig = node->pkt->pkt.signature;
 
     algo = sig->digest_algo;
@@ -324,7 +331,7 @@
 	     || sig->sig_class == 0x30	) { /* classes 0x10..0x17,0x20,0x30 */
 	if( c->list->pkt->pkttype == PKT_PUBLIC_CERT
 	    || c->list->pkt->pkttype == PKT_PUBKEY_SUBCERT ) {
-	    return check_key_signature( c->list, node, NULL );
+	    return check_key_signature( c->list, node, is_selfsig );
 	}
 	else {
 	    log_error("invalid root packet for sigclass %02x\n",
@@ -411,16 +418,23 @@
 	if( opt.with_colons ) {
 	    u32 keyid[2];
 	    keyid_from_pkc( pkc, keyid );
-	    printf("%s::%u:%d:%08lX%08lX:%s:%u:::",
+	    if( mainkey ) {
+		c->local_id = pkc->local_id;
+		c->trustletter = query_trust_info( pkc );
+	    }
+	    printf("%s:%c:%u:%d:%08lX%08lX:%s:%u:",
 		    mainkey? "pub":"sub",
-		    /* fixme: add trust value here */
+		    c->trustletter,
 		    nbits_from_pkc( pkc ),
 		    pkc->pubkey_algo,
 		    (ulong)keyid[0],(ulong)keyid[1],
 		    datestr_from_pkc( pkc ),
-		    (unsigned)pkc->valid_days
-		    /* fixme: add LID and ownertrust here */
-					    );
+		    (unsigned)pkc->valid_days );
+	    if( c->local_id )
+		printf("%lu", c->local_id );
+	    putchar(':');
+	    /* fixme: add ownertrust here */
+	    putchar(':');
 	}
 	else
 	    printf("%s  %4u%c/%08lX %s ",
@@ -429,79 +443,112 @@
 				      pubkey_letter( pkc->pubkey_algo ),
 				      (ulong)keyid_from_pkc( pkc, NULL ),
 				      datestr_from_pkc( pkc )	  );
-	/* and now list all userids with their signatures */
-	for( node = node->next; node; node = node->next ) {
-	    if( any != 2 && node->pkt->pkttype == PKT_SIGNATURE ) {
-		if( !any ) {
-		    if( node->pkt->pkt.signature->sig_class == 0x20 )
-			puts("[revoked]");
-		    else
-			putchar('\n');
+	if( mainkey ) {
+	    /* and now list all userids with their signatures */
+	    for( node = node->next; node; node = node->next ) {
+		if( node->pkt->pkttype == PKT_SIGNATURE ) {
+		    if( !any ) {
+			if( node->pkt->pkt.signature->sig_class == 0x20 )
+			    puts("[revoked]");
+			else
+			    putchar('\n');
+			any = 1;
+		    }
+		    list_node(c,  node );
 		}
-		list_node(c,  node );
-		any = 1;
-	    }
-	    else if( node->pkt->pkttype == PKT_USER_ID ) {
-		KBNODE n;
-
-		if( any ) {
+		else if( node->pkt->pkttype == PKT_USER_ID ) {
+		    if( any ) {
+			if( opt.with_colons )
+			    printf("uid:::::::::");
+			else
+			    printf( "uid%*s", 28, "" );
+		    }
+		    print_userid( node->pkt );
 		    if( opt.with_colons )
-			printf("uid:::::::::");
-		    else
-			printf( "uid%*s", 28, "" );
-		}
-		print_userid( node->pkt );
-		if( opt.with_colons )
-		    putchar(':');
-		putchar('\n');
-		if( opt.fingerprint && !any )
-		    print_fingerprint( pkc, NULL );
-		for( n=node->next; n; n = n->next ) {
-		    if( n->pkt->pkttype == PKT_USER_ID )
-			break;
-		    if( n->pkt->pkttype == PKT_SIGNATURE )
-			list_node(c,  n );
-		}
-		any=2;
-	    }
-	    else if( mainkey && node->pkt->pkttype == PKT_PUBKEY_SUBCERT ) {
-		if( !any ) {
+			putchar(':');
 		    putchar('\n');
-		    any = 1;
+		    if( opt.fingerprint && !any )
+			print_fingerprint( pkc, NULL );
+		    any=1;
+		}
+		else if( node->pkt->pkttype == PKT_PUBKEY_SUBCERT ) {
+		    if( !any ) {
+			putchar('\n');
+			any = 1;
+		    }
+		    list_node(c,  node );
 		}
-		list_node(c,  node );
 	    }
 	}
-	if( any != 2 && mainkey )
-	    printf("ERROR: no user id!\n");
-	else if( any != 2 )
+	if( !any )
 	    putchar('\n');
     }
     else if( (mainkey = (node->pkt->pkttype == PKT_SECRET_CERT) )
 	     || node->pkt->pkttype == PKT_SECKEY_SUBCERT ) {
 	PKT_secret_cert *skc = node->pkt->pkt.secret_cert;
 
-	printf("%s  %4u%c/%08lX %s ",
+	if( opt.with_colons ) {
+	    u32 keyid[2];
+	    keyid_from_skc( skc, keyid );
+	    printf("%s::%u:%d:%08lX%08lX:%s:%u:::",
+		    mainkey? "sec":"ssb",
+		    nbits_from_skc( skc ),
+		    skc->pubkey_algo,
+		    (ulong)keyid[0],(ulong)keyid[1],
+		    datestr_from_skc( skc ),
+		    (unsigned)skc->valid_days
+		    /* fixme: add LID */ );
+	}
+	else
+	    printf("%s  %4u%c/%08lX %s ",
 				      mainkey? "sec":"ssb",
-				       nbits_from_skc( skc ),
+				      nbits_from_skc( skc ),
 				      pubkey_letter( skc->pubkey_algo ),
 				      (ulong)keyid_from_skc( skc, NULL ),
 				      datestr_from_skc( skc )	);
-	/* and now list all userids */
-	while( (node = find_next_kbnode(node, PKT_USER_ID)) ) {
-	    print_userid( node->pkt );
-	    putchar('\n');
-	    if( opt.fingerprint && !any )
-		print_fingerprint( NULL, skc );
-	    any=1;
-	}
-	if( !any && mainkey )
-	    printf("ERROR: no user id!\n");
-	else if( !any )
+	if( mainkey ) {
+	    /* and now list all userids with their signatures */
+	    for( node = node->next; node; node = node->next ) {
+		if( node->pkt->pkttype == PKT_SIGNATURE ) {
+		    if( !any ) {
+			if( node->pkt->pkt.signature->sig_class == 0x20 )
+			    puts("[revoked]");
+			else
+			    putchar('\n');
+			any = 1;
+		    }
+		    list_node(c,  node );
+		}
+		else if( node->pkt->pkttype == PKT_USER_ID ) {
+		    if( any ) {
+			if( opt.with_colons )
+			    printf("uid:::::::::");
+			else
+			    printf( "uid%*s", 28, "" );
+		    }
+		    print_userid( node->pkt );
+		    if( opt.with_colons )
+			putchar(':');
+		    putchar('\n');
+		    if( opt.fingerprint && !any )
+			print_fingerprint( NULL, skc );
+		    any=1;
+		}
+		else if( node->pkt->pkttype == PKT_SECKEY_SUBCERT ) {
+		    if( !any ) {
+			putchar('\n');
+			any = 1;
+		    }
+		    list_node(c,  node );
+		}
+	    }
+	}
+	if( !any )
 	    putchar('\n');
     }
     else if( node->pkt->pkttype == PKT_SIGNATURE  ) {
 	PKT_signature *sig = node->pkt->pkt.signature;
+	int is_selfsig = 0;
 	int rc2=0;
 	size_t n;
 	char *p;
@@ -516,13 +563,27 @@
 	    fputs("sig", stdout);
 	if( opt.check_sigs ) {
 	    fflush(stdout);
-	    switch( (rc2=do_check_sig( c, node )) ) {
+	    switch( (rc2=do_check_sig( c, node, &is_selfsig )) ) {
 	      case 0:		       sigrc = '!'; break;
 	      case G10ERR_BAD_SIGN:    sigrc = '-'; break;
 	      case G10ERR_NO_PUBKEY:   sigrc = '?'; break;
 	      default:		       sigrc = '%'; break;
 	    }
 	}
+	else {	/* check whether this is a self signature */
+	    u32 keyid[2];
+
+	    if( c->list->pkt->pkttype == PKT_PUBLIC_CERT
+		|| c->list->pkt->pkttype == PKT_SECRET_CERT ) {
+		if( c->list->pkt->pkttype == PKT_PUBLIC_CERT )
+		    keyid_from_pkc( c->list->pkt->pkt.public_cert, keyid );
+		else
+		    keyid_from_skc( c->list->pkt->pkt.secret_cert, keyid );
+
+		if( keyid[0] == sig->keyid[0] && keyid[1] == sig->keyid[1] )
+		    is_selfsig = 1;
+	    }
+	}
 	if( opt.with_colons ) {
 	    putchar(':');
 	    if( sigrc != ' ' )
@@ -537,6 +598,13 @@
 	    printf("[%s] ", g10_errstr(rc2) );
 	else if( sigrc == '?' )
 	    ;
+	else if( is_selfsig ) {
+	    if( opt.with_colons )
+		putchar(':');
+	    fputs( sig->sig_class == 0x18? "[keybind]":"[selfsig]", stdout);
+	    if( opt.with_colons )
+		putchar(':');
+	}
 	else {
 	    p = get_user_id( sig->keyid, &n );
 	    print_string( stdout, p, n, opt.with_colons );
@@ -711,6 +779,8 @@
 check_sig_and_print( CTX c, KBNODE node )
 {
     PKT_signature *sig = node->pkt->pkt.signature;
+    time_t stamp = sig->timestamp;
+    const char *astr, *tstr;
     int rc;
 
     if( opt.skip_verify ) {
@@ -718,28 +788,25 @@
 	return 0;
     }
 
-    rc = do_check_sig(c, node );
-    if( !rc || rc == G10ERR_BAD_SIGN ) {
-	char *p, *buf;
+    tstr = asctime(localtime (&stamp));
+    astr = pubkey_algo_to_string( sig->pubkey_algo );
+    log_info(_("Signature made %.*s using %s key ID %08lX\n"),
+		strlen(tstr)-1, tstr, astr? astr: "?", (ulong)sig->keyid[1] );
 
-	p = get_user_id_string( sig->keyid );
-	buf = m_alloc( 20 + strlen(p) );
-	sprintf(buf, "%lu %s", (ulong)sig->timestamp, p );
-	m_free(p);
-	if( (p=strchr(buf,'\n')) )
-	    *p = 0; /* just in case ... */
-	write_status_text( rc? STATUS_BADSIG : STATUS_GOODSIG, buf );
-	m_free(buf);
-	log_info("%s signature from ", rc? "BAD":"Good");
+    rc = do_check_sig(c, node, NULL );
+    if( !rc || rc == G10ERR_BAD_SIGN ) {
+	write_status( rc? STATUS_BADSIG : STATUS_GOODSIG );
+	log_info(rc? _("BAD signature from \"")
+		   : _("Good signature from \""));
 	print_keyid( stderr, sig->keyid );
+	putc('\"', stderr);
 	putc('\n', stderr);
 	if( opt.batch && rc )
 	    g10_exit(1);
     }
     else {
 	write_status( STATUS_ERRSIG );
-	log_error("Can't check signature made by %08lX: %s\n",
-		   (ulong)sig->keyid[1], g10_errstr(rc) );
+	log_error(_("Can't check signature: %s\n"), g10_errstr(rc) );
     }
     return rc;
 }
@@ -757,6 +824,8 @@
     if( opt.list_packets )
 	return;
 
+    c->local_id = 0;
+    c->trustletter = ' ';
     if( node->pkt->pkttype == PKT_PUBLIC_CERT
 	|| node->pkt->pkttype == PKT_PUBKEY_SUBCERT )
 	list_node( c, node );
diff -urN gnupg-0.2.18/g10/options.h gnupg-0.2.19/g10/options.h
--- gnupg-0.2.18/g10/options.h	Fri May 15 15:13:38 1998
+++ gnupg-0.2.19/g10/options.h	Wed May 27 19:22:34 1998
@@ -45,6 +45,8 @@
     int completes_needed;
     const char *homedir;
     int skip_verify;
+    int compress_keys;
+    int always_trust;
 } opt;
 
 
diff -urN gnupg-0.2.18/g10/packet.h gnupg-0.2.19/g10/packet.h
--- gnupg-0.2.18/g10/packet.h	Wed May 13 13:25:46 1998
+++ gnupg-0.2.19/g10/packet.h	Tue May 26 14:16:50 1998
@@ -308,7 +308,8 @@
 
 /*-- sign.c --*/
 int make_keysig_packet( PKT_signature **ret_sig, PKT_public_cert *pkc,
-			PKT_user_id *uid, PKT_secret_cert *skc,
+			PKT_user_id *uid, PKT_public_cert *subpkc,
+			PKT_secret_cert *skc,
 			int sigclass, int digest_algo );
 
 #endif /*G10_PACKET_H*/
diff -urN gnupg-0.2.18/g10/passphrase.c gnupg-0.2.19/g10/passphrase.c
--- gnupg-0.2.18/g10/passphrase.c	Fri May 15 18:05:23 1998
+++ gnupg-0.2.19/g10/passphrase.c	Thu May 28 16:53:27 1998
@@ -31,8 +31,11 @@
 #include "cipher.h"
 #include "keydb.h"
 #include "main.h"
+#include "i18n.h"
 
 static int pwfd = -1;
+static char *next_pw = NULL;
+static char *last_pw = NULL;
 
 static void hash_passphrase( DEK *dek, char *pw, STRING2KEY *s2k, int create );
 
@@ -48,6 +51,34 @@
     return pwfd;
 }
 
+/****************
+ * Set the passphrase to be used for the next query and only for the next
+ * one.
+ */
+void
+set_next_passphrase( const char *s )
+{
+    m_free(next_pw);
+    next_pw = NULL;
+    if( s ) {
+	next_pw = m_alloc_secure( strlen(s)+1 );
+	strcpy(next_pw, s );
+    }
+}
+
+/****************
+ * Get the last passphrase used in passphrase_to_dek.
+ * Note: This removes the passphrase from this modules and
+ * the caller must free the result.  May return NULL:
+ */
+char *
+get_last_passphrase()
+{
+    char *p = last_pw;
+    last_pw = NULL;
+    return p;
+}
+
 
 /****************
  * Get a passphrase for the secret key with KEYID, display TEXT
@@ -62,7 +93,7 @@
 DEK *
 passphrase_to_dek( u32 *keyid, int cipher_algo, STRING2KEY *s2k, int mode )
 {
-    char *pw;
+    char *pw = NULL;
     DEK *dek;
     STRING2KEY help_s2k;
 
@@ -77,17 +108,32 @@
 					    :DEFAULT_DIGEST_ALGO;
     }
 
-    if( keyid && !opt.batch ) {
-	char *ustr;
-	tty_printf("Need a pass phrase to unlock the secret key for:\n");
-	tty_printf("  \"" );
-	ustr = get_user_id_string( keyid );
-	tty_print_string( ustr, strlen(ustr) );
-	m_free(ustr);
-	tty_printf("\"\n\n");
-
+    if( keyid && !opt.batch && !next_pw ) {
+	PKT_public_cert *pkc = m_alloc_clear( sizeof *pkc );
+	size_t n;
+	char *p;
+
+	tty_printf(_("\nYou need a passphrase to unlock the secret key for\n"
+		     "user: \"") );
+	p = get_user_id( keyid, &n );
+	tty_print_string( p, n );
+	m_free(p);
+	tty_printf("\"\n");
+
+	if( !get_pubkey( pkc, keyid ) ) {
+	    const char *s = pubkey_algo_to_string( pkc->pubkey_algo );
+	    tty_printf( _("(%u-bit %s key, ID %08lX, created %s)\n"),
+		       nbits_from_pkc( pkc ), s?s:"?", (ulong)keyid[1],
+		       strtimestamp(pkc->timestamp) );
+	}
+	tty_printf("\n");
+	free_public_cert( pkc );
+    }
+    if( next_pw ) {
+	pw = next_pw;
+	next_pw = NULL;
     }
-    if( pwfd != -1 ) { /* read the passphrase from the given descriptor */
+    else if( pwfd != -1 ) { /* read the passphrase from the file */
 	int i, len;
 
 	if( !opt.batch )
@@ -130,7 +176,8 @@
 	dek->keylen = 0;
     else
 	hash_passphrase( dek, pw, s2k, mode==2 );
-    m_free(pw); /* is allocated in secure memory, so it will be burned */
+    m_free(last_pw);
+    last_pw = pw;
     return dek;
 }
 
diff -urN gnupg-0.2.18/g10/pkclist.c gnupg-0.2.19/g10/pkclist.c
--- gnupg-0.2.18/g10/pkclist.c	Fri May 15 15:38:07 1998
+++ gnupg-0.2.19/g10/pkclist.c	Fri May 29 10:58:25 1998
@@ -274,6 +274,10 @@
 	    rc = 1;
 	m_free(answer);
     }
+    else if( opt.always_trust && !rc ) {
+	log_info(_("WARNING: Using untrusted key!\n"));
+	rc = 1;
+    }
     return rc;
 }
 
diff -urN gnupg-0.2.18/g10/plaintext.c gnupg-0.2.19/g10/plaintext.c
--- gnupg-0.2.18/g10/plaintext.c	Fri May 15 15:38:07 1998
+++ gnupg-0.2.19/g10/plaintext.c	Thu May 21 12:40:56 1998
@@ -77,7 +77,8 @@
     if( pt->len ) {
 	for( ; pt->len; pt->len-- ) {
 	    if( (c = iobuf_get(pt->buf)) == -1 ) {
-		log_error("Problem reading source\n");
+		log_error("Problem reading source (%u bytes remaining)\n",
+							 (unsigned)pt->len);
 		rc = G10ERR_READ_FILE;
 		goto leave;
 	    }
diff -urN gnupg-0.2.18/g10/pubkey-enc.c gnupg-0.2.19/g10/pubkey-enc.c
--- gnupg-0.2.18/g10/pubkey-enc.c	Fri May 15 15:38:07 1998
+++ gnupg-0.2.19/g10/pubkey-enc.c	Thu May 28 10:42:07 1998
@@ -29,6 +29,7 @@
 #include "mpi.h"
 #include "keydb.h"
 #include "cipher.h"
+#include "status.h"
 
 
 /****************
@@ -45,6 +46,11 @@
     u16 csum, csum2;
     PKT_secret_cert *skc = m_alloc_clear( sizeof *skc );
 
+  #ifndef HAVE_RSA_CIPHER
+    if( is_RSA(k->pubkey_algo) )
+	write_status(STATUS_RSA_OR_IDEA);
+  #endif
+
     skc->pubkey_algo = k->pubkey_algo;	 /* we want a pubkey with this algo*/
     if( (rc = get_seckey( skc, k->keyid )) )
 	goto leave;
@@ -58,7 +64,7 @@
 	elg_decrypt( plain_dek, k->d.elg.a, k->d.elg.b, &skc->d.elg );
     }
   #ifdef HAVE_RSA_CIPHER
-    else if( is_ELGAMAL(k->pubkey_algo) ) {
+    else if( is_RSA(k->pubkey_algo) ) {
 	if( DBG_CIPHER )
 	    log_mpidump("Encr DEK frame:", k->d.rsa.rsa_integer );
 
@@ -113,6 +119,7 @@
     dek->algo = frame[n++];
     switch( dek->algo ) {
       case CIPHER_ALGO_IDEA:
+	write_status(STATUS_RSA_OR_IDEA);
 	rc = G10ERR_NI_CIPHER;
 	goto leave;
       case CIPHER_ALGO_BLOWFISH160:
diff -urN gnupg-0.2.18/g10/revoke.c gnupg-0.2.19/g10/revoke.c
--- gnupg-0.2.18/g10/revoke.c	Fri May 15 15:38:07 1998
+++ gnupg-0.2.19/g10/revoke.c	Tue May 26 12:52:12 1998
@@ -159,7 +159,7 @@
 
 
     /* create it */
-    rc = make_keysig_packet( &sig, pkc, NULL, skc, 0x20, 0);
+    rc = make_keysig_packet( &sig, pkc, NULL, NULL, skc, 0x20, 0);
     if( rc ) {
 	log_error("make_keysig_packet failed: %s\n", g10_errstr(rc));
 	goto leave;
diff -urN gnupg-0.2.18/g10/seckey-cert.c gnupg-0.2.19/g10/seckey-cert.c
--- gnupg-0.2.18/g10/seckey-cert.c	Fri May 15 15:38:07 1998
+++ gnupg-0.2.19/g10/seckey-cert.c	Thu May 28 17:40:23 1998
@@ -31,6 +31,7 @@
 #include "cipher.h"
 #include "main.h"
 #include "options.h"
+#include "i18n.h"
 
 
 static int
@@ -55,7 +56,7 @@
 	  case CIPHER_ALGO_CAST:
 	    keyid_from_skc( cert, keyid );
 	    dek = passphrase_to_dek( keyid, cert->protect.algo,
-					      &cert->protect.s2k, 0 );
+				     &cert->protect.s2k, 0 );
 	    cipher_hd = cipher_open( cert->protect.algo,
 				     CIPHER_MODE_AUTO_CFB, 1);
 	    cipher_setkey( cipher_hd, dek->key, dek->keylen );
@@ -221,13 +222,13 @@
 
     for(i=0; i < 3 && rc == G10ERR_BAD_PASS; i++ ) {
 	if( i )
-	    log_error("Invalid passphrase; please try again ...\n\n");
+	    log_error(_("Invalid passphrase; please try again ...\n"));
 	switch( cert->pubkey_algo ) {
 	  case PUBKEY_ALGO_ELGAMAL_E:
 	  case PUBKEY_ALGO_ELGAMAL:
 	  case PUBKEY_ALGO_DSA:
 	    rc = do_check( cert );
-	  #if 1 /* set to 0 to disable the workaround */
+	  #if 0 /* set to 1 to enable the workaround */
 	    if( rc == G10ERR_BAD_PASS && cert->is_protected
 		&& cert->protect.algo == CIPHER_ALGO_BLOWFISH
 		&& cert->pubkey_algo != PUBKEY_ALGO_ELGAMAL ) {
@@ -243,11 +244,19 @@
 	    }
 	  #endif
 	    break;
+	#ifdef HAVE_RSA_CIPHER
+	  case PUBKEY_ALGO_RSA:
+	  case PUBKEY_ALGO_RSA_E:
+	  case PUBKEY_ALGO_RSA_S:
+	    rc = do_check( cert );
+	    break;
+	#endif
 	  default: rc = G10ERR_PUBKEY_ALGO;
 	}
 	if( get_passphrase_fd() != -1 )
 	    break;
     }
+
     return rc;
 }
 
diff -urN gnupg-0.2.18/g10/sig-check.c gnupg-0.2.19/g10/sig-check.c
--- gnupg-0.2.18/g10/sig-check.c	Fri May 15 17:09:42 1998
+++ gnupg-0.2.19/g10/sig-check.c	Thu May 28 10:42:17 1998
@@ -30,6 +30,7 @@
 #include "keydb.h"
 #include "cipher.h"
 #include "main.h"
+#include "status.h"
 
 
 static int do_check( PKT_public_cert *pkc, PKT_signature *sig,
@@ -47,6 +48,12 @@
     PKT_public_cert *pkc = m_alloc_clear( sizeof *pkc );
     int rc=0;
 
+
+  #ifndef HAVE_RSA_CIPHER
+    if( is_RSA(sig->pubkey_algo) )
+	write_status(STATUS_RSA_OR_IDEA);
+  #endif
+
     if( get_pubkey( pkc, sig->keyid ) )
 	rc = G10ERR_NO_PUBKEY;
     else
@@ -294,6 +301,13 @@
 	KBNODE snode = find_prev_kbnode( root, node, PKT_PUBKEY_SUBCERT );
 
 	if( snode ) {
+	    if( is_selfsig ) {
+		u32 keyid[2];
+
+		keyid_from_pkc( pkc, keyid );
+		if( keyid[0] == sig->keyid[0] && keyid[1] == sig->keyid[1] )
+		    *is_selfsig = 1;
+	    }
 	    md = md_open( algo, 0 );
 	    hash_public_cert( md, pkc );
 	    hash_public_cert( md, snode->pkt->pkt.public_cert );
diff -urN gnupg-0.2.18/g10/sign.c gnupg-0.2.19/g10/sign.c
--- gnupg-0.2.18/g10/sign.c	Fri May 15 18:06:25 1998
+++ gnupg-0.2.19/g10/sign.c	Thu May 21 14:40:04 1998
@@ -170,17 +170,19 @@
 
     if( opt.armor && !outfile  )
 	iobuf_push_filter( out, armor_filter, &afx );
-    write_comment( out, "#created by GNUPG v" VERSION " ("
+    else
+	write_comment( out, "#created by GNUPG v" VERSION " ("
 					    PRINTABLE_OS_NAME ")");
-    if( opt.compress && !outfile )
-	iobuf_push_filter( out, compress_filter, &zfx );
-
     if( encrypt ) {
 	efx.pkc_list = pkc_list;
 	/* fixme: set efx.cfx.datalen if known */
 	iobuf_push_filter( out, encrypt_filter, &efx );
     }
 
+    if( opt.compress && !outfile )
+	iobuf_push_filter( out, compress_filter, &zfx );
+
+
     if( !detached ) {
 	/* loop over the secret certificates and build headers */
 	for( skc_rover = skc_list; skc_rover; skc_rover = skc_rover->next ) {
@@ -410,7 +412,6 @@
 clearsign_file( const char *fname, STRLIST locusr, const char *outfile )
 {
     armor_filter_context_t afx;
-    compress_filter_context_t zfx;
     text_filter_context_t tfx;
     MD_HANDLE textmd = NULL;
     IOBUF inp = NULL, out = NULL;
@@ -420,7 +421,6 @@
     SKC_LIST skc_rover = NULL;
 
     memset( &afx, 0, sizeof afx);
-    memset( &zfx, 0, sizeof zfx);
     memset( &tfx, 0, sizeof tfx);
     init_packet( &pkt );
 
diff -urN gnupg-0.2.18/g10/status.c gnupg-0.2.19/g10/status.c
--- gnupg-0.2.18/g10/status.c	Fri May 15 15:38:07 1998
+++ gnupg-0.2.19/g10/status.c	Thu May 28 10:34:11 1998
@@ -56,9 +56,11 @@
       case STATUS_BADSIG : s = "BADSIG\n"; break;
       case STATUS_ERRSIG : s = "ERRSIG\n"; break;
       case STATUS_BADARMOR : s = "BADARMOR\n"; break;
+      case STATUS_RSA_OR_IDEA : s= "RSA_OR_IDEA\n"; break;
       default: s = "?\n"; break;
     }
 
+    write( fd, "[GNUPG:] ", 9 );
     if( text ) {
 	write( fd, s, strlen(s)-1 );
 	write( fd, " ", 1 );
diff -urN gnupg-0.2.18/g10/status.h gnupg-0.2.19/g10/status.h
--- gnupg-0.2.18/g10/status.h	Sun Mar  8 13:21:06 1998
+++ gnupg-0.2.19/g10/status.h	Tue May 26 14:16:50 1998
@@ -32,6 +32,7 @@
 
 #define STATUS_BADARMOR  7
 
+#define STATUS_RSA_OR_IDEA 8
 
 
 /*-- status.c --*/
diff -urN gnupg-0.2.18/g10/trustdb.c gnupg-0.2.19/g10/trustdb.c
--- gnupg-0.2.18/g10/trustdb.c	Fri May 15 15:38:07 1998
+++ gnupg-0.2.19/g10/trustdb.c	Fri May 29 10:01:48 1998
@@ -1756,6 +1756,29 @@
 }
 
 
+int
+query_trust_info( PKT_public_cert *pkc )
+{
+    unsigned trustlevel;
+    int c;
+
+    if( check_trust( pkc, &trustlevel ) )
+	return '?';
+    if( trustlevel & TRUST_FLAG_REVOKED )
+	return 'r';
+    switch( (trustlevel & TRUST_MASK) ) {
+      case TRUST_UNKNOWN:   c = 'o'; break;
+      case TRUST_EXPIRED:   c = 'e'; break;
+      case TRUST_UNDEFINED: c = 'q'; break;
+      case TRUST_NEVER:     c = 'n'; break;
+      case TRUST_MARGINAL:  c = 'm'; break;
+      case TRUST_FULLY:     c = 'f'; break;
+      case TRUST_ULTIMATE:  c = 'u'; break;
+      default: BUG();
+    }
+    return c;
+}
+
 
 
 /****************
diff -urN gnupg-0.2.18/g10/trustdb.h gnupg-0.2.19/g10/trustdb.h
--- gnupg-0.2.18/g10/trustdb.h	Tue Apr 14 19:04:36 1998
+++ gnupg-0.2.19/g10/trustdb.h	Tue May 26 14:16:50 1998
@@ -24,15 +24,15 @@
 
 /* Trust values must be sorted in ascending order */
 #define TRUST_MASK	 15
-#define TRUST_UNKNOWN	  0  /* not yet calculated */
-#define TRUST_EXPIRED	  1  /* calculation may be invalid */
-#define TRUST_UNDEFINED   2  /* not enough information for calculation */
-#define TRUST_NEVER	  3  /* never trust this pubkey */
-#define TRUST_MARGINAL	  4  /* marginally trusted */
-#define TRUST_FULLY	  5  /* fully trusted	   */
-#define TRUST_ULTIMATE	  6  /* ultimately trusted */
+#define TRUST_UNKNOWN	  0  /* o: not yet calculated */
+#define TRUST_EXPIRED	  1  /* e: calculation may be invalid */
+#define TRUST_UNDEFINED   2  /* q: not enough information for calculation */
+#define TRUST_NEVER	  3  /* n: never trust this pubkey */
+#define TRUST_MARGINAL	  4  /* m: marginally trusted */
+#define TRUST_FULLY	  5  /* f: fully trusted      */
+#define TRUST_ULTIMATE	  6  /* u: ultimately trusted */
 /* trust values not covered by the mask */
-#define TRUST_FLAG_REVOKED 32
+#define TRUST_FLAG_REVOKED 32 /* r: revoked */
 
 
 /*-- trustdb.c --*/
@@ -40,6 +40,7 @@
 void list_trust_path( int max_depth, const char *username );
 int init_trustdb( int level, const char *dbname );
 int check_trust( PKT_public_cert *pkc, unsigned *r_trustlevel );
+int query_trust_info( PKT_public_cert *pkc );
 int enum_trust_web( void **context, ulong *lid );
 int get_ownertrust( ulong lid, unsigned *r_otrust );
 int keyid_from_trustdb( ulong lid, u32 *keyid );
diff -urN gnupg-0.2.18/include/ChangeLog gnupg-0.2.19/include/ChangeLog
--- gnupg-0.2.18/include/ChangeLog	Mon May  4 16:38:05 1998
+++ gnupg-0.2.19/include/ChangeLog	Thu May 21 13:26:39 1998
@@ -1,3 +1,11 @@
+Thu May 21 13:25:51 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* cipher.h: removed ROT 5 and changed one id and add dummy
+
+Tue May 19 18:09:05 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* cipher.h (DIGEST_ALGO_TIGER): Chnaged id from 101 to 6.
+
 Mon May  4 16:37:17 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* cipher.h (PUBKEY_ALGO_ELGAMAL_E): New, with value of the
diff -urN gnupg-0.2.18/include/cipher.h gnupg-0.2.19/include/cipher.h
--- gnupg-0.2.18/include/cipher.h	Tue May  5 14:08:49 1998
+++ gnupg-0.2.19/include/cipher.h	Thu May 21 13:23:12 1998
@@ -42,10 +42,10 @@
 #define CIPHER_ALGO_3DES	 2
 #define CIPHER_ALGO_CAST	 3
 #define CIPHER_ALGO_BLOWFISH	 4  /* blowfish 128 bit key */
-#define CIPHER_ALGO_ROT_N	 5
-#define CIPHER_ALGO_SAFER_SK128  6
-#define CIPHER_ALGO_DES_SK	 7
+#define CIPHER_ALGO_SAFER_SK128  5
+#define CIPHER_ALGO_DES_SK	 6
 #define CIPHER_ALGO_BLOWFISH160 42  /* blowfish 160 bit key (not in OpenPGP)*/
+#define CIPHER_ALGO_DUMMY      110  /* no encryption at all */
 
 #define PUBKEY_ALGO_RSA        1
 #define PUBKEY_ALGO_RSA_E      2     /* RSA encrypt only */
@@ -58,7 +58,7 @@
 #define DIGEST_ALGO_SHA1      2
 #define DIGEST_ALGO_RMD160    3
 #ifdef WITH_TIGER_HASH
-#define DIGEST_ALGO_TIGER     101
+#define DIGEST_ALGO_TIGER     6
 #endif
 
 #define is_RSA(a)     ((a)==PUBKEY_ALGO_RSA || (a)==PUBKEY_ALGO_RSA_E \
@@ -81,6 +81,7 @@
 #define CIPHER_MODE_CFB       2
 #define CIPHER_MODE_PHILS_CFB 3
 #define CIPHER_MODE_AUTO_CFB  4
+#define CIPHER_MODE_DUMMY     5  /* used with algo DUMMY for no encryption */
 
 
 int cipher_debug_mode;
diff -urN gnupg-0.2.18/mpi/ChangeLog gnupg-0.2.19/mpi/ChangeLog
--- gnupg-0.2.18/mpi/ChangeLog	Wed May 13 11:04:41 1998
+++ gnupg-0.2.19/mpi/ChangeLog	Mon May 18 13:48:20 1998
@@ -1,3 +1,9 @@
+Mon May 18 13:47:06 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* config.links: split mpih-shift into mpih-[lr]shift and
+	changed all implementations.
+	* mpi/alpha: add some new assembler stuff.
+
 Wed May 13 11:04:29 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* config.links: Add support for MIPS
diff -urN gnupg-0.2.18/mpi/Makefile.am gnupg-0.2.19/mpi/Makefile.am
--- gnupg-0.2.18/mpi/Makefile.am	Mon Mar  2 19:29:54 1998
+++ gnupg-0.2.19/mpi/Makefile.am	Mon May 18 13:00:28 1998
@@ -7,7 +7,7 @@
 
 EXTRA_DIST = config.links
 DISTCLEANFILES = mpih-add1.S mpih-mul1.S mpih-mul2.S mpih-mul3.S  \
-		 mpih-shift.S mpih-sub1.S asm-syntax.h sysdep.h
+		 mpih-lshift.S mpih-rshift.S mpih-sub1.S asm-syntax.h sysdep.h
 
 
 noinst_LIBRARIES = libmpi.a
@@ -43,7 +43,8 @@
 		     mpih-mul3.o    \
 		     mpih-add1.o    \
 		     mpih-sub1.o    \
-		     mpih-shift.o
+		     mpih-lshift.o  \
+		     mpih-rshift.o
 
 libmpi_a_DEPENDENCIES = $(common_asm_objects) @MPI_EXTRA_ASM_OBJS@
 libmpi_a_LIBADD = $(common_asm_objects) @MPI_EXTRA_ASM_OBJS@
diff -urN gnupg-0.2.18/mpi/Makefile.in gnupg-0.2.19/mpi/Makefile.in
--- gnupg-0.2.18/mpi/Makefile.in	Fri May 15 18:45:31 1998
+++ gnupg-0.2.19/mpi/Makefile.in	Fri May 29 12:56:10 1998
@@ -98,7 +98,7 @@
 
 EXTRA_DIST = config.links
 DISTCLEANFILES = mpih-add1.S mpih-mul1.S mpih-mul2.S mpih-mul3.S  \
-		 mpih-shift.S mpih-sub1.S asm-syntax.h sysdep.h
+		 mpih-lshift.S mpih-rshift.S mpih-sub1.S asm-syntax.h sysdep.h
 
 noinst_LIBRARIES = libmpi.a
 # noinst_HEADERS   =
@@ -131,7 +131,8 @@
 		     mpih-mul3.o    \
 		     mpih-add1.o    \
 		     mpih-sub1.o    \
-		     mpih-shift.o
+		     mpih-lshift.o  \
+		     mpih-rshift.o
 
 libmpi_a_DEPENDENCIES = $(common_asm_objects) @MPI_EXTRA_ASM_OBJS@
 libmpi_a_LIBADD = $(common_asm_objects) @MPI_EXTRA_ASM_OBJS@
diff -urN gnupg-0.2.18/mpi/alpha/distfiles gnupg-0.2.19/mpi/alpha/distfiles
--- gnupg-0.2.18/mpi/alpha/distfiles	Wed Feb 11 14:47:27 1998
+++ gnupg-0.2.19/mpi/alpha/distfiles	Mon May 18 13:22:19 1998
@@ -1,6 +1,11 @@
 README
 mpih-add1.S
-mpih-shift.S
+mpih-sub1.S
+mpih-mul1.S
+mpih-mul2.S
+mpih-mul3.S
+mpih-lshift.S
+mpih-rshift.S
 
 udiv-qrnnd.S
 
diff -urN gnupg-0.2.18/mpi/alpha/mpih-add1.S gnupg-0.2.19/mpi/alpha/mpih-add1.S
--- gnupg-0.2.18/mpi/alpha/mpih-add1.S	Mon Feb 23 13:16:23 1998
+++ gnupg-0.2.19/mpi/alpha/mpih-add1.S	Mon May 18 13:16:16 1998
@@ -19,14 +19,6 @@
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
- *
- * Note: This code is heavily based on the GNU MP Library.
- *	 Actually it's the same code with only minor changes in the
- *	 way the data is stored; this is to support the abstraction
- *	 of an optional secure memory allocation which may be used
- *	 to avoid revealing of sensitive data due to paging etc.
- *	 The GNU MP Library itself is published under the LGPL;
- *	 however I decided to publish this code under the plain GPL.
  */
 
 
diff -urN gnupg-0.2.18/mpi/alpha/mpih-lshift.S gnupg-0.2.19/mpi/alpha/mpih-lshift.S
--- gnupg-0.2.18/mpi/alpha/mpih-lshift.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/mpi/alpha/mpih-lshift.S	Mon May 18 13:01:40 1998
@@ -0,0 +1,122 @@
+/* alpha    lshift
+ *	Copyright (C) 1994, 1995 Free Software Foundation, Inc.
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ * Note: This code is heavily based on the GNU MP Library.
+ *	 Actually it's the same code with only minor changes in the
+ *	 way the data is stored; this is to support the abstraction
+ *	 of an optional secure memory allocation which may be used
+ *	 to avoid revealing of sensitive data due to paging etc.
+ *	 The GNU MP Library itself is published under the LGPL;
+ *	 however I decided to publish this code under the plain GPL.
+ */
+
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_lshift( mpi_ptr_t wp,	(r16)
+ *		   mpi_ptr_t up,	(r17)
+ *		   mpi_size_t usize,	(r18)
+ *		   unsigned cnt)	(r19)
+ *
+ * This code runs at 4.8 cycles/limb on the 21064.  With infinite unrolling,
+ * it would take 4 cycles/limb.  It should be possible to get down to 3
+ * cycles/limb since both ldq and stq can be paired with the other used
+ * instructions.  But there are many restrictions in the 21064 pipeline that
+ * makes it hard, if not impossible, to get down to 3 cycles/limb:
+ *
+ * 1. ldq has a 3 cycle delay, srl and sll have a 2 cycle delay.
+ * 2. Only aligned instruction pairs can be paired.
+ * 3. The store buffer or silo might not be able to deal with the bandwidth.
+ */
+
+	.set	noreorder
+	.set	noat
+.text
+	.align	3
+	.globl	mpihelp_lshift
+	.ent	mpihelp_lshift
+mpihelp_lshift:
+	.frame	$30,0,$26,0
+
+	s8addq	$18,$17,$17	# make r17 point at end of s1
+	ldq	$4,-8($17)	# load first limb
+	subq	$17,8,$17
+	subq	$31,$19,$7
+	s8addq	$18,$16,$16	# make r16 point at end of RES
+	subq	$18,1,$18
+	and	$18,4-1,$20	# number of limbs in first loop
+	srl	$4,$7,$0	# compute function result
+
+	beq	$20,.L0
+	subq	$18,$20,$18
+
+	.align	3
+.Loop0:
+	ldq	$3,-8($17)
+	subq	$16,8,$16
+	subq	$17,8,$17
+	subq	$20,1,$20
+	sll	$4,$19,$5
+	srl	$3,$7,$6
+	bis	$3,$3,$4
+	bis	$5,$6,$8
+	stq	$8,0($16)
+	bne	$20,.Loop0
+
+.L0:	beq	$18,.Lend
+
+	.align	3
+.Loop:	ldq	$3,-8($17)
+	subq	$16,32,$16
+	subq	$18,4,$18
+	sll	$4,$19,$5
+	srl	$3,$7,$6
+
+	ldq	$4,-16($17)
+	sll	$3,$19,$1
+	bis	$5,$6,$8
+	stq	$8,24($16)
+	srl	$4,$7,$2
+
+	ldq	$3,-24($17)
+	sll	$4,$19,$5
+	bis	$1,$2,$8
+	stq	$8,16($16)
+	srl	$3,$7,$6
+
+	ldq	$4,-32($17)
+	sll	$3,$19,$1
+	bis	$5,$6,$8
+	stq	$8,8($16)
+	srl	$4,$7,$2
+
+	subq	$17,32,$17
+	bis	$1,$2,$8
+	stq	$8,0($16)
+
+	bgt	$18,.Loop
+
+.Lend:	sll	$4,$19,$8
+	stq	$8,-8($16)
+	ret	$31,($26),1
+	.end	mpihelp_lshift
+
+
diff -urN gnupg-0.2.18/mpi/alpha/mpih-mul1.S gnupg-0.2.19/mpi/alpha/mpih-mul1.S
--- gnupg-0.2.18/mpi/alpha/mpih-mul1.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/mpi/alpha/mpih-mul1.S	Mon May 18 13:15:22 1998
@@ -0,0 +1,89 @@
+/* Alpha 21064 mpih-mul1.S -- Multiply a limb vector with a limb and store
+ *			      the result in a second limb vector.
+ *
+ * Copyright (C) 1992, 1994, 1995, 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_mul_1( mpi_ptr_t res_ptr,	(r16)
+ *		  mpi_ptr_t s1_ptr,	(r17)
+ *		  mpi_size_t s1_size,	(r18)
+ *		  mpi_limb_t s2_limb)	(r19)
+ *
+ * This code runs at 42 cycles/limb on the EV4 and 18 cycles/limb on the EV5.
+ *
+ * To improve performance for long multiplications, we would use
+ * 'fetch' for S1 and 'fetch_m' for RES.  It's not obvious how to use
+ * these instructions without slowing down the general code: 1. We can
+ * only have two prefetches in operation at any time in the Alpha
+ * architecture.  2. There will seldom be any special alignment
+ * between RES_PTR and S1_PTR.	Maybe we can simply divide the current
+ * loop into an inner and outer loop, having the inner loop handle
+ * exactly one prefetch block?
+ */
+
+	.set	noreorder
+	.set	noat
+.text
+	.align	3
+	.globl	mpihelp_mul_1
+	.ent	mpihelp_mul_1 2
+mpihelp_mul_1:
+	.frame	$30,0,$26
+
+	ldq	$2,0($17)	# $2 = s1_limb
+	subq	$18,1,$18	# size--
+	mulq	$2,$19,$3	# $3 = prod_low
+	bic	$31,$31,$4	# clear cy_limb
+	umulh	$2,$19,$0	# $0 = prod_high
+	beq	$18,Lend1	# jump if size was == 1
+	ldq	$2,8($17)	# $2 = s1_limb
+	subq	$18,1,$18	# size--
+	stq	$3,0($16)
+	beq	$18,Lend2	# jump if size was == 2
+
+	.align	3
+Loop:	mulq	$2,$19,$3	# $3 = prod_low
+	addq	$4,$0,$0	# cy_limb = cy_limb + 'cy'
+	subq	$18,1,$18	# size--
+	umulh	$2,$19,$4	# $4 = cy_limb
+	ldq	$2,16($17)	# $2 = s1_limb
+	addq	$17,8,$17	# s1_ptr++
+	addq	$3,$0,$3	# $3 = cy_limb + prod_low
+	stq	$3,8($16)
+	cmpult	$3,$0,$0	# $0 = carry from (cy_limb + prod_low)
+	addq	$16,8,$16	# res_ptr++
+	bne	$18,Loop
+
+Lend2:	mulq	$2,$19,$3	# $3 = prod_low
+	addq	$4,$0,$0	# cy_limb = cy_limb + 'cy'
+	umulh	$2,$19,$4	# $4 = cy_limb
+	addq	$3,$0,$3	# $3 = cy_limb + prod_low
+	cmpult	$3,$0,$0	# $0 = carry from (cy_limb + prod_low)
+	stq	$3,8($16)
+	addq	$4,$0,$0	# cy_limb = prod_high + cy
+	ret	$31,($26),1
+Lend1:	stq	$3,0($16)
+	ret	$31,($26),1
+
+	.end	mpihelp_mul_1
+
+
diff -urN gnupg-0.2.18/mpi/alpha/mpih-mul2.S gnupg-0.2.19/mpi/alpha/mpih-mul2.S
--- gnupg-0.2.18/mpi/alpha/mpih-mul2.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/mpi/alpha/mpih-mul2.S	Mon May 18 13:15:48 1998
@@ -0,0 +1,96 @@
+/* Alpha 21064 addmul_1 -- Multiply a limb vector with a limb and add
+ *			   the result to a second limb vector.
+ *
+ * Copyright (C) 1992, 1994, 1995, 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_addmul_1( mpi_ptr_t res_ptr,      (r16)
+ *		     mpi_ptr_t s1_ptr,	     (r17)
+ *		     mpi_size_t s1_size,     (r18)
+ *		     mpi_limb_t s2_limb)     (r19)
+ *
+ * This code runs at 42 cycles/limb on EV4 and 18 cycles/limb on EV5.
+ */
+
+
+	.set	noreorder
+	.set	noat
+.text
+	.align	3
+	.globl	mpihelp_addmul_1
+	.ent	mpihelp_addmul_1 2
+mpihelp_addmul_1:
+	.frame	$30,0,$26
+
+	ldq	$2,0($17)	# $2 = s1_limb
+	addq	$17,8,$17	# s1_ptr++
+	subq	$18,1,$18	# size--
+	mulq	$2,$19,$3	# $3 = prod_low
+	ldq	$5,0($16)	# $5 = *res_ptr
+	umulh	$2,$19,$0	# $0 = prod_high
+	beq	$18,.Lend1	# jump if size was == 1
+	ldq	$2,0($17)	# $2 = s1_limb
+	addq	$17,8,$17	# s1_ptr++
+	subq	$18,1,$18	# size--
+	addq	$5,$3,$3
+	cmpult	$3,$5,$4
+	stq	$3,0($16)
+	addq	$16,8,$16	# res_ptr++
+	beq	$18,.Lend2	# jump if size was == 2
+
+	.align	3
+.Loop:	mulq	$2,$19,$3	# $3 = prod_low
+	ldq	$5,0($16)	# $5 = *res_ptr
+	addq	$4,$0,$0	# cy_limb = cy_limb + 'cy'
+	subq	$18,1,$18	# size--
+	umulh	$2,$19,$4	# $4 = cy_limb
+	ldq	$2,0($17)	# $2 = s1_limb
+	addq	$17,8,$17	# s1_ptr++
+	addq	$3,$0,$3	# $3 = cy_limb + prod_low
+	cmpult	$3,$0,$0	# $0 = carry from (cy_limb + prod_low)
+	addq	$5,$3,$3
+	cmpult	$3,$5,$5
+	stq	$3,0($16)
+	addq	$16,8,$16	# res_ptr++
+	addq	$5,$0,$0	# combine carries
+	bne	$18,.Loop
+
+.Lend2: mulq	$2,$19,$3	# $3 = prod_low
+	ldq	$5,0($16)	# $5 = *res_ptr
+	addq	$4,$0,$0	# cy_limb = cy_limb + 'cy'
+	umulh	$2,$19,$4	# $4 = cy_limb
+	addq	$3,$0,$3	# $3 = cy_limb + prod_low
+	cmpult	$3,$0,$0	# $0 = carry from (cy_limb + prod_low)
+	addq	$5,$3,$3
+	cmpult	$3,$5,$5
+	stq	$3,0($16)
+	addq	$5,$0,$0	# combine carries
+	addq	$4,$0,$0	# cy_limb = prod_high + cy
+	ret	$31,($26),1
+.Lend1: addq	$5,$3,$3
+	cmpult	$3,$5,$5
+	stq	$3,0($16)
+	addq	$0,$5,$0
+	ret	$31,($26),1
+
+	.end	mpihelp_addmul_1
+
diff -urN gnupg-0.2.18/mpi/alpha/mpih-mul3.S gnupg-0.2.19/mpi/alpha/mpih-mul3.S
--- gnupg-0.2.18/mpi/alpha/mpih-mul3.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/mpi/alpha/mpih-mul3.S	Mon May 18 13:18:40 1998
@@ -0,0 +1,94 @@
+/* Alpha 21064	submul_1 -- Multiply a limb vector with a limb and
+ *			    subtract the result from a second limb vector.
+ * Copyright (C) 1992, 1994, 1995, 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_submul_1( mpi_ptr_t res_ptr,      (r16   )
+ *		     mpi_ptr_t s1_ptr,	     (r17   )
+ *		     mpi_size_t s1_size,     (r18   )
+ *		     mpi_limb_t s2_limb)     (r19   )
+ *
+ * This code runs at 42 cycles/limb on EV4 and 18 cycles/limb on EV5.
+ */
+
+	.set	noreorder
+	.set	noat
+.text
+	.align	3
+	.globl	mpihelp_submul_1
+	.ent	mpihelp_submul_1 2
+mpihelp_submul_1:
+	.frame	$30,0,$26
+
+	ldq	$2,0($17)	# $2 = s1_limb
+	addq	$17,8,$17	# s1_ptr++
+	subq	$18,1,$18	# size--
+	mulq	$2,$19,$3	# $3 = prod_low
+	ldq	$5,0($16)	# $5 = *res_ptr
+	umulh	$2,$19,$0	# $0 = prod_high
+	beq	$18,.Lend1	# jump if size was == 1
+	ldq	$2,0($17)	# $2 = s1_limb
+	addq	$17,8,$17	# s1_ptr++
+	subq	$18,1,$18	# size--
+	subq	$5,$3,$3
+	cmpult	$5,$3,$4
+	stq	$3,0($16)
+	addq	$16,8,$16	# res_ptr++
+	beq	$18,.Lend2	# jump if size was == 2
+
+	.align	3
+.Loop:	mulq	$2,$19,$3	# $3 = prod_low
+	ldq	$5,0($16)	# $5 = *res_ptr
+	addq	$4,$0,$0	# cy_limb = cy_limb + 'cy'
+	subq	$18,1,$18	# size--
+	umulh	$2,$19,$4	# $4 = cy_limb
+	ldq	$2,0($17)	# $2 = s1_limb
+	addq	$17,8,$17	# s1_ptr++
+	addq	$3,$0,$3	# $3 = cy_limb + prod_low
+	cmpult	$3,$0,$0	# $0 = carry from (cy_limb + prod_low)
+	subq	$5,$3,$3
+	cmpult	$5,$3,$5
+	stq	$3,0($16)
+	addq	$16,8,$16	# res_ptr++
+	addq	$5,$0,$0	# combine carries
+	bne	$18,.Loop
+
+.Lend2: mulq	$2,$19,$3	# $3 = prod_low
+	ldq	$5,0($16)	# $5 = *res_ptr
+	addq	$4,$0,$0	# cy_limb = cy_limb + 'cy'
+	umulh	$2,$19,$4	# $4 = cy_limb
+	addq	$3,$0,$3	# $3 = cy_limb + prod_low
+	cmpult	$3,$0,$0	# $0 = carry from (cy_limb + prod_low)
+	subq	$5,$3,$3
+	cmpult	$5,$3,$5
+	stq	$3,0($16)
+	addq	$5,$0,$0	# combine carries
+	addq	$4,$0,$0	# cy_limb = prod_high + cy
+	ret	$31,($26),1
+.Lend1: subq	$5,$3,$3
+	cmpult	$5,$3,$5
+	stq	$3,0($16)
+	addq	$0,$5,$0
+	ret	$31,($26),1
+
+	.end	mpihelp_submul_1
+
diff -urN gnupg-0.2.18/mpi/alpha/mpih-rshift.S gnupg-0.2.19/mpi/alpha/mpih-rshift.S
--- gnupg-0.2.18/mpi/alpha/mpih-rshift.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/mpi/alpha/mpih-rshift.S	Mon May 18 13:02:01 1998
@@ -0,0 +1,120 @@
+/* alpha    rshift
+ *	Copyright (C) 1994, 1995 Free Software Foundation, Inc.
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ * Note: This code is heavily based on the GNU MP Library.
+ *	 Actually it's the same code with only minor changes in the
+ *	 way the data is stored; this is to support the abstraction
+ *	 of an optional secure memory allocation which may be used
+ *	 to avoid revealing of sensitive data due to paging etc.
+ *	 The GNU MP Library itself is published under the LGPL;
+ *	 however I decided to publish this code under the plain GPL.
+ */
+
+
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_rshift( mpi_ptr_t wp,	(r16)
+ *		   mpi_ptr_t up,	(r17)
+ *		   mpi_size_t usize,	(r18)
+ *		   unsigned cnt)	(r19)
+ *
+ * This code runs at 4.8 cycles/limb on the 21064.  With infinite unrolling,
+ * it would take 4 cycles/limb.  It should be possible to get down to 3
+ * cycles/limb since both ldq and stq can be paired with the other used
+ * instructions.  But there are many restrictions in the 21064 pipeline that
+ * makes it hard, if not impossible, to get down to 3 cycles/limb:
+ *
+ * 1. ldq has a 3 cycle delay, srl and sll have a 2 cycle delay.
+ * 2. Only aligned instruction pairs can be paired.
+ * 3. The store buffer or silo might not be able to deal with the bandwidth.
+ */
+
+	.set	noreorder
+	.set	noat
+.text
+	.align	3
+	.globl	mpihelp_rshift
+	.ent	mpihelp_rshift
+mpihelp_rshift:
+	.frame	$30,0,$26,0
+
+	ldq	$4,0($17)	# load first limb
+	addq	$17,8,$17
+	subq	$31,$19,$7
+	subq	$18,1,$18
+	and	$18,4-1,$20	# number of limbs in first loop
+	sll	$4,$7,$0	# compute function result
+
+	beq	$20,.R0
+	subq	$18,$20,$18
+
+	.align	3
+.Roop0:
+	ldq	$3,0($17)
+	addq	$16,8,$16
+	addq	$17,8,$17
+	subq	$20,1,$20
+	srl	$4,$19,$5
+	sll	$3,$7,$6
+	bis	$3,$3,$4
+	bis	$5,$6,$8
+	stq	$8,-8($16)
+	bne	$20,.Roop0
+
+.R0:	beq	$18,.Rend
+
+	.align	3
+.Roop:	ldq	$3,0($17)
+	addq	$16,32,$16
+	subq	$18,4,$18
+	srl	$4,$19,$5
+	sll	$3,$7,$6
+
+	ldq	$4,8($17)
+	srl	$3,$19,$1
+	bis	$5,$6,$8
+	stq	$8,-32($16)
+	sll	$4,$7,$2
+
+	ldq	$3,16($17)
+	srl	$4,$19,$5
+	bis	$1,$2,$8
+	stq	$8,-24($16)
+	sll	$3,$7,$6
+
+	ldq	$4,24($17)
+	srl	$3,$19,$1
+	bis	$5,$6,$8
+	stq	$8,-16($16)
+	sll	$4,$7,$2
+
+	addq	$17,32,$17
+	bis	$1,$2,$8
+	stq	$8,-8($16)
+
+	bgt	$18,.Roop
+
+.Rend:	srl	$4,$19,$8
+	stq	$8,0($16)
+	ret	$31,($26),1
+	.end	mpihelp_rshift
+
diff -urN gnupg-0.2.18/mpi/alpha/mpih-shift.S gnupg-0.2.19/mpi/alpha/mpih-shift.S
--- gnupg-0.2.18/mpi/alpha/mpih-shift.S	Mon Feb 23 13:16:23 1998
+++ gnupg-0.2.19/mpi/alpha/mpih-shift.S	Thu Jan  1 01:00:00 1970
@@ -1,213 +0,0 @@
-/* alpha    rshift, lshift
- *	Copyright (C) 1994, 1995 Free Software Foundation, Inc.
- *	Copyright (C) 1998 Free Software Foundation, Inc.
- *
- * This file is part of GNUPG.
- *
- * GNUPG is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * GNUPG is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
- *
- * Note: This code is heavily based on the GNU MP Library.
- *	 Actually it's the same code with only minor changes in the
- *	 way the data is stored; this is to support the abstraction
- *	 of an optional secure memory allocation which may be used
- *	 to avoid revealing of sensitive data due to paging etc.
- *	 The GNU MP Library itself is published under the LGPL;
- *	 however I decided to publish this code under the plain GPL.
- */
-
-
-
-/*******************
- * mpi_limb_t
- * mpihelp_lshift( mpi_ptr_t wp,	(r16)
- *		   mpi_ptr_t up,	(r17)
- *		   mpi_size_t usize,	(r18)
- *		   unsigned cnt)	(r19)
- *
- * This code runs at 4.8 cycles/limb on the 21064.  With infinite unrolling,
- * it would take 4 cycles/limb.  It should be possible to get down to 3
- * cycles/limb since both ldq and stq can be paired with the other used
- * instructions.  But there are many restrictions in the 21064 pipeline that
- * makes it hard, if not impossible, to get down to 3 cycles/limb:
- *
- * 1. ldq has a 3 cycle delay, srl and sll have a 2 cycle delay.
- * 2. Only aligned instruction pairs can be paired.
- * 3. The store buffer or silo might not be able to deal with the bandwidth.
- */
-
-	.set	noreorder
-	.set	noat
-.text
-	.align	3
-	.globl	mpihelp_lshift
-	.ent	mpihelp_lshift
-mpihelp_lshift:
-	.frame	$30,0,$26,0
-
-	s8addq	$18,$17,$17	# make r17 point at end of s1
-	ldq	$4,-8($17)	# load first limb
-	subq	$17,8,$17
-	subq	$31,$19,$7
-	s8addq	$18,$16,$16	# make r16 point at end of RES
-	subq	$18,1,$18
-	and	$18,4-1,$20	# number of limbs in first loop
-	srl	$4,$7,$0	# compute function result
-
-	beq	$20,.L0
-	subq	$18,$20,$18
-
-	.align	3
-.Loop0:
-	ldq	$3,-8($17)
-	subq	$16,8,$16
-	subq	$17,8,$17
-	subq	$20,1,$20
-	sll	$4,$19,$5
-	srl	$3,$7,$6
-	bis	$3,$3,$4
-	bis	$5,$6,$8
-	stq	$8,0($16)
-	bne	$20,.Loop0
-
-.L0:	beq	$18,.Lend
-
-	.align	3
-.Loop:	ldq	$3,-8($17)
-	subq	$16,32,$16
-	subq	$18,4,$18
-	sll	$4,$19,$5
-	srl	$3,$7,$6
-
-	ldq	$4,-16($17)
-	sll	$3,$19,$1
-	bis	$5,$6,$8
-	stq	$8,24($16)
-	srl	$4,$7,$2
-
-	ldq	$3,-24($17)
-	sll	$4,$19,$5
-	bis	$1,$2,$8
-	stq	$8,16($16)
-	srl	$3,$7,$6
-
-	ldq	$4,-32($17)
-	sll	$3,$19,$1
-	bis	$5,$6,$8
-	stq	$8,8($16)
-	srl	$4,$7,$2
-
-	subq	$17,32,$17
-	bis	$1,$2,$8
-	stq	$8,0($16)
-
-	bgt	$18,.Loop
-
-.Lend:	sll	$4,$19,$8
-	stq	$8,-8($16)
-	ret	$31,($26),1
-	.end	mpihelp_lshift
-
-
-
-
-
-/*******************
- * mpi_limb_t
- * mpihelp_rshift( mpi_ptr_t wp,	(r16)
- *		   mpi_ptr_t up,	(r17)
- *		   mpi_size_t usize,	(r18)
- *		   unsigned cnt)	(r19)
- *
- * This code runs at 4.8 cycles/limb on the 21064.  With infinite unrolling,
- * it would take 4 cycles/limb.  It should be possible to get down to 3
- * cycles/limb since both ldq and stq can be paired with the other used
- * instructions.  But there are many restrictions in the 21064 pipeline that
- * makes it hard, if not impossible, to get down to 3 cycles/limb:
- *
- * 1. ldq has a 3 cycle delay, srl and sll have a 2 cycle delay.
- * 2. Only aligned instruction pairs can be paired.
- * 3. The store buffer or silo might not be able to deal with the bandwidth.
- */
-
-	.set	noreorder
-	.set	noat
-.text
-	.align	3
-	.globl	mpihelp_rshift
-	.ent	mpihelp_rshift
-mpihelp_rshift:
-	.frame	$30,0,$26,0
-
-	ldq	$4,0($17)	# load first limb
-	addq	$17,8,$17
-	subq	$31,$19,$7
-	subq	$18,1,$18
-	and	$18,4-1,$20	# number of limbs in first loop
-	sll	$4,$7,$0	# compute function result
-
-	beq	$20,.R0
-	subq	$18,$20,$18
-
-	.align	3
-.Roop0:
-	ldq	$3,0($17)
-	addq	$16,8,$16
-	addq	$17,8,$17
-	subq	$20,1,$20
-	srl	$4,$19,$5
-	sll	$3,$7,$6
-	bis	$3,$3,$4
-	bis	$5,$6,$8
-	stq	$8,-8($16)
-	bne	$20,.Roop0
-
-.R0:	beq	$18,.Rend
-
-	.align	3
-.Roop:	ldq	$3,0($17)
-	addq	$16,32,$16
-	subq	$18,4,$18
-	srl	$4,$19,$5
-	sll	$3,$7,$6
-
-	ldq	$4,8($17)
-	srl	$3,$19,$1
-	bis	$5,$6,$8
-	stq	$8,-32($16)
-	sll	$4,$7,$2
-
-	ldq	$3,16($17)
-	srl	$4,$19,$5
-	bis	$1,$2,$8
-	stq	$8,-24($16)
-	sll	$3,$7,$6
-
-	ldq	$4,24($17)
-	srl	$3,$19,$1
-	bis	$5,$6,$8
-	stq	$8,-16($16)
-	sll	$4,$7,$2
-
-	addq	$17,32,$17
-	bis	$1,$2,$8
-	stq	$8,-8($16)
-
-	bgt	$18,.Roop
-
-.Rend:	srl	$4,$19,$8
-	stq	$8,0($16)
-	ret	$31,($26),1
-	.end	mpihelp_rshift
-
diff -urN gnupg-0.2.18/mpi/alpha/mpih-sub1.S gnupg-0.2.19/mpi/alpha/mpih-sub1.S
--- gnupg-0.2.18/mpi/alpha/mpih-sub1.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/mpi/alpha/mpih-sub1.S	Mon May 18 13:22:01 1998
@@ -0,0 +1,123 @@
+/* Alpha  sub_n -- Subtract two limb vectors of the same length > 0 and
+ *		  store difference in a third limb vector.
+ * Copyright (C) 1995, 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+
+/*******************
+ *  mpi_limb_t
+ *  mpihelp_sub_n( mpi_ptr_t res_ptr,	(r16)
+ *		   mpi_ptr_t s1_ptr,	(r17)
+ *		   mpi_ptr_t s2_ptr,	(r18)
+ *		   mpi_size_t size)	(r19)
+ */
+
+	.set	noreorder
+	.set	noat
+.text
+	.align	3
+	.globl	mpihelp_sub_n
+	.ent	mpihelp_sub_n
+mpihelp_sub_n:
+	.frame	$30,0,$26,0
+
+	ldq	$3,0($17)
+	ldq	$4,0($18)
+
+	subq	$19,1,$19
+	and	$19,4-1,$2	# number of limbs in first loop
+	bis	$31,$31,$0
+	beq	$2,.L0		# if multiple of 4 limbs, skip first loop
+
+	subq	$19,$2,$19
+
+.Loop0: subq	$2,1,$2
+	ldq	$5,8($17)
+	addq	$4,$0,$4
+	ldq	$6,8($18)
+	cmpult	$4,$0,$1
+	subq	$3,$4,$4
+	cmpult	$3,$4,$0
+	stq	$4,0($16)
+	or	$0,$1,$0
+
+	addq	$17,8,$17
+	addq	$18,8,$18
+	bis	$5,$5,$3
+	bis	$6,$6,$4
+	addq	$16,8,$16
+	bne	$2,.Loop0
+
+.L0:	beq	$19,.Lend
+
+	.align	3
+.Loop:	subq	$19,4,$19
+
+	ldq	$5,8($17)
+	addq	$4,$0,$4
+	ldq	$6,8($18)
+	cmpult	$4,$0,$1
+	subq	$3,$4,$4
+	cmpult	$3,$4,$0
+	stq	$4,0($16)
+	or	$0,$1,$0
+
+	ldq	$3,16($17)
+	addq	$6,$0,$6
+	ldq	$4,16($18)
+	cmpult	$6,$0,$1
+	subq	$5,$6,$6
+	cmpult	$5,$6,$0
+	stq	$6,8($16)
+	or	$0,$1,$0
+
+	ldq	$5,24($17)
+	addq	$4,$0,$4
+	ldq	$6,24($18)
+	cmpult	$4,$0,$1
+	subq	$3,$4,$4
+	cmpult	$3,$4,$0
+	stq	$4,16($16)
+	or	$0,$1,$0
+
+	ldq	$3,32($17)
+	addq	$6,$0,$6
+	ldq	$4,32($18)
+	cmpult	$6,$0,$1
+	subq	$5,$6,$6
+	cmpult	$5,$6,$0
+	stq	$6,24($16)
+	or	$0,$1,$0
+
+	addq	$17,32,$17
+	addq	$18,32,$18
+	addq	$16,32,$16
+	bne	$19,.Loop
+
+.Lend:	addq	$4,$0,$4
+	cmpult	$4,$0,$1
+	subq	$3,$4,$4
+	cmpult	$3,$4,$0
+	stq	$4,0($16)
+	or	$0,$1,$0
+	ret	$31,($26),1
+
+	.end	mpihelp_sub_n
+
+
diff -urN gnupg-0.2.18/mpi/config.links gnupg-0.2.19/mpi/config.links
--- gnupg-0.2.18/mpi/config.links	Wed May 13 11:04:26 1998
+++ gnupg-0.2.19/mpi/config.links	Mon May 18 12:58:06 1998
@@ -150,7 +150,7 @@
 
 # fixme: grep these modules from Makefile.in
 mpi_ln_modules="${mpi_extra_modules} mpih-add1 mpih-mul1 mpih-mul2 mpih-mul3 \
-		 mpih-shift mpih-sub1"
+		 mpih-lshift mpih-rshift mpih-sub1"
 
 mpi_ln_objects=
 mpi_ln_src=
diff -urN gnupg-0.2.18/mpi/generic/distfiles gnupg-0.2.19/mpi/generic/distfiles
--- gnupg-0.2.18/mpi/generic/distfiles	Tue Dec 23 17:40:40 1997
+++ gnupg-0.2.19/mpi/generic/distfiles	Mon May 18 12:59:44 1998
@@ -2,6 +2,7 @@
 mpih-mul1.c
 mpih-mul2.c
 mpih-mul3.c
-mpih-shift.c
+mpih-lshift.c
+mpih-rshift.c
 mpih-sub1.c
 
diff -urN gnupg-0.2.18/mpi/generic/mpih-lshift.c gnupg-0.2.19/mpi/generic/mpih-lshift.c
--- gnupg-0.2.18/mpi/generic/mpih-lshift.c	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/mpi/generic/mpih-lshift.c	Mon May 18 12:58:52 1998
@@ -0,0 +1,69 @@
+/* mpihelp-lshift.c  -	MPI helper functions
+ *	Copyright (C) 1994, 1996, 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of G10.
+ *
+ * G10 is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * G10 is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ * Note: This code is heavily based on the GNU MP Library.
+ *	 Actually it's the same code with only minor changes in the
+ *	 way the data is stored; this is to support the abstraction
+ *	 of an optional secure memory allocation which may be used
+ *	 to avoid revealing of sensitive data due to paging etc.
+ *	 The GNU MP Library itself is published under the LGPL;
+ *	 however I decided to publish this code under the plain GPL.
+ */
+
+#include <config.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include "mpi-internal.h"
+
+/* Shift U (pointed to by UP and USIZE digits long) CNT bits to the left
+ * and store the USIZE least significant digits of the result at WP.
+ * Return the bits shifted out from the most significant digit.
+ *
+ * Argument constraints:
+ * 1. 0 < CNT < BITS_PER_MP_LIMB
+ * 2. If the result is to be written over the input, WP must be >= UP.
+ */
+
+mpi_limb_t
+mpihelp_lshift( mpi_ptr_t wp, mpi_ptr_t up, mpi_size_t usize,
+					    unsigned int cnt)
+{
+    mpi_limb_t high_limb, low_limb;
+    unsigned sh_1, sh_2;
+    mpi_size_t i;
+    mpi_limb_t retval;
+
+    sh_1 = cnt;
+    wp += 1;
+    sh_2 = BITS_PER_MPI_LIMB - sh_1;
+    i = usize - 1;
+    low_limb = up[i];
+    retval = low_limb >> sh_2;
+    high_limb = low_limb;
+    while( --i >= 0 ) {
+	low_limb = up[i];
+	wp[i] = (high_limb << sh_1) | (low_limb >> sh_2);
+	high_limb = low_limb;
+    }
+    wp[i] = high_limb << sh_1;
+
+    return retval;
+}
+
+
diff -urN gnupg-0.2.18/mpi/generic/mpih-rshift.c gnupg-0.2.19/mpi/generic/mpih-rshift.c
--- gnupg-0.2.18/mpi/generic/mpih-rshift.c	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/mpi/generic/mpih-rshift.c	Mon May 18 12:59:36 1998
@@ -0,0 +1,67 @@
+/* mpih-rshift.c  -  MPI helper functions
+ *	Copyright (C) 1994, 1996, 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ * Note: This code is heavily based on the GNU MP Library.
+ *	 Actually it's the same code with only minor changes in the
+ *	 way the data is stored; this is to support the abstraction
+ *	 of an optional secure memory allocation which may be used
+ *	 to avoid revealing of sensitive data due to paging etc.
+ *	 The GNU MP Library itself is published under the LGPL;
+ *	 however I decided to publish this code under the plain GPL.
+ */
+
+#include <config.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include "mpi-internal.h"
+
+
+/* Shift U (pointed to by UP and USIZE limbs long) CNT bits to the right
+ * and store the USIZE least significant limbs of the result at WP.
+ * The bits shifted out to the right are returned.
+ *
+ * Argument constraints:
+ * 1. 0 < CNT < BITS_PER_MP_LIMB
+ * 2. If the result is to be written over the input, WP must be <= UP.
+ */
+
+mpi_limb_t
+mpihelp_rshift( mpi_ptr_t wp, mpi_ptr_t up, mpi_size_t usize, unsigned cnt)
+{
+    mpi_limb_t high_limb, low_limb;
+    unsigned sh_1, sh_2;
+    mpi_size_t i;
+    mpi_limb_t retval;
+
+    sh_1 = cnt;
+    wp -= 1;
+    sh_2 = BITS_PER_MPI_LIMB - sh_1;
+    high_limb = up[0];
+    retval = high_limb << sh_2;
+    low_limb = high_limb;
+    for( i=1; i < usize; i++) {
+	high_limb = up[i];
+	wp[i] = (low_limb >> sh_1) | (high_limb << sh_2);
+	low_limb = high_limb;
+    }
+    wp[i] = low_limb >> sh_1;
+
+    return retval;
+}
+
diff -urN gnupg-0.2.18/mpi/generic/mpih-shift.c gnupg-0.2.19/mpi/generic/mpih-shift.c
--- gnupg-0.2.18/mpi/generic/mpih-shift.c	Wed Nov 26 08:24:17 1997
+++ gnupg-0.2.19/mpi/generic/mpih-shift.c	Thu Jan  1 01:00:00 1970
@@ -1,103 +0,0 @@
-/* mpihelp-shift.c  -  MPI helper functions
- *	Copyright (c) 1997 by Werner Koch (dd9jn)
- *	Copyright (C) 1994, 1996 Free Software Foundation, Inc.
- *
- * This file is part of G10.
- *
- * G10 is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * G10 is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
- *
- * Note: This code is heavily based on the GNU MP Library.
- *	 Actually it's the same code with only minor changes in the
- *	 way the data is stored; this is to support the abstraction
- *	 of an optional secure memory allocation which may be used
- *	 to avoid revealing of sensitive data due to paging etc.
- *	 The GNU MP Library itself is published under the LGPL;
- *	 however I decided to publish this code under the plain GPL.
- */
-
-#include <config.h>
-#include <stdio.h>
-#include <stdlib.h>
-#include "mpi-internal.h"
-
-/* Shift U (pointed to by UP and USIZE digits long) CNT bits to the left
- * and store the USIZE least significant digits of the result at WP.
- * Return the bits shifted out from the most significant digit.
- *
- * Argument constraints:
- * 1. 0 < CNT < BITS_PER_MP_LIMB
- * 2. If the result is to be written over the input, WP must be >= UP.
- */
-
-mpi_limb_t
-mpihelp_lshift( mpi_ptr_t wp, mpi_ptr_t up, mpi_size_t usize,
-					    unsigned int cnt)
-{
-    mpi_limb_t high_limb, low_limb;
-    unsigned sh_1, sh_2;
-    mpi_size_t i;
-    mpi_limb_t retval;
-
-    sh_1 = cnt;
-    wp += 1;
-    sh_2 = BITS_PER_MPI_LIMB - sh_1;
-    i = usize - 1;
-    low_limb = up[i];
-    retval = low_limb >> sh_2;
-    high_limb = low_limb;
-    while( --i >= 0 ) {
-	low_limb = up[i];
-	wp[i] = (high_limb << sh_1) | (low_limb >> sh_2);
-	high_limb = low_limb;
-    }
-    wp[i] = high_limb << sh_1;
-
-    return retval;
-}
-
-
-/* Shift U (pointed to by UP and USIZE limbs long) CNT bits to the right
- * and store the USIZE least significant limbs of the result at WP.
- * The bits shifted out to the right are returned.
- *
- * Argument constraints:
- * 1. 0 < CNT < BITS_PER_MP_LIMB
- * 2. If the result is to be written over the input, WP must be <= UP.
- */
-
-mpi_limb_t
-mpihelp_rshift( mpi_ptr_t wp, mpi_ptr_t up, mpi_size_t usize, unsigned cnt)
-{
-    mpi_limb_t high_limb, low_limb;
-    unsigned sh_1, sh_2;
-    mpi_size_t i;
-    mpi_limb_t retval;
-
-    sh_1 = cnt;
-    wp -= 1;
-    sh_2 = BITS_PER_MPI_LIMB - sh_1;
-    high_limb = up[0];
-    retval = high_limb << sh_2;
-    low_limb = high_limb;
-    for( i=1; i < usize; i++) {
-	high_limb = up[i];
-	wp[i] = (low_limb >> sh_1) | (high_limb << sh_2);
-	low_limb = high_limb;
-    }
-    wp[i] = low_limb >> sh_1;
-
-    return retval;
-}
-
diff -urN gnupg-0.2.18/mpi/hppa/distfiles gnupg-0.2.19/mpi/hppa/distfiles
--- gnupg-0.2.18/mpi/hppa/distfiles	Thu Feb 12 20:16:58 1998
+++ gnupg-0.2.19/mpi/hppa/distfiles	Mon May 18 13:42:41 1998
@@ -2,5 +2,6 @@
 udiv-qrnnd.S
 mpih-add1.S
 mpih-sub1.S
-mpih-shift.S
+mpih-lshift.S
+mpih-rshift.S
 
diff -urN gnupg-0.2.18/mpi/hppa/mpih-lshift.S gnupg-0.2.19/mpi/hppa/mpih-lshift.S
--- gnupg-0.2.18/mpi/hppa/mpih-lshift.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/mpi/hppa/mpih-lshift.S	Mon May 18 13:42:13 1998
@@ -0,0 +1,72 @@
+/* hppa   lshift
+*
+ * Copyright (C) 1992, 1994, 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_lshift( mpi_ptr_t wp,	(gr26)
+ *		   mpi_ptr_t up,	(gr25)
+ *		   mpi_size_t usize,	(gr24)
+ *		   unsigned cnt)	(gr23)
+ */
+
+	.code
+	.export 	mpihelp_lshift
+mpihelp_lshift
+	.proc
+	.callinfo	frame=64,no_calls
+	.entry
+
+	sh2add		%r24,%r25,%r25
+	sh2add		%r24,%r26,%r26
+	ldws,mb 	-4(0,%r25),%r22
+	subi		32,%r23,%r1
+	mtsar		%r1
+	addib,= 	-1,%r24,L$0004
+	vshd		%r0,%r22,%r28		; compute carry out limb
+	ldws,mb 	-4(0,%r25),%r29
+	addib,= 	-1,%r24,L$0002
+	vshd		%r22,%r29,%r20
+
+L$loop	ldws,mb 	-4(0,%r25),%r22
+	stws,mb 	%r20,-4(0,%r26)
+	addib,= 	-1,%r24,L$0003
+	vshd		%r29,%r22,%r20
+	ldws,mb 	-4(0,%r25),%r29
+	stws,mb 	%r20,-4(0,%r26)
+	addib,<>	-1,%r24,L$loop
+	vshd		%r22,%r29,%r20
+
+L$0002	stws,mb 	%r20,-4(0,%r26)
+	vshd		%r29,%r0,%r20
+	bv		0(%r2)
+	stw		%r20,-4(0,%r26)
+L$0003	stws,mb 	%r20,-4(0,%r26)
+L$0004	vshd		%r22,%r0,%r20
+	bv		0(%r2)
+	stw		%r20,-4(0,%r26)
+
+	.exit
+	.procend
+
+
+
diff -urN gnupg-0.2.18/mpi/hppa/mpih-rshift.S gnupg-0.2.19/mpi/hppa/mpih-rshift.S
--- gnupg-0.2.18/mpi/hppa/mpih-rshift.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/mpi/hppa/mpih-rshift.S	Mon May 18 13:42:32 1998
@@ -0,0 +1,68 @@
+/* hppa   rshift
+*
+ * Copyright (C) 1992, 1994, 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_rshift( mpi_ptr_t wp,       (gr26)
+ *		   mpi_ptr_t up,       (gr25)
+ *		   mpi_size_t usize,   (gr24)
+ *		   unsigned cnt)       (gr23)
+ */
+
+	.code
+	.export 	mpihelp_rshift
+mpihelp_rshift
+	.proc
+	.callinfo	frame=64,no_calls
+	.entry
+
+	ldws,ma 	4(0,%r25),%r22
+	mtsar		%r23
+	addib,= 	-1,%r24,L$r004
+	vshd		%r22,%r0,%r28		; compute carry out limb
+	ldws,ma 	4(0,%r25),%r29
+	addib,= 	-1,%r24,L$r002
+	vshd		%r29,%r22,%r20
+
+L$roop	ldws,ma 	4(0,%r25),%r22
+	stws,ma 	%r20,4(0,%r26)
+	addib,= 	-1,%r24,L$r003
+	vshd		%r22,%r29,%r20
+	ldws,ma 	4(0,%r25),%r29
+	stws,ma 	%r20,4(0,%r26)
+	addib,<>	-1,%r24,L$roop
+	vshd		%r29,%r22,%r20
+
+L$r002	stws,ma 	%r20,4(0,%r26)
+	vshd		%r0,%r29,%r20
+	bv		0(%r2)
+	stw		%r20,0(0,%r26)
+L$r003	stws,ma 	%r20,4(0,%r26)
+L$r004	vshd		%r0,%r22,%r20
+	bv		0(%r2)
+	stw		%r20,0(0,%r26)
+
+	.exit
+	.procend
+
diff -urN gnupg-0.2.18/mpi/hppa/mpih-shift.S gnupg-0.2.19/mpi/hppa/mpih-shift.S
--- gnupg-0.2.18/mpi/hppa/mpih-shift.S	Mon Feb 23 13:18:13 1998
+++ gnupg-0.2.19/mpi/hppa/mpih-shift.S	Thu Jan  1 01:00:00 1970
@@ -1,124 +0,0 @@
-/* hppa   rshift, lshift
- *	Copyright (C) 1992, 1994 Free Software Foundation, Inc.
- *	Copyright (C) 1998 Free Software Foundation, Inc.
- *
- * This file is part of GNUPG.
- *
- * GNUPG is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * GNUPG is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
- *
- * Note: This code is heavily based on the GNU MP Library.
- *	 Actually it's the same code with only minor changes in the
- *	 way the data is stored; this is to support the abstraction
- *	 of an optional secure memory allocation which may be used
- *	 to avoid revealing of sensitive data due to paging etc.
- *	 The GNU MP Library itself is published under the LGPL;
- *	 however I decided to publish this code under the plain GPL.
- */
-
-
-
-/*******************
- * mpi_limb_t
- * mpihelp_lshift( mpi_ptr_t wp,	(gr26)
- *		   mpi_ptr_t up,	(gr25)
- *		   mpi_size_t usize,	(gr24)
- *		   unsigned cnt)	(gr23)
- */
-
-	.code
-	.export 	mpihelp_lshift
-mpihelp_lshift
-	.proc
-	.callinfo	frame=64,no_calls
-	.entry
-
-	sh2add		%r24,%r25,%r25
-	sh2add		%r24,%r26,%r26
-	ldws,mb 	-4(0,%r25),%r22
-	subi		32,%r23,%r1
-	mtsar		%r1
-	addib,= 	-1,%r24,L$0004
-	vshd		%r0,%r22,%r28		; compute carry out limb
-	ldws,mb 	-4(0,%r25),%r29
-	addib,= 	-1,%r24,L$0002
-	vshd		%r22,%r29,%r20
-
-L$loop	ldws,mb 	-4(0,%r25),%r22
-	stws,mb 	%r20,-4(0,%r26)
-	addib,= 	-1,%r24,L$0003
-	vshd		%r29,%r22,%r20
-	ldws,mb 	-4(0,%r25),%r29
-	stws,mb 	%r20,-4(0,%r26)
-	addib,<>	-1,%r24,L$loop
-	vshd		%r22,%r29,%r20
-
-L$0002	stws,mb 	%r20,-4(0,%r26)
-	vshd		%r29,%r0,%r20
-	bv		0(%r2)
-	stw		%r20,-4(0,%r26)
-L$0003	stws,mb 	%r20,-4(0,%r26)
-L$0004	vshd		%r22,%r0,%r20
-	bv		0(%r2)
-	stw		%r20,-4(0,%r26)
-
-	.exit
-	.procend
-
-
-
-/*******************
- * mpi_limb_t
- * mpihelp_rshift( mpi_ptr_t wp,       (gr26)
- *		   mpi_ptr_t up,       (gr25)
- *		   mpi_size_t usize,   (gr24)
- *		   unsigned cnt)       (gr23)
- */
-
-	.code
-	.export 	mpihelp_rshift
-mpihelp_rshift
-	.proc
-	.callinfo	frame=64,no_calls
-	.entry
-
-	ldws,ma 	4(0,%r25),%r22
-	mtsar		%r23
-	addib,= 	-1,%r24,L$r004
-	vshd		%r22,%r0,%r28		; compute carry out limb
-	ldws,ma 	4(0,%r25),%r29
-	addib,= 	-1,%r24,L$r002
-	vshd		%r29,%r22,%r20
-
-L$roop	ldws,ma 	4(0,%r25),%r22
-	stws,ma 	%r20,4(0,%r26)
-	addib,= 	-1,%r24,L$r003
-	vshd		%r22,%r29,%r20
-	ldws,ma 	4(0,%r25),%r29
-	stws,ma 	%r20,4(0,%r26)
-	addib,<>	-1,%r24,L$roop
-	vshd		%r29,%r22,%r20
-
-L$r002	stws,ma 	%r20,4(0,%r26)
-	vshd		%r0,%r29,%r20
-	bv		0(%r2)
-	stw		%r20,0(0,%r26)
-L$r003	stws,ma 	%r20,4(0,%r26)
-L$r004	vshd		%r0,%r22,%r20
-	bv		0(%r2)
-	stw		%r20,0(0,%r26)
-
-	.exit
-	.procend
-
diff -urN gnupg-0.2.18/mpi/i386/distfiles gnupg-0.2.19/mpi/i386/distfiles
--- gnupg-0.2.18/mpi/i386/distfiles	Tue Dec 23 18:02:26 1997
+++ gnupg-0.2.19/mpi/i386/distfiles	Mon May 18 12:55:39 1998
@@ -2,7 +2,8 @@
 mpih-mul1.S
 mpih-mul2.S
 mpih-mul3.S
-mpih-shift.S
+mpih-lshift.S
+mpih-rshift.S
 mpih-sub1.S
 syntax.h
 
diff -urN gnupg-0.2.18/mpi/i386/mpih-lshift.S gnupg-0.2.19/mpi/i386/mpih-lshift.S
--- gnupg-0.2.18/mpi/i386/mpih-lshift.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/mpi/i386/mpih-lshift.S	Mon May 18 12:54:53 1998
@@ -0,0 +1,96 @@
+/* i80386   lshift
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *	Copyright (C) 1992, 1994 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ * Note: This code is heavily based on the GNU MP Library.
+ *	 Actually it's the same code with only minor changes in the
+ *	 way the data is stored; this is to support the abstraction
+ *	 of an optional secure memory allocation which may be used
+ *	 to avoid revealing of sensitive data due to paging etc.
+ *	 The GNU MP Library itself is published under the LGPL;
+ *	 however I decided to publish this code under the plain GPL.
+ */
+
+
+#include "sysdep.h"
+#include "asm-syntax.h"
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_lshift( mpi_ptr_t wp,	(sp + 4)
+ *		   mpi_ptr_t up,	(sp + 8)
+ *		   mpi_size_t usize,	(sp + 12)
+ *		   unsigned cnt)	(sp + 16)
+ */
+
+.text
+	ALIGN (3)
+	.globl C_SYMBOL_NAME(mpihelp_lshift)
+C_SYMBOL_NAME(mpihelp_lshift:)
+	pushl	%edi
+	pushl	%esi
+	pushl	%ebx
+
+	movl	16(%esp),%edi		/* res_ptr */
+	movl	20(%esp),%esi		/* s_ptr */
+	movl	24(%esp),%edx		/* size */
+	movl	28(%esp),%ecx		/* cnt */
+
+	subl	$4,%esi 		/* adjust s_ptr */
+
+	movl	(%esi,%edx,4),%ebx	/* read most significant limb */
+	xorl	%eax,%eax
+	shldl	%cl,%ebx,%eax		/* compute carry limb */
+	decl	%edx
+	jz	Lend
+	pushl	%eax			/* push carry limb onto stack */
+	testb	$1,%edx
+	jnz	L1			/* enter loop in the middle */
+	movl	%ebx,%eax
+
+	ALIGN (3)
+Loop:	movl	(%esi,%edx,4),%ebx	/* load next lower limb */
+	shldl	%cl,%ebx,%eax		/* compute result limb */
+	movl	%eax,(%edi,%edx,4)	/* store it */
+	decl	%edx
+L1:	movl	(%esi,%edx,4),%eax
+	shldl	%cl,%eax,%ebx
+	movl	%ebx,(%edi,%edx,4)
+	decl	%edx
+	jnz	Loop
+
+	shll	%cl,%eax		/* compute least significant limb */
+	movl	%eax,(%edi)		/* store it */
+
+	popl	%eax			/* pop carry limb */
+
+	popl	%ebx
+	popl	%esi
+	popl	%edi
+	ret
+
+Lend:	shll	%cl,%ebx		/* compute least significant limb */
+	movl	%ebx,(%edi)		/* store it */
+
+	popl	%ebx
+	popl	%esi
+	popl	%edi
+	ret
+
diff -urN gnupg-0.2.18/mpi/i386/mpih-rshift.S gnupg-0.2.19/mpi/i386/mpih-rshift.S
--- gnupg-0.2.18/mpi/i386/mpih-rshift.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/mpi/i386/mpih-rshift.S	Mon May 18 12:55:22 1998
@@ -0,0 +1,98 @@
+/* i80386   rshift
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *	Copyright (C) 1992, 1994 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ * Note: This code is heavily based on the GNU MP Library.
+ *	 Actually it's the same code with only minor changes in the
+ *	 way the data is stored; this is to support the abstraction
+ *	 of an optional secure memory allocation which may be used
+ *	 to avoid revealing of sensitive data due to paging etc.
+ *	 The GNU MP Library itself is published under the LGPL;
+ *	 however I decided to publish this code under the plain GPL.
+ */
+
+
+#include "sysdep.h"
+#include "asm-syntax.h"
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_rshift( mpi_ptr_t wp,	(sp + 4)
+ *		   mpi_ptr_t up,	(sp + 8)
+ *		   mpi_size_t usize,	(sp + 12)
+ *		   unsigned cnt)	(sp + 16)
+ */
+
+.text
+	ALIGN (3)
+	.globl C_SYMBOL_NAME(mpihelp_rshift)
+C_SYMBOL_NAME(mpihelp_rshift:)
+	pushl	%edi
+	pushl	%esi
+	pushl	%ebx
+
+	movl	16(%esp),%edi		/* wp */
+	movl	20(%esp),%esi		/* up */
+	movl	24(%esp),%edx		/* usize */
+	movl	28(%esp),%ecx		/* cnt */
+
+	leal	-4(%edi,%edx,4),%edi
+	leal	(%esi,%edx,4),%esi
+	negl	%edx
+
+	movl	(%esi,%edx,4),%ebx	/* read least significant limb */
+	xorl	%eax,%eax
+	shrdl	%cl,%ebx,%eax		/* compute carry limb */
+	incl	%edx
+	jz	Lend2
+	pushl	%eax			/* push carry limb onto stack */
+	testb	$1,%edx
+	jnz	L2			/* enter loop in the middle */
+	movl	%ebx,%eax
+
+	ALIGN (3)
+Loop2:	 movl	 (%esi,%edx,4),%ebx	 /* load next higher limb */
+	shrdl	%cl,%ebx,%eax		/* compute result limb */
+	movl	%eax,(%edi,%edx,4)	/* store it */
+	incl	%edx
+L2:	movl	(%esi,%edx,4),%eax
+	shrdl	%cl,%eax,%ebx
+	movl	%ebx,(%edi,%edx,4)
+	incl	%edx
+	jnz	Loop2
+
+	shrl	%cl,%eax		/* compute most significant limb */
+	movl	%eax,(%edi)		/* store it */
+
+	popl	%eax			/* pop carry limb */
+
+	popl	%ebx
+	popl	%esi
+	popl	%edi
+	ret
+
+Lend2:	shrl	%cl,%ebx		/* compute most significant limb */
+	movl	%ebx,(%edi)		/* store it */
+
+	popl	%ebx
+	popl	%esi
+	popl	%edi
+	ret
+
diff -urN gnupg-0.2.18/mpi/i386/mpih-shift.S gnupg-0.2.19/mpi/i386/mpih-shift.S
--- gnupg-0.2.18/mpi/i386/mpih-shift.S	Mon Feb 23 13:17:16 1998
+++ gnupg-0.2.19/mpi/i386/mpih-shift.S	Thu Jan  1 01:00:00 1970
@@ -1,160 +0,0 @@
-/* i80386   rshift, lshift
- *	Copyright (C) 1998 Free Software Foundation, Inc.
- *	Copyright (C) 1992, 1994 Free Software Foundation, Inc.
- *
- * This file is part of GNUPG.
- *
- * GNUPG is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * GNUPG is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
- *
- * Note: This code is heavily based on the GNU MP Library.
- *	 Actually it's the same code with only minor changes in the
- *	 way the data is stored; this is to support the abstraction
- *	 of an optional secure memory allocation which may be used
- *	 to avoid revealing of sensitive data due to paging etc.
- *	 The GNU MP Library itself is published under the LGPL;
- *	 however I decided to publish this code under the plain GPL.
- */
-
-
-#include "sysdep.h"
-#include "asm-syntax.h"
-
-
-/*******************
- * mpi_limb_t
- * mpihelp_lshift( mpi_ptr_t wp,	(sp + 4)
- *		   mpi_ptr_t up,	(sp + 8)
- *		   mpi_size_t usize,	(sp + 12)
- *		   unsigned cnt)	(sp + 16)
- */
-
-.text
-	ALIGN (3)
-	.globl C_SYMBOL_NAME(mpihelp_lshift)
-C_SYMBOL_NAME(mpihelp_lshift:)
-	pushl	%edi
-	pushl	%esi
-	pushl	%ebx
-
-	movl	16(%esp),%edi		/* res_ptr */
-	movl	20(%esp),%esi		/* s_ptr */
-	movl	24(%esp),%edx		/* size */
-	movl	28(%esp),%ecx		/* cnt */
-
-	subl	$4,%esi 		/* adjust s_ptr */
-
-	movl	(%esi,%edx,4),%ebx	/* read most significant limb */
-	xorl	%eax,%eax
-	shldl	%cl,%ebx,%eax		/* compute carry limb */
-	decl	%edx
-	jz	Lend
-	pushl	%eax			/* push carry limb onto stack */
-	testb	$1,%edx
-	jnz	L1			/* enter loop in the middle */
-	movl	%ebx,%eax
-
-	ALIGN (3)
-Loop:	movl	(%esi,%edx,4),%ebx	/* load next lower limb */
-	shldl	%cl,%ebx,%eax		/* compute result limb */
-	movl	%eax,(%edi,%edx,4)	/* store it */
-	decl	%edx
-L1:	movl	(%esi,%edx,4),%eax
-	shldl	%cl,%eax,%ebx
-	movl	%ebx,(%edi,%edx,4)
-	decl	%edx
-	jnz	Loop
-
-	shll	%cl,%eax		/* compute least significant limb */
-	movl	%eax,(%edi)		/* store it */
-
-	popl	%eax			/* pop carry limb */
-
-	popl	%ebx
-	popl	%esi
-	popl	%edi
-	ret
-
-Lend:	shll	%cl,%ebx		/* compute least significant limb */
-	movl	%ebx,(%edi)		/* store it */
-
-	popl	%ebx
-	popl	%esi
-	popl	%edi
-	ret
-
-/*******************
- * mpi_limb_t
- * mpihelp_rshift( mpi_ptr_t wp,	(sp + 4)
- *		   mpi_ptr_t up,	(sp + 8)
- *		   mpi_size_t usize,	(sp + 12)
- *		   unsigned cnt)	(sp + 16)
- */
-
-.text
-	ALIGN (3)
-	.globl C_SYMBOL_NAME(mpihelp_rshift)
-C_SYMBOL_NAME(mpihelp_rshift:)
-	pushl	%edi
-	pushl	%esi
-	pushl	%ebx
-
-	movl	16(%esp),%edi		/* wp */
-	movl	20(%esp),%esi		/* up */
-	movl	24(%esp),%edx		/* usize */
-	movl	28(%esp),%ecx		/* cnt */
-
-	leal	-4(%edi,%edx,4),%edi
-	leal	(%esi,%edx,4),%esi
-	negl	%edx
-
-	movl	(%esi,%edx,4),%ebx	/* read least significant limb */
-	xorl	%eax,%eax
-	shrdl	%cl,%ebx,%eax		/* compute carry limb */
-	incl	%edx
-	jz	Lend2
-	pushl	%eax			/* push carry limb onto stack */
-	testb	$1,%edx
-	jnz	L2			/* enter loop in the middle */
-	movl	%ebx,%eax
-
-	ALIGN (3)
-Loop2:	 movl	 (%esi,%edx,4),%ebx	 /* load next higher limb */
-	shrdl	%cl,%ebx,%eax		/* compute result limb */
-	movl	%eax,(%edi,%edx,4)	/* store it */
-	incl	%edx
-L2:	movl	(%esi,%edx,4),%eax
-	shrdl	%cl,%eax,%ebx
-	movl	%ebx,(%edi,%edx,4)
-	incl	%edx
-	jnz	Loop2
-
-	shrl	%cl,%eax		/* compute most significant limb */
-	movl	%eax,(%edi)		/* store it */
-
-	popl	%eax			/* pop carry limb */
-
-	popl	%ebx
-	popl	%esi
-	popl	%edi
-	ret
-
-Lend2:	shrl	%cl,%ebx		/* compute most significant limb */
-	movl	%ebx,(%edi)		/* store it */
-
-	popl	%ebx
-	popl	%esi
-	popl	%edi
-	ret
-
diff -urN gnupg-0.2.18/mpi/i586/distfiles gnupg-0.2.19/mpi/i586/distfiles
--- gnupg-0.2.18/mpi/i586/distfiles	Wed Feb 11 04:03:50 1998
+++ gnupg-0.2.19/mpi/i586/distfiles	Mon May 18 12:57:18 1998
@@ -2,7 +2,8 @@
 mpih-mul1.S
 mpih-mul2.S
 mpih-mul3.S
-mpih-shift.S
+mpih-lshift.S
+mpih-rshift.S
 mpih-sub1.S
 README
 
diff -urN gnupg-0.2.18/mpi/i586/mpih-lshift.S gnupg-0.2.19/mpi/i586/mpih-lshift.S
--- gnupg-0.2.18/mpi/i586/mpih-lshift.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/mpi/i586/mpih-lshift.S	Mon May 18 12:56:33 1998
@@ -0,0 +1,230 @@
+/* i80586   lshift
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *	Copyright (C) 1992, 1994 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ * Note: This code is heavily based on the GNU MP Library.
+ *	 Actually it's the same code with only minor changes in the
+ *	 way the data is stored; this is to support the abstraction
+ *	 of an optional secure memory allocation which may be used
+ *	 to avoid revealing of sensitive data due to paging etc.
+ *	 The GNU MP Library itself is published under the LGPL;
+ *	 however I decided to publish this code under the plain GPL.
+ */
+
+
+#include "sysdep.h"
+#include "asm-syntax.h"
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_lshift( mpi_ptr_t wp,	(sp + 4)
+ *		   mpi_ptr_t up,	(sp + 8)
+ *		   mpi_size_t usize,	(sp + 12)
+ *		   unsigned cnt)	(sp + 16)
+ */
+
+.text
+	ALIGN (3)
+	.globl C_SYMBOL_NAME(mpihelp_lshift)
+C_SYMBOL_NAME(mpihelp_lshift:)
+
+	pushl	%edi
+	pushl	%esi
+	pushl	%ebx
+	pushl	%ebp
+
+	movl	20(%esp),%edi		/* res_ptr */
+	movl	24(%esp),%esi		/* s_ptr */
+	movl	28(%esp),%ebp		/* size */
+	movl	32(%esp),%ecx		/* cnt */
+
+/* We can use faster code for shift-by-1 under certain conditions.  */
+	cmp	$1,%ecx
+	jne	Lnormal
+	leal	4(%esi),%eax
+	cmpl	%edi,%eax
+	jnc	Lspecial		/* jump if s_ptr + 1 >= res_ptr */
+	leal	(%esi,%ebp,4),%eax
+	cmpl	%eax,%edi
+	jnc	Lspecial		/* jump if res_ptr >= s_ptr + size */
+
+Lnormal:
+	leal	-4(%edi,%ebp,4),%edi
+	leal	-4(%esi,%ebp,4),%esi
+
+	movl	(%esi),%edx
+	subl	$4,%esi
+	xorl	%eax,%eax
+	shldl	%cl,%edx,%eax		/* compute carry limb */
+	pushl	%eax			/* push carry limb onto stack */
+
+	decl	%ebp
+	pushl	%ebp
+	shrl	$3,%ebp
+	jz	Lend
+
+	movl	(%edi),%eax		/* fetch destination cache line */
+
+	ALIGN	(2)
+Loop:	movl	-28(%edi),%eax		/* fetch destination cache line */
+	movl	%edx,%ebx
+
+	movl	(%esi),%eax
+	movl	-4(%esi),%edx
+	shldl	%cl,%eax,%ebx
+	shldl	%cl,%edx,%eax
+	movl	%ebx,(%edi)
+	movl	%eax,-4(%edi)
+
+	movl	-8(%esi),%ebx
+	movl	-12(%esi),%eax
+	shldl	%cl,%ebx,%edx
+	shldl	%cl,%eax,%ebx
+	movl	%edx,-8(%edi)
+	movl	%ebx,-12(%edi)
+
+	movl	-16(%esi),%edx
+	movl	-20(%esi),%ebx
+	shldl	%cl,%edx,%eax
+	shldl	%cl,%ebx,%edx
+	movl	%eax,-16(%edi)
+	movl	%edx,-20(%edi)
+
+	movl	-24(%esi),%eax
+	movl	-28(%esi),%edx
+	shldl	%cl,%eax,%ebx
+	shldl	%cl,%edx,%eax
+	movl	%ebx,-24(%edi)
+	movl	%eax,-28(%edi)
+
+	subl	$32,%esi
+	subl	$32,%edi
+	decl	%ebp
+	jnz	Loop
+
+Lend:	popl	%ebp
+	andl	$7,%ebp
+	jz	Lend2
+Loop2:	movl	(%esi),%eax
+	shldl	%cl,%eax,%edx
+	movl	%edx,(%edi)
+	movl	%eax,%edx
+	subl	$4,%esi
+	subl	$4,%edi
+	decl	%ebp
+	jnz	Loop2
+
+Lend2:	shll	%cl,%edx		/* compute least significant limb */
+	movl	%edx,(%edi)		/* store it */
+
+	popl	%eax			/* pop carry limb */
+
+	popl	%ebp
+	popl	%ebx
+	popl	%esi
+	popl	%edi
+	ret
+
+/* We loop from least significant end of the arrays, which is only
+   permissable if the source and destination don't overlap, since the
+   function is documented to work for overlapping source and destination.
+*/
+
+Lspecial:
+	movl	(%esi),%edx
+	addl	$4,%esi
+
+	decl	%ebp
+	pushl	%ebp
+	shrl	$3,%ebp
+
+	addl	%edx,%edx
+	incl	%ebp
+	decl	%ebp
+	jz	LLend
+
+	movl	(%edi),%eax		/* fetch destination cache line */
+
+	ALIGN	(2)
+LLoop:	movl	28(%edi),%eax		/* fetch destination cache line */
+	movl	%edx,%ebx
+
+	movl	(%esi),%eax
+	movl	4(%esi),%edx
+	adcl	%eax,%eax
+	movl	%ebx,(%edi)
+	adcl	%edx,%edx
+	movl	%eax,4(%edi)
+
+	movl	8(%esi),%ebx
+	movl	12(%esi),%eax
+	adcl	%ebx,%ebx
+	movl	%edx,8(%edi)
+	adcl	%eax,%eax
+	movl	%ebx,12(%edi)
+
+	movl	16(%esi),%edx
+	movl	20(%esi),%ebx
+	adcl	%edx,%edx
+	movl	%eax,16(%edi)
+	adcl	%ebx,%ebx
+	movl	%edx,20(%edi)
+
+	movl	24(%esi),%eax
+	movl	28(%esi),%edx
+	adcl	%eax,%eax
+	movl	%ebx,24(%edi)
+	adcl	%edx,%edx
+	movl	%eax,28(%edi)
+
+	leal	32(%esi),%esi		/* use leal not to clobber carry */
+	leal	32(%edi),%edi
+	decl	%ebp
+	jnz	LLoop
+
+LLend:	popl	%ebp
+	sbbl	%eax,%eax		/* save carry in %eax */
+	andl	$7,%ebp
+	jz	LLend2
+	addl	%eax,%eax		/* restore carry from eax */
+LLoop2: movl	%edx,%ebx
+	movl	(%esi),%edx
+	adcl	%edx,%edx
+	movl	%ebx,(%edi)
+
+	leal	4(%esi),%esi		/* use leal not to clobber carry */
+	leal	4(%edi),%edi
+	decl	%ebp
+	jnz	LLoop2
+
+	jmp	LL1
+LLend2: addl	%eax,%eax		/* restore carry from eax */
+LL1:	movl	%edx,(%edi)		/* store last limb */
+
+	sbbl	%eax,%eax
+	negl	%eax
+
+	popl	%ebp
+	popl	%ebx
+	popl	%esi
+	popl	%edi
+	ret
+
+
diff -urN gnupg-0.2.18/mpi/i586/mpih-rshift.S gnupg-0.2.19/mpi/i586/mpih-rshift.S
--- gnupg-0.2.18/mpi/i586/mpih-rshift.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/mpi/i586/mpih-rshift.S	Mon May 18 12:57:00 1998
@@ -0,0 +1,229 @@
+/* i80586   rshift
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *	Copyright (C) 1992, 1994 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ *
+ * Note: This code is heavily based on the GNU MP Library.
+ *	 Actually it's the same code with only minor changes in the
+ *	 way the data is stored; this is to support the abstraction
+ *	 of an optional secure memory allocation which may be used
+ *	 to avoid revealing of sensitive data due to paging etc.
+ *	 The GNU MP Library itself is published under the LGPL;
+ *	 however I decided to publish this code under the plain GPL.
+ */
+
+
+#include "sysdep.h"
+#include "asm-syntax.h"
+
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_rshift( mpi_ptr_t wp,	(sp + 4)
+ *		   mpi_ptr_t up,	(sp + 8)
+ *		   mpi_size_t usize,	(sp + 12)
+ *		   unsigned cnt)	(sp + 16)
+ */
+
+.text
+	ALIGN (3)
+	.globl C_SYMBOL_NAME(mpihelp_rshift)
+C_SYMBOL_NAME(mpihelp_rshift:)
+	pushl	%edi
+	pushl	%esi
+	pushl	%ebx
+	pushl	%ebp
+
+	movl	20(%esp),%edi		/* res_ptr */
+	movl	24(%esp),%esi		/* s_ptr */
+	movl	28(%esp),%ebp		/* size */
+	movl	32(%esp),%ecx		/* cnt */
+
+/* We can use faster code for shift-by-1 under certain conditions.  */
+	cmp	$1,%ecx
+	jne	Rnormal
+	leal	4(%edi),%eax
+	cmpl	%esi,%eax
+	jnc	Rspecial		/* jump if res_ptr + 1 >= s_ptr */
+	leal	(%edi,%ebp,4),%eax
+	cmpl	%eax,%esi
+	jnc	Rspecial		/* jump if s_ptr >= res_ptr + size */
+
+Rnormal:
+	movl	(%esi),%edx
+	addl	$4,%esi
+	xorl	%eax,%eax
+	shrdl	%cl,%edx,%eax		/* compute carry limb */
+	pushl	%eax			/* push carry limb onto stack */
+
+	decl	%ebp
+	pushl	%ebp
+	shrl	$3,%ebp
+	jz	Rend
+
+	movl	(%edi),%eax		/* fetch destination cache line */
+
+	ALIGN	(2)
+Roop:	movl	28(%edi),%eax		/* fetch destination cache line */
+	movl	%edx,%ebx
+
+	movl	(%esi),%eax
+	movl	4(%esi),%edx
+	shrdl	%cl,%eax,%ebx
+	shrdl	%cl,%edx,%eax
+	movl	%ebx,(%edi)
+	movl	%eax,4(%edi)
+
+	movl	8(%esi),%ebx
+	movl	12(%esi),%eax
+	shrdl	%cl,%ebx,%edx
+	shrdl	%cl,%eax,%ebx
+	movl	%edx,8(%edi)
+	movl	%ebx,12(%edi)
+
+	movl	16(%esi),%edx
+	movl	20(%esi),%ebx
+	shrdl	%cl,%edx,%eax
+	shrdl	%cl,%ebx,%edx
+	movl	%eax,16(%edi)
+	movl	%edx,20(%edi)
+
+	movl	24(%esi),%eax
+	movl	28(%esi),%edx
+	shrdl	%cl,%eax,%ebx
+	shrdl	%cl,%edx,%eax
+	movl	%ebx,24(%edi)
+	movl	%eax,28(%edi)
+
+	addl	$32,%esi
+	addl	$32,%edi
+	decl	%ebp
+	jnz	Roop
+
+Rend:	popl	%ebp
+	andl	$7,%ebp
+	jz	Rend2
+Roop2:	movl	(%esi),%eax
+	shrdl	%cl,%eax,%edx		/* compute result limb */
+	movl	%edx,(%edi)
+	movl	%eax,%edx
+	addl	$4,%esi
+	addl	$4,%edi
+	decl	%ebp
+	jnz	Roop2
+
+Rend2:	shrl	%cl,%edx		/* compute most significant limb */
+	movl	%edx,(%edi)		/* store it */
+
+	popl	%eax			/* pop carry limb */
+
+	popl	%ebp
+	popl	%ebx
+	popl	%esi
+	popl	%edi
+	ret
+
+/* We loop from least significant end of the arrays, which is only
+   permissable if the source and destination don't overlap, since the
+   function is documented to work for overlapping source and destination.
+*/
+
+Rspecial:
+	leal	-4(%edi,%ebp,4),%edi
+	leal	-4(%esi,%ebp,4),%esi
+
+	movl	(%esi),%edx
+	subl	$4,%esi
+
+	decl	%ebp
+	pushl	%ebp
+	shrl	$3,%ebp
+
+	shrl	$1,%edx
+	incl	%ebp
+	decl	%ebp
+	jz	RLend
+
+	movl	(%edi),%eax		/* fetch destination cache line */
+
+	ALIGN	(2)
+RLoop:	movl	-28(%edi),%eax		/* fetch destination cache line */
+	movl	%edx,%ebx
+
+	movl	(%esi),%eax
+	movl	-4(%esi),%edx
+	rcrl	$1,%eax
+	movl	%ebx,(%edi)
+	rcrl	$1,%edx
+	movl	%eax,-4(%edi)
+
+	movl	-8(%esi),%ebx
+	movl	-12(%esi),%eax
+	rcrl	$1,%ebx
+	movl	%edx,-8(%edi)
+	rcrl	$1,%eax
+	movl	%ebx,-12(%edi)
+
+	movl	-16(%esi),%edx
+	movl	-20(%esi),%ebx
+	rcrl	$1,%edx
+	movl	%eax,-16(%edi)
+	rcrl	$1,%ebx
+	movl	%edx,-20(%edi)
+
+	movl	-24(%esi),%eax
+	movl	-28(%esi),%edx
+	rcrl	$1,%eax
+	movl	%ebx,-24(%edi)
+	rcrl	$1,%edx
+	movl	%eax,-28(%edi)
+
+	leal	-32(%esi),%esi		/* use leal not to clobber carry */
+	leal	-32(%edi),%edi
+	decl	%ebp
+	jnz	RLoop
+
+RLend:	popl	%ebp
+	sbbl	%eax,%eax		/* save carry in %eax */
+	andl	$7,%ebp
+	jz	RLend2
+	addl	%eax,%eax		/* restore carry from eax */
+RLoop2: movl	%edx,%ebx
+	movl	(%esi),%edx
+	rcrl	$1,%edx
+	movl	%ebx,(%edi)
+
+	leal	-4(%esi),%esi		/* use leal not to clobber carry */
+	leal	-4(%edi),%edi
+	decl	%ebp
+	jnz	RLoop2
+
+	jmp	RL1
+RLend2: addl	%eax,%eax		/* restore carry from eax */
+RL1:	movl	%edx,(%edi)		/* store last limb */
+
+	movl	$0,%eax
+	rcrl	$1,%eax
+
+	popl	%ebp
+	popl	%ebx
+	popl	%esi
+	popl	%edi
+	ret
+
diff -urN gnupg-0.2.18/mpi/i586/mpih-shift.S gnupg-0.2.19/mpi/i586/mpih-shift.S
--- gnupg-0.2.18/mpi/i586/mpih-shift.S	Mon Feb 23 13:17:49 1998
+++ gnupg-0.2.19/mpi/i586/mpih-shift.S	Thu Jan  1 01:00:00 1970
@@ -1,426 +0,0 @@
-/* i80586   rshift, lshift
- *	Copyright (C) 1998 Free Software Foundation, Inc.
- *	Copyright (C) 1992, 1994 Free Software Foundation, Inc.
- *
- * This file is part of GNUPG.
- *
- * GNUPG is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * GNUPG is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
- *
- * Note: This code is heavily based on the GNU MP Library.
- *	 Actually it's the same code with only minor changes in the
- *	 way the data is stored; this is to support the abstraction
- *	 of an optional secure memory allocation which may be used
- *	 to avoid revealing of sensitive data due to paging etc.
- *	 The GNU MP Library itself is published under the LGPL;
- *	 however I decided to publish this code under the plain GPL.
- */
-
-
-#include "sysdep.h"
-#include "asm-syntax.h"
-
-
-/*******************
- * mpi_limb_t
- * mpihelp_lshift( mpi_ptr_t wp,	(sp + 4)
- *		   mpi_ptr_t up,	(sp + 8)
- *		   mpi_size_t usize,	(sp + 12)
- *		   unsigned cnt)	(sp + 16)
- */
-
-.text
-	ALIGN (3)
-	.globl C_SYMBOL_NAME(mpihelp_lshift)
-C_SYMBOL_NAME(mpihelp_lshift:)
-
-	pushl	%edi
-	pushl	%esi
-	pushl	%ebx
-	pushl	%ebp
-
-	movl	20(%esp),%edi		/* res_ptr */
-	movl	24(%esp),%esi		/* s_ptr */
-	movl	28(%esp),%ebp		/* size */
-	movl	32(%esp),%ecx		/* cnt */
-
-/* We can use faster code for shift-by-1 under certain conditions.  */
-	cmp	$1,%ecx
-	jne	Lnormal
-	leal	4(%esi),%eax
-	cmpl	%edi,%eax
-	jnc	Lspecial		/* jump if s_ptr + 1 >= res_ptr */
-	leal	(%esi,%ebp,4),%eax
-	cmpl	%eax,%edi
-	jnc	Lspecial		/* jump if res_ptr >= s_ptr + size */
-
-Lnormal:
-	leal	-4(%edi,%ebp,4),%edi
-	leal	-4(%esi,%ebp,4),%esi
-
-	movl	(%esi),%edx
-	subl	$4,%esi
-	xorl	%eax,%eax
-	shldl	%cl,%edx,%eax		/* compute carry limb */
-	pushl	%eax			/* push carry limb onto stack */
-
-	decl	%ebp
-	pushl	%ebp
-	shrl	$3,%ebp
-	jz	Lend
-
-	movl	(%edi),%eax		/* fetch destination cache line */
-
-	ALIGN	(2)
-Loop:	movl	-28(%edi),%eax		/* fetch destination cache line */
-	movl	%edx,%ebx
-
-	movl	(%esi),%eax
-	movl	-4(%esi),%edx
-	shldl	%cl,%eax,%ebx
-	shldl	%cl,%edx,%eax
-	movl	%ebx,(%edi)
-	movl	%eax,-4(%edi)
-
-	movl	-8(%esi),%ebx
-	movl	-12(%esi),%eax
-	shldl	%cl,%ebx,%edx
-	shldl	%cl,%eax,%ebx
-	movl	%edx,-8(%edi)
-	movl	%ebx,-12(%edi)
-
-	movl	-16(%esi),%edx
-	movl	-20(%esi),%ebx
-	shldl	%cl,%edx,%eax
-	shldl	%cl,%ebx,%edx
-	movl	%eax,-16(%edi)
-	movl	%edx,-20(%edi)
-
-	movl	-24(%esi),%eax
-	movl	-28(%esi),%edx
-	shldl	%cl,%eax,%ebx
-	shldl	%cl,%edx,%eax
-	movl	%ebx,-24(%edi)
-	movl	%eax,-28(%edi)
-
-	subl	$32,%esi
-	subl	$32,%edi
-	decl	%ebp
-	jnz	Loop
-
-Lend:	popl	%ebp
-	andl	$7,%ebp
-	jz	Lend2
-Loop2:	movl	(%esi),%eax
-	shldl	%cl,%eax,%edx
-	movl	%edx,(%edi)
-	movl	%eax,%edx
-	subl	$4,%esi
-	subl	$4,%edi
-	decl	%ebp
-	jnz	Loop2
-
-Lend2:	shll	%cl,%edx		/* compute least significant limb */
-	movl	%edx,(%edi)		/* store it */
-
-	popl	%eax			/* pop carry limb */
-
-	popl	%ebp
-	popl	%ebx
-	popl	%esi
-	popl	%edi
-	ret
-
-/* We loop from least significant end of the arrays, which is only
-   permissable if the source and destination don't overlap, since the
-   function is documented to work for overlapping source and destination.
-*/
-
-Lspecial:
-	movl	(%esi),%edx
-	addl	$4,%esi
-
-	decl	%ebp
-	pushl	%ebp
-	shrl	$3,%ebp
-
-	addl	%edx,%edx
-	incl	%ebp
-	decl	%ebp
-	jz	LLend
-
-	movl	(%edi),%eax		/* fetch destination cache line */
-
-	ALIGN	(2)
-LLoop:	movl	28(%edi),%eax		/* fetch destination cache line */
-	movl	%edx,%ebx
-
-	movl	(%esi),%eax
-	movl	4(%esi),%edx
-	adcl	%eax,%eax
-	movl	%ebx,(%edi)
-	adcl	%edx,%edx
-	movl	%eax,4(%edi)
-
-	movl	8(%esi),%ebx
-	movl	12(%esi),%eax
-	adcl	%ebx,%ebx
-	movl	%edx,8(%edi)
-	adcl	%eax,%eax
-	movl	%ebx,12(%edi)
-
-	movl	16(%esi),%edx
-	movl	20(%esi),%ebx
-	adcl	%edx,%edx
-	movl	%eax,16(%edi)
-	adcl	%ebx,%ebx
-	movl	%edx,20(%edi)
-
-	movl	24(%esi),%eax
-	movl	28(%esi),%edx
-	adcl	%eax,%eax
-	movl	%ebx,24(%edi)
-	adcl	%edx,%edx
-	movl	%eax,28(%edi)
-
-	leal	32(%esi),%esi		/* use leal not to clobber carry */
-	leal	32(%edi),%edi
-	decl	%ebp
-	jnz	LLoop
-
-LLend:	popl	%ebp
-	sbbl	%eax,%eax		/* save carry in %eax */
-	andl	$7,%ebp
-	jz	LLend2
-	addl	%eax,%eax		/* restore carry from eax */
-LLoop2: movl	%edx,%ebx
-	movl	(%esi),%edx
-	adcl	%edx,%edx
-	movl	%ebx,(%edi)
-
-	leal	4(%esi),%esi		/* use leal not to clobber carry */
-	leal	4(%edi),%edi
-	decl	%ebp
-	jnz	LLoop2
-
-	jmp	LL1
-LLend2: addl	%eax,%eax		/* restore carry from eax */
-LL1:	movl	%edx,(%edi)		/* store last limb */
-
-	sbbl	%eax,%eax
-	negl	%eax
-
-	popl	%ebp
-	popl	%ebx
-	popl	%esi
-	popl	%edi
-	ret
-
-
-
-
-/*******************
- * mpi_limb_t
- * mpihelp_rshift( mpi_ptr_t wp,	(sp + 4)
- *		   mpi_ptr_t up,	(sp + 8)
- *		   mpi_size_t usize,	(sp + 12)
- *		   unsigned cnt)	(sp + 16)
- */
-
-.text
-	ALIGN (3)
-	.globl C_SYMBOL_NAME(mpihelp_rshift)
-C_SYMBOL_NAME(mpihelp_rshift:)
-	pushl	%edi
-	pushl	%esi
-	pushl	%ebx
-	pushl	%ebp
-
-	movl	20(%esp),%edi		/* res_ptr */
-	movl	24(%esp),%esi		/* s_ptr */
-	movl	28(%esp),%ebp		/* size */
-	movl	32(%esp),%ecx		/* cnt */
-
-/* We can use faster code for shift-by-1 under certain conditions.  */
-	cmp	$1,%ecx
-	jne	Rnormal
-	leal	4(%edi),%eax
-	cmpl	%esi,%eax
-	jnc	Rspecial		/* jump if res_ptr + 1 >= s_ptr */
-	leal	(%edi,%ebp,4),%eax
-	cmpl	%eax,%esi
-	jnc	Rspecial		/* jump if s_ptr >= res_ptr + size */
-
-Rnormal:
-	movl	(%esi),%edx
-	addl	$4,%esi
-	xorl	%eax,%eax
-	shrdl	%cl,%edx,%eax		/* compute carry limb */
-	pushl	%eax			/* push carry limb onto stack */
-
-	decl	%ebp
-	pushl	%ebp
-	shrl	$3,%ebp
-	jz	Rend
-
-	movl	(%edi),%eax		/* fetch destination cache line */
-
-	ALIGN	(2)
-Roop:	movl	28(%edi),%eax		/* fetch destination cache line */
-	movl	%edx,%ebx
-
-	movl	(%esi),%eax
-	movl	4(%esi),%edx
-	shrdl	%cl,%eax,%ebx
-	shrdl	%cl,%edx,%eax
-	movl	%ebx,(%edi)
-	movl	%eax,4(%edi)
-
-	movl	8(%esi),%ebx
-	movl	12(%esi),%eax
-	shrdl	%cl,%ebx,%edx
-	shrdl	%cl,%eax,%ebx
-	movl	%edx,8(%edi)
-	movl	%ebx,12(%edi)
-
-	movl	16(%esi),%edx
-	movl	20(%esi),%ebx
-	shrdl	%cl,%edx,%eax
-	shrdl	%cl,%ebx,%edx
-	movl	%eax,16(%edi)
-	movl	%edx,20(%edi)
-
-	movl	24(%esi),%eax
-	movl	28(%esi),%edx
-	shrdl	%cl,%eax,%ebx
-	shrdl	%cl,%edx,%eax
-	movl	%ebx,24(%edi)
-	movl	%eax,28(%edi)
-
-	addl	$32,%esi
-	addl	$32,%edi
-	decl	%ebp
-	jnz	Roop
-
-Rend:	popl	%ebp
-	andl	$7,%ebp
-	jz	Rend2
-Roop2:	movl	(%esi),%eax
-	shrdl	%cl,%eax,%edx		/* compute result limb */
-	movl	%edx,(%edi)
-	movl	%eax,%edx
-	addl	$4,%esi
-	addl	$4,%edi
-	decl	%ebp
-	jnz	Roop2
-
-Rend2:	shrl	%cl,%edx		/* compute most significant limb */
-	movl	%edx,(%edi)		/* store it */
-
-	popl	%eax			/* pop carry limb */
-
-	popl	%ebp
-	popl	%ebx
-	popl	%esi
-	popl	%edi
-	ret
-
-/* We loop from least significant end of the arrays, which is only
-   permissable if the source and destination don't overlap, since the
-   function is documented to work for overlapping source and destination.
-*/
-
-Rspecial:
-	leal	-4(%edi,%ebp,4),%edi
-	leal	-4(%esi,%ebp,4),%esi
-
-	movl	(%esi),%edx
-	subl	$4,%esi
-
-	decl	%ebp
-	pushl	%ebp
-	shrl	$3,%ebp
-
-	shrl	$1,%edx
-	incl	%ebp
-	decl	%ebp
-	jz	RLend
-
-	movl	(%edi),%eax		/* fetch destination cache line */
-
-	ALIGN	(2)
-RLoop:	movl	-28(%edi),%eax		/* fetch destination cache line */
-	movl	%edx,%ebx
-
-	movl	(%esi),%eax
-	movl	-4(%esi),%edx
-	rcrl	$1,%eax
-	movl	%ebx,(%edi)
-	rcrl	$1,%edx
-	movl	%eax,-4(%edi)
-
-	movl	-8(%esi),%ebx
-	movl	-12(%esi),%eax
-	rcrl	$1,%ebx
-	movl	%edx,-8(%edi)
-	rcrl	$1,%eax
-	movl	%ebx,-12(%edi)
-
-	movl	-16(%esi),%edx
-	movl	-20(%esi),%ebx
-	rcrl	$1,%edx
-	movl	%eax,-16(%edi)
-	rcrl	$1,%ebx
-	movl	%edx,-20(%edi)
-
-	movl	-24(%esi),%eax
-	movl	-28(%esi),%edx
-	rcrl	$1,%eax
-	movl	%ebx,-24(%edi)
-	rcrl	$1,%edx
-	movl	%eax,-28(%edi)
-
-	leal	-32(%esi),%esi		/* use leal not to clobber carry */
-	leal	-32(%edi),%edi
-	decl	%ebp
-	jnz	RLoop
-
-RLend:	popl	%ebp
-	sbbl	%eax,%eax		/* save carry in %eax */
-	andl	$7,%ebp
-	jz	RLend2
-	addl	%eax,%eax		/* restore carry from eax */
-RLoop2: movl	%edx,%ebx
-	movl	(%esi),%edx
-	rcrl	$1,%edx
-	movl	%ebx,(%edi)
-
-	leal	-4(%esi),%esi		/* use leal not to clobber carry */
-	leal	-4(%edi),%edi
-	decl	%ebp
-	jnz	RLoop2
-
-	jmp	RL1
-RLend2: addl	%eax,%eax		/* restore carry from eax */
-RL1:	movl	%edx,(%edi)		/* store last limb */
-
-	movl	$0,%eax
-	rcrl	$1,%eax
-
-	popl	%ebp
-	popl	%ebx
-	popl	%esi
-	popl	%edi
-	ret
-
diff -urN gnupg-0.2.18/mpi/m68k/distfiles gnupg-0.2.19/mpi/m68k/distfiles
--- gnupg-0.2.18/mpi/m68k/distfiles	Wed Feb 18 15:56:24 1998
+++ gnupg-0.2.19/mpi/m68k/distfiles	Mon May 18 13:39:36 1998
@@ -1,5 +1,6 @@
 syntax.h
-mpih-shift.S
+mpih-lshift.S
+mpih-rshift.S
 mpih-add1.S
 mpih-sub1.S
 
diff -urN gnupg-0.2.18/mpi/m68k/mpih-lshift.S gnupg-0.2.19/mpi/m68k/mpih-lshift.S
--- gnupg-0.2.18/mpi/m68k/mpih-lshift.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/mpi/m68k/mpih-lshift.S	Mon May 18 13:38:29 1998
@@ -0,0 +1,158 @@
+/* mc68020 lshift -- Shift left a low-level natural-number integer.
+
+Copyright (C) 1996, 1998 Free Software Foundation, Inc.
+
+This file is part of GNUPG.
+
+GNUPG is free software; you can redistribute it and/or modify
+it under the terms of the GNU Library General Public License as published by
+the Free Software Foundation; either version 2 of the License, or (at your
+option) any later version.
+
+GNUPG is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
+License for more details.
+
+You should have received a copy of the GNU Library General Public License
+along with the GNU MP Library; see the file COPYING.LIB.  If not, write to
+the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
+MA 02111-1307, USA.
+*/
+
+#include "sysdep.h"
+#include "asm-syntax.h"
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_lshift( mpi_ptr_t wp,	(sp + 4)
+ *		   mpi_ptr_t up,	(sp + 8)
+ *		   mpi_size_t usize,	(sp + 12)
+ *		   unsigned cnt)	(sp + 16)
+ */
+
+#define res_ptr a1
+#define s_ptr a0
+#define s_size d6
+#define cnt d4
+
+	TEXT
+	ALIGN
+	GLOBL	C_SYMBOL_NAME(mpihelp_lshift)
+
+C_SYMBOL_NAME(mpihelp_lshift:)
+PROLOG(mpihelp_lshift)
+
+	/* Save used registers on the stack.  */
+	moveml	R(d2)-R(d6)/R(a2),MEM_PREDEC(sp)
+
+	/* Copy the arguments to registers.  */
+	movel	MEM_DISP(sp,28),R(res_ptr)
+	movel	MEM_DISP(sp,32),R(s_ptr)
+	movel	MEM_DISP(sp,36),R(s_size)
+	movel	MEM_DISP(sp,40),R(cnt)
+
+	moveql	#1,R(d5)
+	cmpl	R(d5),R(cnt)
+	bne	L(Lnormal)
+	cmpl	R(s_ptr),R(res_ptr)
+	bls	L(Lspecial)		/* jump if s_ptr >= res_ptr */
+#if (defined (__mc68020__) || defined (__NeXT__) || defined(mc68020))
+	lea	MEM_INDX1(s_ptr,s_size,l,4),R(a2)
+#else /* not mc68020 */
+	movel	R(s_size),R(d0)
+	asll	#2,R(d0)
+	lea	MEM_INDX(s_ptr,d0,l),R(a2)
+#endif
+	cmpl	R(res_ptr),R(a2)
+	bls	L(Lspecial)		/* jump if res_ptr >= s_ptr + s_size */
+
+L(Lnormal:)
+	moveql	#32,R(d5)
+	subl	R(cnt),R(d5)
+
+#if (defined (__mc68020__) || defined (__NeXT__) || defined(mc68020))
+	lea	MEM_INDX1(s_ptr,s_size,l,4),R(s_ptr)
+	lea	MEM_INDX1(res_ptr,s_size,l,4),R(res_ptr)
+#else /* not mc68000 */
+	movel	R(s_size),R(d0)
+	asll	#2,R(d0)
+	addl	R(s_size),R(s_ptr)
+	addl	R(s_size),R(res_ptr)
+#endif
+	movel	MEM_PREDEC(s_ptr),R(d2)
+	movel	R(d2),R(d0)
+	lsrl	R(d5),R(d0)		/* compute carry limb */
+
+	lsll	R(cnt),R(d2)
+	movel	R(d2),R(d1)
+	subql	#1,R(s_size)
+	beq	L(Lend)
+	lsrl	#1,R(s_size)
+	bcs	L(L1)
+	subql	#1,R(s_size)
+
+L(Loop:)
+	movel	MEM_PREDEC(s_ptr),R(d2)
+	movel	R(d2),R(d3)
+	lsrl	R(d5),R(d3)
+	orl	R(d3),R(d1)
+	movel	R(d1),MEM_PREDEC(res_ptr)
+	lsll	R(cnt),R(d2)
+L(L1:)
+	movel	MEM_PREDEC(s_ptr),R(d1)
+	movel	R(d1),R(d3)
+	lsrl	R(d5),R(d3)
+	orl	R(d3),R(d2)
+	movel	R(d2),MEM_PREDEC(res_ptr)
+	lsll	R(cnt),R(d1)
+
+	dbf	R(s_size),L(Loop)
+	subl	#0x10000,R(s_size)
+	bcc	L(Loop)
+
+L(Lend:)
+	movel	R(d1),MEM_PREDEC(res_ptr) /* store least significant limb */
+
+/* Restore used registers from stack frame.  */
+	moveml	MEM_POSTINC(sp),R(d2)-R(d6)/R(a2)
+	rts
+
+/* We loop from least significant end of the arrays, which is only
+   permissable if the source and destination don't overlap, since the
+   function is documented to work for overlapping source and destination.  */
+
+L(Lspecial:)
+	clrl	R(d0)			/* initialize carry */
+	eorw	#1,R(s_size)
+	lsrl	#1,R(s_size)
+	bcc	L(LL1)
+	subql	#1,R(s_size)
+
+L(LLoop:)
+	movel	MEM_POSTINC(s_ptr),R(d2)
+	addxl	R(d2),R(d2)
+	movel	R(d2),MEM_POSTINC(res_ptr)
+L(LL1:)
+	movel	MEM_POSTINC(s_ptr),R(d2)
+	addxl	R(d2),R(d2)
+	movel	R(d2),MEM_POSTINC(res_ptr)
+
+	dbf	R(s_size),L(LLoop)
+	addxl	R(d0),R(d0)		/* save cy in lsb */
+	subl	#0x10000,R(s_size)
+	bcs	L(LLend)
+	lsrl	#1,R(d0)		/* restore cy */
+	bra	L(LLoop)
+
+L(LLend:)
+/* Restore used registers from stack frame.  */
+	moveml	MEM_POSTINC(sp),R(d2)-R(d6)/R(a2)
+	rts
+EPILOG(mpihelp_lshift)
+
+
+
+
+
diff -urN gnupg-0.2.18/mpi/m68k/mpih-rshift.S gnupg-0.2.19/mpi/m68k/mpih-rshift.S
--- gnupg-0.2.18/mpi/m68k/mpih-rshift.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/mpi/m68k/mpih-rshift.S	Mon May 18 13:40:00 1998
@@ -0,0 +1,156 @@
+/* mc68020 rshift -- Shift right a low-level natural-number integer.
+
+Copyright (C) 1996, 1998 Free Software Foundation, Inc.
+
+This file is part of GNUPG.
+
+GNUPG is free software; you can redistribute it and/or modify
+it under the terms of the GNU Library General Public License as published by
+the Free Software Foundation; either version 2 of the License, or (at your
+option) any later version.
+
+GNUPG is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
+License for more details.
+
+You should have received a copy of the GNU Library General Public License
+along with the GNU MP Library; see the file COPYING.LIB.  If not, write to
+the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
+MA 02111-1307, USA.
+*/
+
+#include "sysdep.h"
+#include "asm-syntax.h"
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_rshift( mpi_ptr_t wp,	(sp + 4)
+ *		   mpi_ptr_t up,	(sp + 8)
+ *		   mpi_size_t usize,	(sp + 12)
+ *		   unsigned cnt)	(sp + 16)
+ */
+
+#define res_ptr a1
+#define s_ptr a0
+#define s_size d6
+#define cnt d4
+
+	TEXT
+	ALIGN
+	GLOBL	C_SYMBOL_NAME(mpihelp_rshift)
+
+C_SYMBOL_NAME(mpihelp_rshift:)
+PROLOG(mpihelp_rshift)
+	/* Save used registers on the stack.  */
+	moveml	R(d2)-R(d6)/R(a2),MEM_PREDEC(sp)
+
+	/* Copy the arguments to registers.  */
+	movel	MEM_DISP(sp,28),R(res_ptr)
+	movel	MEM_DISP(sp,32),R(s_ptr)
+	movel	MEM_DISP(sp,36),R(s_size)
+	movel	MEM_DISP(sp,40),R(cnt)
+
+	moveql	#1,R(d5)
+	cmpl	R(d5),R(cnt)
+	bne	L(Rnormal)
+	cmpl	R(res_ptr),R(s_ptr)
+	bls	L(Rspecial)		/* jump if res_ptr >= s_ptr */
+#if (defined (__mc68020__) || defined (__NeXT__) || defined(mc68020))
+	lea	MEM_INDX1(res_ptr,s_size,l,4),R(a2)
+#else /* not mc68020 */
+	movel	R(s_size),R(d0)
+	asll	#2,R(d0)
+	lea	MEM_INDX(res_ptr,d0,l),R(a2)
+#endif
+	cmpl	R(s_ptr),R(a2)
+	bls	L(Rspecial)		/* jump if s_ptr >= res_ptr + s_size */
+
+L(Rnormal:)
+	moveql	#32,R(d5)
+	subl	R(cnt),R(d5)
+	movel	MEM_POSTINC(s_ptr),R(d2)
+	movel	R(d2),R(d0)
+	lsll	R(d5),R(d0)		/* compute carry limb */
+
+	lsrl	R(cnt),R(d2)
+	movel	R(d2),R(d1)
+	subql	#1,R(s_size)
+	beq	L(Rend)
+	lsrl	#1,R(s_size)
+	bcs	L(R1)
+	subql	#1,R(s_size)
+
+L(Roop:)
+	movel	MEM_POSTINC(s_ptr),R(d2)
+	movel	R(d2),R(d3)
+	lsll	R(d5),R(d3)
+	orl	R(d3),R(d1)
+	movel	R(d1),MEM_POSTINC(res_ptr)
+	lsrl	R(cnt),R(d2)
+L(R1:)
+	movel	MEM_POSTINC(s_ptr),R(d1)
+	movel	R(d1),R(d3)
+	lsll	R(d5),R(d3)
+	orl	R(d3),R(d2)
+	movel	R(d2),MEM_POSTINC(res_ptr)
+	lsrl	R(cnt),R(d1)
+
+	dbf	R(s_size),L(Roop)
+	subl	#0x10000,R(s_size)
+	bcc	L(Roop)
+
+L(Rend:)
+	movel	R(d1),MEM(res_ptr) /* store most significant limb */
+
+/* Restore used registers from stack frame.  */
+	moveml	MEM_POSTINC(sp),R(d2)-R(d6)/R(a2)
+	rts
+
+/* We loop from most significant end of the arrays, which is only
+   permissable if the source and destination don't overlap, since the
+   function is documented to work for overlapping source and destination.  */
+
+L(Rspecial:)
+#if (defined (__mc68020__) || defined (__NeXT__) || defined(mc68020))
+	lea	MEM_INDX1(s_ptr,s_size,l,4),R(s_ptr)
+	lea	MEM_INDX1(res_ptr,s_size,l,4),R(res_ptr)
+#else /* not mc68000 */
+	movel	R(s_size),R(d0)
+	asll	#2,R(d0)
+	addl	R(s_size),R(s_ptr)
+	addl	R(s_size),R(res_ptr)
+#endif
+
+	clrl	R(d0)			/* initialize carry */
+	eorw	#1,R(s_size)
+	lsrl	#1,R(s_size)
+	bcc	L(LR1)
+	subql	#1,R(s_size)
+
+L(LRoop:)
+	movel	MEM_PREDEC(s_ptr),R(d2)
+	roxrl	#1,R(d2)
+	movel	R(d2),MEM_PREDEC(res_ptr)
+L(LR1:)
+	movel	MEM_PREDEC(s_ptr),R(d2)
+	roxrl	#1,R(d2)
+	movel	R(d2),MEM_PREDEC(res_ptr)
+
+	dbf	R(s_size),L(LRoop)
+	roxrl	#1,R(d0)		/* save cy in msb */
+	subl	#0x10000,R(s_size)
+	bcs	L(LRend)
+	addl	R(d0),R(d0)		/* restore cy */
+	bra	L(LRoop)
+
+L(LRend:)
+/* Restore used registers from stack frame.  */
+	moveml	MEM_POSTINC(sp),R(d2)-R(d6)/R(a2)
+	rts
+EPILOG(mpihelp_rshift)
+
+
+
+
diff -urN gnupg-0.2.18/mpi/m68k/mpih-shift.S gnupg-0.2.19/mpi/m68k/mpih-shift.S
--- gnupg-0.2.18/mpi/m68k/mpih-shift.S	Tue Feb 24 11:46:21 1998
+++ gnupg-0.2.19/mpi/m68k/mpih-shift.S	Thu Jan  1 01:00:00 1970
@@ -1,286 +0,0 @@
-/* mc68020 __mpn_lshift -- Shift left a low-level natural-number integer.
-
-Copyright (C) 1996 Free Software Foundation, Inc.
-
-This file is part of the GNU MP Library.
-
-The GNU MP Library is free software; you can redistribute it and/or modify
-it under the terms of the GNU Library General Public License as published by
-the Free Software Foundation; either version 2 of the License, or (at your
-option) any later version.
-
-The GNU MP Library is distributed in the hope that it will be useful, but
-WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
-or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
-License for more details.
-
-You should have received a copy of the GNU Library General Public License
-along with the GNU MP Library; see the file COPYING.LIB.  If not, write to
-the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
-MA 02111-1307, USA. */
-
-#include "sysdep.h"
-#include "asm-syntax.h"
-
-
-/*******************
- * mpi_limb_t
- * mpihelp_lshift( mpi_ptr_t wp,	(sp + 4)
- *		   mpi_ptr_t up,	(sp + 8)
- *		   mpi_size_t usize,	(sp + 12)
- *		   unsigned cnt)	(sp + 16)
- */
-
-#define res_ptr a1
-#define s_ptr a0
-#define s_size d6
-#define cnt d4
-
-	TEXT
-	ALIGN
-	GLOBL	C_SYMBOL_NAME(mpihelp_lshift)
-
-C_SYMBOL_NAME(mpihelp_lshift:)
-PROLOG(mpihelp_lshift)
-
-	/* Save used registers on the stack.  */
-	moveml	R(d2)-R(d6)/R(a2),MEM_PREDEC(sp)
-
-	/* Copy the arguments to registers.  */
-	movel	MEM_DISP(sp,28),R(res_ptr)
-	movel	MEM_DISP(sp,32),R(s_ptr)
-	movel	MEM_DISP(sp,36),R(s_size)
-	movel	MEM_DISP(sp,40),R(cnt)
-
-	moveql	#1,R(d5)
-	cmpl	R(d5),R(cnt)
-	bne	L(Lnormal)
-	cmpl	R(s_ptr),R(res_ptr)
-	bls	L(Lspecial)		/* jump if s_ptr >= res_ptr */
-#if (defined (__mc68020__) || defined (__NeXT__) || defined(mc68020))
-	lea	MEM_INDX1(s_ptr,s_size,l,4),R(a2)
-#else /* not mc68020 */
-	movel	R(s_size),R(d0)
-	asll	#2,R(d0)
-	lea	MEM_INDX(s_ptr,d0,l),R(a2)
-#endif
-	cmpl	R(res_ptr),R(a2)
-	bls	L(Lspecial)		/* jump if res_ptr >= s_ptr + s_size */
-
-L(Lnormal:)
-	moveql	#32,R(d5)
-	subl	R(cnt),R(d5)
-
-#if (defined (__mc68020__) || defined (__NeXT__) || defined(mc68020))
-	lea	MEM_INDX1(s_ptr,s_size,l,4),R(s_ptr)
-	lea	MEM_INDX1(res_ptr,s_size,l,4),R(res_ptr)
-#else /* not mc68000 */
-	movel	R(s_size),R(d0)
-	asll	#2,R(d0)
-	addl	R(s_size),R(s_ptr)
-	addl	R(s_size),R(res_ptr)
-#endif
-	movel	MEM_PREDEC(s_ptr),R(d2)
-	movel	R(d2),R(d0)
-	lsrl	R(d5),R(d0)		/* compute carry limb */
-
-	lsll	R(cnt),R(d2)
-	movel	R(d2),R(d1)
-	subql	#1,R(s_size)
-	beq	L(Lend)
-	lsrl	#1,R(s_size)
-	bcs	L(L1)
-	subql	#1,R(s_size)
-
-L(Loop:)
-	movel	MEM_PREDEC(s_ptr),R(d2)
-	movel	R(d2),R(d3)
-	lsrl	R(d5),R(d3)
-	orl	R(d3),R(d1)
-	movel	R(d1),MEM_PREDEC(res_ptr)
-	lsll	R(cnt),R(d2)
-L(L1:)
-	movel	MEM_PREDEC(s_ptr),R(d1)
-	movel	R(d1),R(d3)
-	lsrl	R(d5),R(d3)
-	orl	R(d3),R(d2)
-	movel	R(d2),MEM_PREDEC(res_ptr)
-	lsll	R(cnt),R(d1)
-
-	dbf	R(s_size),L(Loop)
-	subl	#0x10000,R(s_size)
-	bcc	L(Loop)
-
-L(Lend:)
-	movel	R(d1),MEM_PREDEC(res_ptr) /* store least significant limb */
-
-/* Restore used registers from stack frame.  */
-	moveml	MEM_POSTINC(sp),R(d2)-R(d6)/R(a2)
-	rts
-
-/* We loop from least significant end of the arrays, which is only
-   permissable if the source and destination don't overlap, since the
-   function is documented to work for overlapping source and destination.  */
-
-L(Lspecial:)
-	clrl	R(d0)			/* initialize carry */
-	eorw	#1,R(s_size)
-	lsrl	#1,R(s_size)
-	bcc	L(LL1)
-	subql	#1,R(s_size)
-
-L(LLoop:)
-	movel	MEM_POSTINC(s_ptr),R(d2)
-	addxl	R(d2),R(d2)
-	movel	R(d2),MEM_POSTINC(res_ptr)
-L(LL1:)
-	movel	MEM_POSTINC(s_ptr),R(d2)
-	addxl	R(d2),R(d2)
-	movel	R(d2),MEM_POSTINC(res_ptr)
-
-	dbf	R(s_size),L(LLoop)
-	addxl	R(d0),R(d0)		/* save cy in lsb */
-	subl	#0x10000,R(s_size)
-	bcs	L(LLend)
-	lsrl	#1,R(d0)		/* restore cy */
-	bra	L(LLoop)
-
-L(LLend:)
-/* Restore used registers from stack frame.  */
-	moveml	MEM_POSTINC(sp),R(d2)-R(d6)/R(a2)
-	rts
-EPILOG(mpihelp_lshift)
-
-
-
-
-/*******************
- * mpi_limb_t
- * mpihelp_rshift( mpi_ptr_t wp,	(sp + 4)
- *		   mpi_ptr_t up,	(sp + 8)
- *		   mpi_size_t usize,	(sp + 12)
- *		   unsigned cnt)	(sp + 16)
- */
-
-#define res_ptr a1
-#define s_ptr a0
-#define s_size d6
-#define cnt d4
-
-	TEXT
-	ALIGN
-	GLOBL	C_SYMBOL_NAME(mpihelp_rshift)
-
-C_SYMBOL_NAME(mpihelp_rshift:)
-PROLOG(mpihelp_rshift)
-	/* Save used registers on the stack.  */
-	moveml	R(d2)-R(d6)/R(a2),MEM_PREDEC(sp)
-
-	/* Copy the arguments to registers.  */
-	movel	MEM_DISP(sp,28),R(res_ptr)
-	movel	MEM_DISP(sp,32),R(s_ptr)
-	movel	MEM_DISP(sp,36),R(s_size)
-	movel	MEM_DISP(sp,40),R(cnt)
-
-	moveql	#1,R(d5)
-	cmpl	R(d5),R(cnt)
-	bne	L(Rnormal)
-	cmpl	R(res_ptr),R(s_ptr)
-	bls	L(Rspecial)		/* jump if res_ptr >= s_ptr */
-#if (defined (__mc68020__) || defined (__NeXT__) || defined(mc68020))
-	lea	MEM_INDX1(res_ptr,s_size,l,4),R(a2)
-#else /* not mc68020 */
-	movel	R(s_size),R(d0)
-	asll	#2,R(d0)
-	lea	MEM_INDX(res_ptr,d0,l),R(a2)
-#endif
-	cmpl	R(s_ptr),R(a2)
-	bls	L(Rspecial)		/* jump if s_ptr >= res_ptr + s_size */
-
-L(Rnormal:)
-	moveql	#32,R(d5)
-	subl	R(cnt),R(d5)
-	movel	MEM_POSTINC(s_ptr),R(d2)
-	movel	R(d2),R(d0)
-	lsll	R(d5),R(d0)		/* compute carry limb */
-
-	lsrl	R(cnt),R(d2)
-	movel	R(d2),R(d1)
-	subql	#1,R(s_size)
-	beq	L(Rend)
-	lsrl	#1,R(s_size)
-	bcs	L(R1)
-	subql	#1,R(s_size)
-
-L(Roop:)
-	movel	MEM_POSTINC(s_ptr),R(d2)
-	movel	R(d2),R(d3)
-	lsll	R(d5),R(d3)
-	orl	R(d3),R(d1)
-	movel	R(d1),MEM_POSTINC(res_ptr)
-	lsrl	R(cnt),R(d2)
-L(R1:)
-	movel	MEM_POSTINC(s_ptr),R(d1)
-	movel	R(d1),R(d3)
-	lsll	R(d5),R(d3)
-	orl	R(d3),R(d2)
-	movel	R(d2),MEM_POSTINC(res_ptr)
-	lsrl	R(cnt),R(d1)
-
-	dbf	R(s_size),L(Roop)
-	subl	#0x10000,R(s_size)
-	bcc	L(Roop)
-
-L(Rend:)
-	movel	R(d1),MEM(res_ptr) /* store most significant limb */
-
-/* Restore used registers from stack frame.  */
-	moveml	MEM_POSTINC(sp),R(d2)-R(d6)/R(a2)
-	rts
-
-/* We loop from most significant end of the arrays, which is only
-   permissable if the source and destination don't overlap, since the
-   function is documented to work for overlapping source and destination.  */
-
-L(Rspecial:)
-#if (defined (__mc68020__) || defined (__NeXT__) || defined(mc68020))
-	lea	MEM_INDX1(s_ptr,s_size,l,4),R(s_ptr)
-	lea	MEM_INDX1(res_ptr,s_size,l,4),R(res_ptr)
-#else /* not mc68000 */
-	movel	R(s_size),R(d0)
-	asll	#2,R(d0)
-	addl	R(s_size),R(s_ptr)
-	addl	R(s_size),R(res_ptr)
-#endif
-
-	clrl	R(d0)			/* initialize carry */
-	eorw	#1,R(s_size)
-	lsrl	#1,R(s_size)
-	bcc	L(LR1)
-	subql	#1,R(s_size)
-
-L(LRoop:)
-	movel	MEM_PREDEC(s_ptr),R(d2)
-	roxrl	#1,R(d2)
-	movel	R(d2),MEM_PREDEC(res_ptr)
-L(LR1:)
-	movel	MEM_PREDEC(s_ptr),R(d2)
-	roxrl	#1,R(d2)
-	movel	R(d2),MEM_PREDEC(res_ptr)
-
-	dbf	R(s_size),L(LRoop)
-	roxrl	#1,R(d0)		/* save cy in msb */
-	subl	#0x10000,R(s_size)
-	bcs	L(LRend)
-	addl	R(d0),R(d0)		/* restore cy */
-	bra	L(LRoop)
-
-L(LRend:)
-/* Restore used registers from stack frame.  */
-	moveml	MEM_POSTINC(sp),R(d2)-R(d6)/R(a2)
-	rts
-EPILOG(mpihelp_rshift)
-
-
-
-
diff -urN gnupg-0.2.18/mpi/pa7100/distfiles gnupg-0.2.19/mpi/pa7100/distfiles
--- gnupg-0.2.18/mpi/pa7100/distfiles	Thu Feb 12 20:49:59 1998
+++ gnupg-0.2.19/mpi/pa7100/distfiles	Mon May 18 13:43:49 1998
@@ -1,2 +1,3 @@
-mpih-shift.S
+mpih-lshift.S
+mpih-rshift.S
 
diff -urN gnupg-0.2.18/mpi/pa7100/mpih-lshift.S gnupg-0.2.19/mpi/pa7100/mpih-lshift.S
--- gnupg-0.2.18/mpi/pa7100/mpih-lshift.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/mpi/pa7100/mpih-lshift.S	Mon May 18 13:44:28 1998
@@ -0,0 +1,89 @@
+/* hppa   lshift
+ *	  optimized for the PA7100, where is runs at 3.25 cycles/limb
+ *	Copyright (C) 1992, 1994 Free Software Foundation, Inc.
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_lshift( mpi_ptr_t wp,	(gr26)
+ *		   mpi_ptr_t up,	(gr25)
+ *		   mpi_size_t usize,	(gr24)
+ *		   unsigned cnt)	(gr23)
+ */
+
+	.code
+	.export 	mpihelp_lshift
+mpihelp_lshift
+	.proc
+	.callinfo	frame=64,no_calls
+	.entry
+
+	sh2add		%r24,%r25,%r25
+	sh2add		%r24,%r26,%r26
+	ldws,mb 	-4(0,%r25),%r22
+	subi		32,%r23,%r1
+	mtsar		%r1
+	addib,= 	-1,%r24,L$0004
+	vshd		%r0,%r22,%r28		; compute carry out limb
+	ldws,mb 	-4(0,%r25),%r29
+	addib,<=	-5,%r24,L$rest
+	vshd		%r22,%r29,%r20
+
+L$loop	ldws,mb 	-4(0,%r25),%r22
+	stws,mb 	%r20,-4(0,%r26)
+	vshd		%r29,%r22,%r20
+	ldws,mb 	-4(0,%r25),%r29
+	stws,mb 	%r20,-4(0,%r26)
+	vshd		%r22,%r29,%r20
+	ldws,mb 	-4(0,%r25),%r22
+	stws,mb 	%r20,-4(0,%r26)
+	vshd		%r29,%r22,%r20
+	ldws,mb 	-4(0,%r25),%r29
+	stws,mb 	%r20,-4(0,%r26)
+	addib,> 	-4,%r24,L$loop
+	vshd		%r22,%r29,%r20
+
+L$rest	addib,= 	4,%r24,L$end1
+	nop
+L$eloop ldws,mb 	-4(0,%r25),%r22
+	stws,mb 	%r20,-4(0,%r26)
+	addib,<=	-1,%r24,L$end2
+	vshd		%r29,%r22,%r20
+	ldws,mb 	-4(0,%r25),%r29
+	stws,mb 	%r20,-4(0,%r26)
+	addib,> 	-1,%r24,L$eloop
+	vshd		%r22,%r29,%r20
+
+L$end1	stws,mb 	%r20,-4(0,%r26)
+	vshd		%r29,%r0,%r20
+	bv		0(%r2)
+	stw		%r20,-4(0,%r26)
+L$end2	stws,mb 	%r20,-4(0,%r26)
+L$0004	vshd		%r22,%r0,%r20
+	bv		0(%r2)
+	stw		%r20,-4(0,%r26)
+
+	.exit
+	.procend
+
+
+
diff -urN gnupg-0.2.18/mpi/pa7100/mpih-rshift.S gnupg-0.2.19/mpi/pa7100/mpih-rshift.S
--- gnupg-0.2.18/mpi/pa7100/mpih-rshift.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/mpi/pa7100/mpih-rshift.S	Mon May 18 13:44:43 1998
@@ -0,0 +1,85 @@
+/* hppa   rshift
+ *	  optimized for the PA7100, where is runs at 3.25 cycles/limb
+ *	Copyright (C) 1992, 1994 Free Software Foundation, Inc.
+ *	Copyright (C) 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+
+
+/*******************
+ * mpi_limb_t
+ * mpihelp_rshift( mpi_ptr_t wp,       (gr26)
+ *		   mpi_ptr_t up,       (gr25)
+ *		   mpi_size_t usize,   (gr24)
+ *		   unsigned cnt)       (gr23)
+ */
+
+	.code
+	.export 	mpihelp_rshift
+mpihelp_rshift
+	.proc
+	.callinfo	frame=64,no_calls
+	.entry
+
+	ldws,ma 	4(0,%r25),%r22
+	mtsar		%r23
+	addib,= 	-1,%r24,L$r004
+	vshd		%r22,%r0,%r28		; compute carry out limb
+	ldws,ma 	4(0,%r25),%r29
+	addib,<=	-5,%r24,L$rrest
+	vshd		%r29,%r22,%r20
+
+L$roop	ldws,ma 	4(0,%r25),%r22
+	stws,ma 	%r20,4(0,%r26)
+	vshd		%r22,%r29,%r20
+	ldws,ma 	4(0,%r25),%r29
+	stws,ma 	%r20,4(0,%r26)
+	vshd		%r29,%r22,%r20
+	ldws,ma 	4(0,%r25),%r22
+	stws,ma 	%r20,4(0,%r26)
+	vshd		%r22,%r29,%r20
+	ldws,ma 	4(0,%r25),%r29
+	stws,ma 	%r20,4(0,%r26)
+	addib,> 	-4,%r24,L$roop
+	vshd		%r29,%r22,%r20
+
+L$rrest addib,= 	4,%r24,L$rend1
+	nop
+L$eroop ldws,ma 	4(0,%r25),%r22
+	stws,ma 	%r20,4(0,%r26)
+	addib,<=	-1,%r24,L$rend2
+	vshd		%r22,%r29,%r20
+	ldws,ma 	4(0,%r25),%r29
+	stws,ma 	%r20,4(0,%r26)
+	addib,> 	-1,%r24,L$eroop
+	vshd		%r29,%r22,%r20
+
+L$rend1  stws,ma	 %r20,4(0,%r26)
+	vshd		%r0,%r29,%r20
+	bv		0(%r2)
+	stw		%r20,0(0,%r26)
+L$rend2  stws,ma	 %r20,4(0,%r26)
+L$r004	vshd		%r0,%r22,%r20
+	bv		0(%r2)
+	stw		%r20,0(0,%r26)
+
+	.exit
+	.procend
+
+
diff -urN gnupg-0.2.18/mpi/pa7100/mpih-shift.S gnupg-0.2.19/mpi/pa7100/mpih-shift.S
--- gnupg-0.2.18/mpi/pa7100/mpih-shift.S	Mon Feb 23 13:20:02 1998
+++ gnupg-0.2.19/mpi/pa7100/mpih-shift.S	Thu Jan  1 01:00:00 1970
@@ -1,158 +0,0 @@
-/* hppa   rshift, lshift
- *	  optimized for the PA7100, where is runs at 3.25 cycles/limb
- *	Copyright (C) 1992, 1994 Free Software Foundation, Inc.
- *	Copyright (C) 1998 Free Software Foundation, Inc.
- *
- * This file is part of GNUPG.
- *
- * GNUPG is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * GNUPG is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
- *
- * Note: This code is heavily based on the GNU MP Library.
- *	 Actually it's the same code with only minor changes in the
- *	 way the data is stored; this is to support the abstraction
- *	 of an optional secure memory allocation which may be used
- *	 to avoid revealing of sensitive data due to paging etc.
- *	 The GNU MP Library itself is published under the LGPL;
- *	 however I decided to publish this code under the plain GPL.
- */
-
-
-
-/*******************
- * mpi_limb_t
- * mpihelp_lshift( mpi_ptr_t wp,	(gr26)
- *		   mpi_ptr_t up,	(gr25)
- *		   mpi_size_t usize,	(gr24)
- *		   unsigned cnt)	(gr23)
- */
-
-	.code
-	.export 	mpihelp_lshift
-mpihelp_lshift
-	.proc
-	.callinfo	frame=64,no_calls
-	.entry
-
-	sh2add		%r24,%r25,%r25
-	sh2add		%r24,%r26,%r26
-	ldws,mb 	-4(0,%r25),%r22
-	subi		32,%r23,%r1
-	mtsar		%r1
-	addib,= 	-1,%r24,L$0004
-	vshd		%r0,%r22,%r28		; compute carry out limb
-	ldws,mb 	-4(0,%r25),%r29
-	addib,<=	-5,%r24,L$rest
-	vshd		%r22,%r29,%r20
-
-L$loop	ldws,mb 	-4(0,%r25),%r22
-	stws,mb 	%r20,-4(0,%r26)
-	vshd		%r29,%r22,%r20
-	ldws,mb 	-4(0,%r25),%r29
-	stws,mb 	%r20,-4(0,%r26)
-	vshd		%r22,%r29,%r20
-	ldws,mb 	-4(0,%r25),%r22
-	stws,mb 	%r20,-4(0,%r26)
-	vshd		%r29,%r22,%r20
-	ldws,mb 	-4(0,%r25),%r29
-	stws,mb 	%r20,-4(0,%r26)
-	addib,> 	-4,%r24,L$loop
-	vshd		%r22,%r29,%r20
-
-L$rest	addib,= 	4,%r24,L$end1
-	nop
-L$eloop ldws,mb 	-4(0,%r25),%r22
-	stws,mb 	%r20,-4(0,%r26)
-	addib,<=	-1,%r24,L$end2
-	vshd		%r29,%r22,%r20
-	ldws,mb 	-4(0,%r25),%r29
-	stws,mb 	%r20,-4(0,%r26)
-	addib,> 	-1,%r24,L$eloop
-	vshd		%r22,%r29,%r20
-
-L$end1	stws,mb 	%r20,-4(0,%r26)
-	vshd		%r29,%r0,%r20
-	bv		0(%r2)
-	stw		%r20,-4(0,%r26)
-L$end2	stws,mb 	%r20,-4(0,%r26)
-L$0004	vshd		%r22,%r0,%r20
-	bv		0(%r2)
-	stw		%r20,-4(0,%r26)
-
-	.exit
-	.procend
-
-
-
-/*******************
- * mpi_limb_t
- * mpihelp_rshift( mpi_ptr_t wp,       (gr26)
- *		   mpi_ptr_t up,       (gr25)
- *		   mpi_size_t usize,   (gr24)
- *		   unsigned cnt)       (gr23)
- */
-
-	.code
-	.export 	mpihelp_rshift
-mpihelp_rshift
-	.proc
-	.callinfo	frame=64,no_calls
-	.entry
-
-	ldws,ma 	4(0,%r25),%r22
-	mtsar		%r23
-	addib,= 	-1,%r24,L$r004
-	vshd		%r22,%r0,%r28		; compute carry out limb
-	ldws,ma 	4(0,%r25),%r29
-	addib,<=	-5,%r24,L$rrest
-	vshd		%r29,%r22,%r20
-
-L$roop	ldws,ma 	4(0,%r25),%r22
-	stws,ma 	%r20,4(0,%r26)
-	vshd		%r22,%r29,%r20
-	ldws,ma 	4(0,%r25),%r29
-	stws,ma 	%r20,4(0,%r26)
-	vshd		%r29,%r22,%r20
-	ldws,ma 	4(0,%r25),%r22
-	stws,ma 	%r20,4(0,%r26)
-	vshd		%r22,%r29,%r20
-	ldws,ma 	4(0,%r25),%r29
-	stws,ma 	%r20,4(0,%r26)
-	addib,> 	-4,%r24,L$roop
-	vshd		%r29,%r22,%r20
-
-L$rrest addib,= 	4,%r24,L$rend1
-	nop
-L$eroop ldws,ma 	4(0,%r25),%r22
-	stws,ma 	%r20,4(0,%r26)
-	addib,<=	-1,%r24,L$rend2
-	vshd		%r22,%r29,%r20
-	ldws,ma 	4(0,%r25),%r29
-	stws,ma 	%r20,4(0,%r26)
-	addib,> 	-1,%r24,L$eroop
-	vshd		%r29,%r22,%r20
-
-L$rend1  stws,ma	 %r20,4(0,%r26)
-	vshd		%r0,%r29,%r20
-	bv		0(%r2)
-	stw		%r20,0(0,%r26)
-L$rend2  stws,ma	 %r20,4(0,%r26)
-L$r004	vshd		%r0,%r22,%r20
-	bv		0(%r2)
-	stw		%r20,0(0,%r26)
-
-	.exit
-	.procend
-
-
diff -urN gnupg-0.2.18/mpi/sparc32/distfiles gnupg-0.2.19/mpi/sparc32/distfiles
--- gnupg-0.2.18/mpi/sparc32/distfiles	Thu Jan  8 13:58:53 1998
+++ gnupg-0.2.19/mpi/sparc32/distfiles	Mon May 18 13:34:45 1998
@@ -1,4 +1,6 @@
 
+mpih-lshift.S
+mpih-rshift.S
 mpih-add1.S
 udiv.S
 
diff -urN gnupg-0.2.18/mpi/sparc32/mpih-add1.S gnupg-0.2.19/mpi/sparc32/mpih-add1.S
--- gnupg-0.2.18/mpi/sparc32/mpih-add1.S	Mon Feb 23 13:20:24 1998
+++ gnupg-0.2.19/mpi/sparc32/mpih-add1.S	Mon May 18 13:35:32 1998
@@ -1,24 +1,25 @@
-! SPARC __mpn_add_n -- Add two limb vectors of the same length > 0 and store
-! sum in a third limb vector.
+/* SPARC _add_n -- Add two limb vectors of the same length > 0 and store
+ *		   sum in a third limb vector.
+ *
+ * Copyright (C) 1995, 1996, 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
 
-! Copyright (C) 1995, 1996 Free Software Foundation, Inc.
-
-! This file is part of the GNU MP Library.
-
-! The GNU MP Library is free software; you can redistribute it and/or modify
-! it under the terms of the GNU Library General Public License as published by
-! the Free Software Foundation; either version 2 of the License, or (at your
-! option) any later version.
-
-! The GNU MP Library is distributed in the hope that it will be useful, but
-! WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
-! or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU Library General Public
-! License for more details.
-
-! You should have received a copy of the GNU Library General Public License
-! along with the GNU MP Library; see the file COPYING.LIB.  If not, write to
-! the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
-! MA 02111-1307, USA.
 
 
 /*******************
diff -urN gnupg-0.2.18/mpi/sparc32/mpih-lshift.S gnupg-0.2.19/mpi/sparc32/mpih-lshift.S
--- gnupg-0.2.18/mpi/sparc32/mpih-lshift.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/mpi/sparc32/mpih-lshift.S	Mon May 18 13:31:30 1998
@@ -0,0 +1,96 @@
+/* sparc lshift
+ *
+ * Copyright (C) 1995, 1996, 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+
+! INPUT PARAMETERS
+! res_ptr	%o0
+! src_ptr	%o1
+! size		%o2
+! cnt		%o3
+
+#include "sysdep.h"
+
+	.text
+	.align	4
+	.global C_SYMBOL_NAME(mpihelp_lshift)
+C_SYMBOL_NAME(mpihelp_lshift):
+	sll	%o2,2,%g1
+	add	%o1,%g1,%o1	! make %o1 point at end of src
+	ld	[%o1-4],%g2	! load first limb
+	sub	%g0,%o3,%o5	! negate shift count
+	add	%o0,%g1,%o0	! make %o0 point at end of res
+	add	%o2,-1,%o2
+	andcc	%o2,4-1,%g4	! number of limbs in first loop
+	srl	%g2,%o5,%g1	! compute function result
+	be	L0		! if multiple of 4 limbs, skip first loop
+	st	%g1,[%sp+80]
+
+	sub	%o2,%g4,%o2	! adjust count for main loop
+
+Loop0:	ld	[%o1-8],%g3
+	add	%o0,-4,%o0
+	add	%o1,-4,%o1
+	addcc	%g4,-1,%g4
+	sll	%g2,%o3,%o4
+	srl	%g3,%o5,%g1
+	mov	%g3,%g2
+	or	%o4,%g1,%o4
+	bne	Loop0
+	 st	%o4,[%o0+0]
+
+L0:	tst	%o2
+	be	Lend
+	 nop
+
+Loop:	ld	[%o1-8],%g3
+	add	%o0,-16,%o0
+	addcc	%o2,-4,%o2
+	sll	%g2,%o3,%o4
+	srl	%g3,%o5,%g1
+
+	ld	[%o1-12],%g2
+	sll	%g3,%o3,%g4
+	or	%o4,%g1,%o4
+	st	%o4,[%o0+12]
+	srl	%g2,%o5,%g1
+
+	ld	[%o1-16],%g3
+	sll	%g2,%o3,%o4
+	or	%g4,%g1,%g4
+	st	%g4,[%o0+8]
+	srl	%g3,%o5,%g1
+
+	ld	[%o1-20],%g2
+	sll	%g3,%o3,%g4
+	or	%o4,%g1,%o4
+	st	%o4,[%o0+4]
+	srl	%g2,%o5,%g1
+
+	add	%o1,-16,%o1
+	or	%g4,%g1,%g4
+	bne	Loop
+	 st	%g4,[%o0+0]
+
+Lend:	sll	%g2,%o3,%g2
+	st	%g2,[%o0-4]
+	retl
+	ld	[%sp+80],%o0
+
diff -urN gnupg-0.2.18/mpi/sparc32/mpih-rshift.S gnupg-0.2.19/mpi/sparc32/mpih-rshift.S
--- gnupg-0.2.18/mpi/sparc32/mpih-rshift.S	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/mpi/sparc32/mpih-rshift.S	Mon May 18 13:33:20 1998
@@ -0,0 +1,92 @@
+/* sparc rshift
+ *
+ * Copyright (C) 1995, 1996, 1998 Free Software Foundation, Inc.
+ *
+ * This file is part of GNUPG.
+ *
+ * GNUPG is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * GNUPG is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ */
+
+! INPUT PARAMETERS
+! res_ptr	%o0
+! src_ptr	%o1
+! size		%o2
+! cnt		%o3
+
+#include "sysdep.h"
+
+	.text
+	.align	4
+	.global C_SYMBOL_NAME(mpohelp_rshift)
+C_SYMBOL_NAME(mpihelp_rshift):
+	ld	[%o1],%g2	! load first limb
+	sub	%g0,%o3,%o5	! negate shift count
+	add	%o2,-1,%o2
+	andcc	%o2,4-1,%g4	! number of limbs in first loop
+	sll	%g2,%o5,%g1	! compute function result
+	be	L0		! if multiple of 4 limbs, skip first loop
+	st	%g1,[%sp+80]
+
+	sub	%o2,%g4,%o2	! adjust count for main loop
+
+Loop0:	ld	[%o1+4],%g3
+	add	%o0,4,%o0
+	add	%o1,4,%o1
+	addcc	%g4,-1,%g4
+	srl	%g2,%o3,%o4
+	sll	%g3,%o5,%g1
+	mov	%g3,%g2
+	or	%o4,%g1,%o4
+	bne	Loop0
+	 st	%o4,[%o0-4]
+
+L0:	tst	%o2
+	be	Lend
+	 nop
+
+Loop:	ld	[%o1+4],%g3
+	add	%o0,16,%o0
+	addcc	%o2,-4,%o2
+	srl	%g2,%o3,%o4
+	sll	%g3,%o5,%g1
+
+	ld	[%o1+8],%g2
+	srl	%g3,%o3,%g4
+	or	%o4,%g1,%o4
+	st	%o4,[%o0-16]
+	sll	%g2,%o5,%g1
+
+	ld	[%o1+12],%g3
+	srl	%g2,%o3,%o4
+	or	%g4,%g1,%g4
+	st	%g4,[%o0-12]
+	sll	%g3,%o5,%g1
+
+	ld	[%o1+16],%g2
+	srl	%g3,%o3,%g4
+	or	%o4,%g1,%o4
+	st	%o4,[%o0-8]
+	sll	%g2,%o5,%g1
+
+	add	%o1,16,%o1
+	or	%g4,%g1,%g4
+	bne	Loop
+	 st	%g4,[%o0-4]
+
+Lend:	srl	%g2,%o3,%g2
+	st	%g2,[%o0-0]
+	retl
+	ld	[%sp+80],%o0
+
diff -urN gnupg-0.2.18/po/ChangeLog gnupg-0.2.19/po/ChangeLog
--- gnupg-0.2.18/po/ChangeLog	Thu Apr  9 10:03:32 1998
+++ gnupg-0.2.19/po/ChangeLog	Thu May 28 10:44:50 1998
@@ -1,3 +1,7 @@
+Thu May 28 10:44:25 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* it.po: Add small corrections from Marco
+
 Thu Apr  9 10:03:14 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* it.po: New version from Marco
diff -urN gnupg-0.2.18/po/cat-id-tbl.c gnupg-0.2.19/po/cat-id-tbl.c
--- gnupg-0.2.18/po/cat-id-tbl.c	Fri May 15 15:51:46 1998
+++ gnupg-0.2.19/po/cat-id-tbl.c	Thu May 28 10:43:06 1998
@@ -24,48 +24,49 @@
   {"list keys and signatures", 13},
   {"check key signatures", 14},
   {"list keys and fingerprints", 15},
-  {"generate a new key pair", 16},
-  {"add a subkey to a key pair", 17},
-  {"make a signature on a key in the keyring", 18},
-  {"remove key from the public keyring", 19},
-  {"edit a key signature", 20},
-  {"change the passphrase of your secret keyring", 21},
-  {"generate a revocation certificate", 22},
-  {"export keys", 23},
-  {"import/merge keys", 24},
-  {"list only the sequence of packets", 25},
-  {"De-Armor a file or stdin", 26},
-  {"En-Armor a file or stdin", 27},
-  {"|algo [files]|print message digests", 28},
-  {"print all message digests", 29},
+  {"list secret keys", 16},
+  {"generate a new key pair", 17},
+  {"add a subkey to a key pair", 18},
+  {"make a signature on a key in the keyring", 19},
+  {"remove key from the public keyring", 20},
+  {"edit a key signature", 21},
+  {"change the passphrase of your secret keyring", 22},
+  {"generate a revocation certificate", 23},
+  {"export keys", 24},
+  {"import/merge keys", 25},
+  {"list only the sequence of packets", 26},
+  {"De-Armor a file or stdin", 27},
+  {"En-Armor a file or stdin", 28},
+  {"|algo [files]|print message digests", 29},
+  {"print all message digests", 30},
   {"\
 @\n\
 Options:\n\
- ", 30},
-  {"create ascii armored output", 31},
-  {"use this user-id to sign or decrypt", 32},
-  {"use this user-id for encryption", 33},
-  {"|N|set compress level N (0 disables)", 34},
-  {"use canonical text mode", 35},
-  {"use as output file", 36},
-  {"verbose", 37},
-  {"do not make any changes", 38},
-  {"batch mode: never ask", 39},
-  {"assume yes on most questions", 40},
-  {"assume no on most questions", 41},
-  {"add this keyring to the list of keyrings", 42},
-  {"add this secret keyring to the list", 43},
-  {"read options from file", 44},
-  {"set debugging flags", 45},
-  {"enable full debugging", 46},
-  {"|FD|write status info to this FD", 47},
-  {"do not write comment packets", 48},
-  {"(default is 1)", 49},
-  {"(default is 3)", 50},
-  {"|NAME|use cipher algorithm NAME", 51},
-  {"|NAME|use public key algorithm NAME", 52},
-  {"|NAME|use message digest algorithm NAME", 53},
-  {"|N|use compress algorithm N", 54},
+ ", 31},
+  {"create ascii armored output", 32},
+  {"use this user-id to sign or decrypt", 33},
+  {"use this user-id for encryption", 34},
+  {"|N|set compress level N (0 disables)", 35},
+  {"use canonical text mode", 36},
+  {"use as output file", 37},
+  {"verbose", 38},
+  {"do not make any changes", 39},
+  {"batch mode: never ask", 40},
+  {"assume yes on most questions", 41},
+  {"assume no on most questions", 42},
+  {"add this keyring to the list of keyrings", 43},
+  {"add this secret keyring to the list", 44},
+  {"read options from file", 45},
+  {"set debugging flags", 46},
+  {"enable full debugging", 47},
+  {"|FD|write status info to this FD", 48},
+  {"do not write comment packets", 49},
+  {"(default is 1)", 50},
+  {"(default is 3)", 51},
+  {"|NAME|use cipher algorithm NAME", 52},
+  {"|NAME|use public key algorithm NAME", 53},
+  {"|NAME|use message digest algorithm NAME", 54},
+  {"|N|use compress algorithm N", 55},
   {"\
 @\n\
 Examples:\n\
@@ -74,52 +75,52 @@
  -sat [file]                make a clear text signature\n\
  -sb  [file]                make a detached signature\n\
  -k   [userid]              show keys\n\
- -kc  [userid]              show fingerprint\n", 55},
-  {"Please report bugs to <gnupg-bugs@isil.d.shuttle.de>.\n", 56},
-  {"Usage: gpgm [options] [files] (-h for help)", 57},
-  {"Usage: gpg [options] [files] (-h for help)", 58},
+ -kc  [userid]              show fingerprint\n", 56},
+  {"Please report bugs to <gnupg-bugs@gnu.org>.\n", 57},
+  {"Usage: gpgm [options] [files] (-h for help)", 58},
+  {"Usage: gpg [options] [files] (-h for help)", 59},
   {"\
 Syntax: gpgm [options] [files]\n\
-GNUPG maintenance utility\n", 59},
+GNUPG maintenance utility\n", 60},
   {"\
 Syntax: gpg [options] [files]\n\
 sign, check, encrypt or decrypt\n\
-default operation depends on the input data\n", 60},
-  {"usage: gpgm [options] ", 61},
-  {"usage: gpg [options] ", 62},
-  {"conflicting commands\n", 63},
-  {"selected cipher algorithm is invalid\n", 64},
-  {"selected pubkey algorithm is invalid\n", 65},
-  {"selected digest algorithm is invalid\n", 66},
-  {"compress algorithm must be in range %d..%d\n", 67},
-  {"completes-needed must be greater than 0\n", 68},
-  {"marginals-needed must be greater than 1\n", 69},
-  {"note: no default option file '%s'\n", 70},
-  {"option file '%s': %s\n", 71},
-  {"reading options from '%s'\n", 72},
-  {"failed to initialize the TrustDB: %s\n", 73},
-  {"--store [filename]", 74},
-  {"--symmetric [filename]", 75},
-  {"--encrypt [filename]", 76},
-  {"--sign [filename]", 77},
-  {"--sign --encrypt [filename]", 78},
-  {"--clearsign [filename]", 79},
-  {"--decrypt [filename]", 80},
-  {"--sign-key username", 81},
-  {"--edit-sig username", 82},
-  {"--delete-secret-key username", 83},
-  {"--delete-key username", 84},
-  {"--change-passphrase [username]", 85},
-  {"can't open %s: %s\n", 86},
-  {"-k[v][v][v][c] [userid] [keyring]", 87},
-  {"dearmoring failed: %s\n", 88},
-  {"enarmoring failed: %s\n", 89},
-  {"invalid hash algorithm '%s'\n", 90},
-  {"[filename]", 91},
-  {"can't open '%s'\n", 92},
+default operation depends on the input data\n", 61},
+  {"usage: gpgm [options] ", 62},
+  {"usage: gpg [options] ", 63},
+  {"conflicting commands\n", 64},
+  {"selected cipher algorithm is invalid\n", 65},
+  {"selected pubkey algorithm is invalid\n", 66},
+  {"selected digest algorithm is invalid\n", 67},
+  {"compress algorithm must be in range %d..%d\n", 68},
+  {"completes-needed must be greater than 0\n", 69},
+  {"marginals-needed must be greater than 1\n", 70},
+  {"note: no default option file '%s'\n", 71},
+  {"option file '%s': %s\n", 72},
+  {"reading options from '%s'\n", 73},
+  {"failed to initialize the TrustDB: %s\n", 74},
+  {"--store [filename]", 75},
+  {"--symmetric [filename]", 76},
+  {"--encrypt [filename]", 77},
+  {"--sign [filename]", 78},
+  {"--sign --encrypt [filename]", 79},
+  {"--clearsign [filename]", 80},
+  {"--decrypt [filename]", 81},
+  {"--sign-key username", 82},
+  {"--edit-sig username", 83},
+  {"--delete-secret-key username", 84},
+  {"--delete-key username", 85},
+  {"--change-passphrase [username]", 86},
+  {"can't open %s: %s\n", 87},
+  {"-k[v][v][v][c] [userid] [keyring]", 88},
+  {"dearmoring failed: %s\n", 89},
+  {"enarmoring failed: %s\n", 90},
+  {"invalid hash algorithm '%s'\n", 91},
+  {"[filename]", 92},
+  {"can't open '%s'\n", 93},
   {"\
 No ownertrust defined for %lu:\n\
-%4u%c/%08lX %s \"", 93},
+%4u%c/%08lX %s \"", 94},
   {"\
 \"\n\
 \n\
@@ -132,101 +133,108 @@
  3 = I trust marginally\n\
  4 = I trust fully\n\
  s = please show me more information\n\
-\n", 94},
-  {"Your decision? ", 95},
+\n", 95},
+  {"Your decision? ", 96},
   {"\
 It's up to you to assign a value here; this value will never be exported\n\
 to any 3rd party.  We need it to implement the web-of-trust; it has nothing\n\
-to do with the (implicitly created) web-of-certificates.\n", 96},
-  {"You will see a list of signators etc. here\n", 97},
+to do with the (implicitly created) web-of-certificates.\n", 97},
+  {"You will see a list of signators etc. here\n", 98},
   {"\
 Could not find a valid trust path to the key.  Let's see whether we\n\
 can assign some missing owner trust values.\n\
-\n", 98},
+\n", 99},
   {"\
 No ownertrust values changed.\n\
-\n", 99},
+\n", 100},
   {"\
 It is NOT certain that the key belongs to its owner.\n\
 If you *really* know what you are doing, you may answer\n\
 the next question with yes\n\
-\n", 100},
+\n", 101},
+  {"WARNING: Using untrusted key!\n", 102},
   {"\
 You did not specify a user ID. (you may use \"-r\")\n\
-\n", 101},
-  {"Enter the user ID: ", 102},
-  {"writing self signature\n", 103},
-  {"Key generation can only be used in interactive mode\n", 104},
+\n", 103},
+  {"Enter the user ID: ", 104},
+  {"writing self signature\n", 105},
+  {"writing key binding signature\n", 106},
   {"\
 Please select the algorithm to use:\n\
    (1) ElGamal is the suggested one.\n\
-   (2) DSA can only be used for signatures.\n", 105},
-  {"   (3) RSA cannot be used in the U.S.\n", 106},
-  {"Your selection? (1,2,3) ", 107},
-  {"Your selection? (1,2) ", 108},
+   (2) ElGamal using v4 packets (OpenPGP)\n\
+   (3) DSA can only be used for signatures.\n", 107},
+  {"   (4) RSA cannot be used in the U.S.\n", 108},
+  {"Your selection? (1,2,3,4) ", 109},
+  {"Your selection? (1,2,3) ", 110},
   {"\
 About to generate a new %s keypair.\n\
               minimum keysize is  768 bits\n\
               default keysize is 1024 bits\n\
-    highest suggested keysize is 2048 bits\n", 109},
-  {"What keysize do you want? (1024) ", 110},
-  {"DSA only allows keysizes from 512 to 1024\n", 111},
-  {"keysize too small; 768 is smallest value allowed.\n", 112},
-  {"Keysizes larger than 2048 are not suggested, because computations take REALLY long!\n", 113},
-  {"Are you sure, that you want this keysize? ", 114},
-  {"Okay, but keep in mind that your monitor and keyboard radiation is also very vulnerable to attacks!\n", 115},
-  {"Do you really need such a large keysize? ", 116},
-  {"Requested keysize is %u bits\n", 117},
-  {"rounded up to %u bits\n", 118},
+    highest suggested keysize is 2048 bits\n", 111},
+  {"What keysize do you want? (1024) ", 112},
+  {"DSA only allows keysizes from 512 to 1024\n", 113},
+  {"keysize too small; 768 is smallest value allowed.\n", 114},
+  {"Keysizes larger than 2048 are not suggested, because computations take REALLY long!\n", 115},
+  {"Are you sure, that you want this keysize? ", 116},
+  {"Okay, but keep in mind that your monitor and keyboard radiation is also very vulnerable to attacks!\n", 117},
+  {"Do you really need such a large keysize? ", 118},
+  {"Requested keysize is %u bits\n", 119},
+  {"rounded up to %u bits\n", 120},
   {"\
 Please specify how long the key should be valid.\n\
          0 = key does not expire\n\
       <n>  = key expires in n days\n\
       <n>w = key expires in n weeks\n\
       <n>m = key expires in n months\n\
-      <n>y = key expires in n years\n", 119},
-  {"Key is valid for? (0) ", 120},
-  {"invalid value\n", 121},
-  {"Key does not expire at all\n", 122},
-  {"Key expires at %s\n", 123},
-  {"Is this correct (y/n)? ", 124},
+      <n>y = key expires in n years\n", 121},
+  {"Key is valid for? (0) ", 122},
+  {"invalid value\n", 123},
+  {"Key does not expire at all\n", 124},
+  {"Key expires at %s\n", 125},
+  {"Is this correct (y/n)? ", 126},
   {"\
 \n\
 You need a User-ID to identify your key; the software constructs the user id\n\
 from Real Name, Comment and Email Address in this form:\n\
     \"Heinrich Heine (Der Dichter) <heinrichh@duesseldorf.de>\"\n\
-\n", 125},
-  {"Real name: ", 126},
-  {"Invalid character in name\n", 127},
-  {"Name may not start with a digit\n", 128},
-  {"Name must be at least 5 characters long\n", 129},
-  {"Email address: ", 130},
-  {"Not a valid email address\n", 131},
-  {"Comment: ", 132},
-  {"Invalid character in comment\n", 133},
+\n", 127},
+  {"Real name: ", 128},
+  {"Invalid character in name\n", 129},
+  {"Name may not start with a digit\n", 130},
+  {"Name must be at least 5 characters long\n", 131},
+  {"Email address: ", 132},
+  {"Not a valid email address\n", 133},
+  {"Comment: ", 134},
+  {"Invalid character in comment\n", 135},
   {"\
 You selected this USER-ID:\n\
     \"%s\"\n\
-\n", 134},
-  {"Edit (N)ame, (C)omment, (E)mail or (O)kay? ", 135},
+\n", 136},
+  {"Edit (N)ame, (C)omment, (E)mail or (O)kay? ", 137},
   {"\
 You need a Passphrase to protect your secret key.\n\
-\n", 136},
-  {"passphrase not correctly repeated; try again.\n", 137},
+\n", 138},
+  {"passphrase not correctly repeated; try again.\n", 139},
   {"\
 You don't want a passphrase - this is probably a *bad* idea!\n\
 I will do it anyway.  You can change your passphrase at any time,\n\
 using this program with the option \"--change-passphrase\"\n\
-\n", 138},
-  {"writing public certificate to '%s'\n", 139},
-  {"writing secret certificate to '%s'\n", 140},
+\n", 140},
   {"\
 We need to generate a lot of random bytes. It is a good idea to perform\n\
 some other action (work in another window, move the mouse, utilize the\n\
 network and the disks) during the prime generation; this gives the random\n\
 number generator a better chance to gain enough entropy.\n", 141},
-  {"public and secret key created and signed.\n", 142},
-  {"Key generation failed: %s\n", 143},
+  {"Key generation can only be used in interactive mode\n", 142},
+  {"writing public certificate to '%s'\n", 143},
+  {"writing secret certificate to '%s'\n", 144},
+  {"public and secret key created and signed.\n", 145},
+  {"\
+Note that this key cannot be used for encryption.  You may want to use\n\
+the command \"--add-key\" to generate a secondary key for this purpose.\n", 146},
+  {"Key generation failed: %s\n", 147},
+  {"public and secret subkey created.\n", 148},
 };
 
-int _msg_tbl_length = 143;
+int _msg_tbl_length = 148;
diff -urN gnupg-0.2.18/po/gnupg.pot gnupg-0.2.19/po/gnupg.pot
--- gnupg-0.2.18/po/gnupg.pot	Fri May 15 18:31:44 1998
+++ gnupg-0.2.19/po/gnupg.pot	Fri May 29 11:45:06 1998
@@ -1,6 +1,6 @@
 msgid ""
 msgstr ""
-"Date: 1998-05-15 18:31:44+0200\n"
+"Date: 1998-05-29 11:45:05+0200\n"
 "From: Werner Koch <wk@frodo>\n"
 "Content-Type: text/plain; charset=\n"
 "Xgettext-Options: --default-domain=gnupg --directory=.. --add-comments --keyword=_ --keyword=N_ --files-from=./POTFILES.in\n"
@@ -64,63 +64,67 @@
 msgid "list keys and fingerprints"
 msgstr ""
 
-#: g10/g10.c:68
-msgid "generate a new key pair"
+#: g10/g10.c:67
+msgid "list secret keys"
 msgstr ""
 
 #: g10/g10.c:69
-msgid "add a subkey to a key pair"
+msgid "generate a new key pair"
 msgstr ""
 
 #: g10/g10.c:70
-msgid "make a signature on a key in the keyring"
+msgid "add a subkey to a key pair"
 msgstr ""
 
 #: g10/g10.c:71
-msgid "remove key from the public keyring"
+msgid "make a signature on a key in the keyring"
 msgstr ""
 
 #: g10/g10.c:72
-msgid "edit a key signature"
+msgid "remove key from the public keyring"
 msgstr ""
 
 #: g10/g10.c:73
-msgid "change the passphrase of your secret keyring"
+msgid "edit a key signature"
 msgstr ""
 
 #: g10/g10.c:74
+msgid "change the passphrase of your secret keyring"
+msgstr ""
+
+#: g10/g10.c:75
 msgid "generate a revocation certificate"
 msgstr ""
 
-#: g10/g10.c:76
+#: g10/g10.c:77
 msgid "export keys"
 msgstr ""
 
-#: g10/g10.c:77
+#: g10/g10.c:78
 msgid "import/merge keys"
 msgstr ""
 
-#: g10/g10.c:78
+#: g10/g10.c:79
 msgid "list only the sequence of packets"
 msgstr ""
 
-#: g10/g10.c:80
+#: g10/g10.c:81
 msgid "De-Armor a file or stdin"
 msgstr ""
 
-#: g10/g10.c:81
+#: g10/g10.c:82
 msgid "En-Armor a file or stdin"
 msgstr ""
 
-#: g10/g10.c:82
+#: g10/g10.c:83
 msgid "|algo [files]|print message digests"
 msgstr ""
 
-#: g10/g10.c:83
+#: g10/g10.c:84
 msgid "print all message digests"
 msgstr ""
 
-#: g10/g10.c:88
+#: g10/g10.c:89
 msgid ""
 "@\n"
 "Options:\n"
@@ -131,99 +135,99 @@
 msgid "create ascii armored output"
 msgstr ""
 
-#: g10/g10.c:92
+#: g10/g10.c:93
 msgid "use this user-id to sign or decrypt"
 msgstr ""
 
-#: g10/g10.c:93
+#: g10/g10.c:94
 msgid "use this user-id for encryption"
 msgstr ""
 
-#: g10/g10.c:94
+#: g10/g10.c:95
 msgid "|N|set compress level N (0 disables)"
 msgstr ""
 
-#: g10/g10.c:95
+#: g10/g10.c:96
 msgid "use canonical text mode"
 msgstr ""
 
-#: g10/g10.c:97
+#: g10/g10.c:98
 msgid "use as output file"
 msgstr ""
 
-#: g10/g10.c:98
+#: g10/g10.c:99
 msgid "verbose"
 msgstr ""
 
-#: g10/g10.c:99
+#: g10/g10.c:100
 msgid "do not make any changes"
 msgstr ""
 
-#: g10/g10.c:100
+#: g10/g10.c:101
 msgid "batch mode: never ask"
 msgstr ""
 
-#: g10/g10.c:101
+#: g10/g10.c:102
 msgid "assume yes on most questions"
 msgstr ""
 
-#: g10/g10.c:102
+#: g10/g10.c:103
 msgid "assume no on most questions"
 msgstr ""
 
-#: g10/g10.c:103
+#: g10/g10.c:104
 msgid "add this keyring to the list of keyrings"
 msgstr ""
 
-#: g10/g10.c:104
+#: g10/g10.c:105
 msgid "add this secret keyring to the list"
 msgstr ""
 
-#: g10/g10.c:105
+#: g10/g10.c:106
 msgid "read options from file"
 msgstr ""
 
-#: g10/g10.c:107
+#: g10/g10.c:108
 msgid "set debugging flags"
 msgstr ""
 
-#: g10/g10.c:108
+#: g10/g10.c:109
 msgid "enable full debugging"
 msgstr ""
 
-#: g10/g10.c:109
+#: g10/g10.c:110
 msgid "|FD|write status info to this FD"
 msgstr ""
 
-#: g10/g10.c:110
+#: g10/g10.c:111
 msgid "do not write comment packets"
 msgstr ""
 
-#: g10/g10.c:111
+#: g10/g10.c:112
 msgid "(default is 1)"
 msgstr ""
 
-#: g10/g10.c:112
+#: g10/g10.c:113
 msgid "(default is 3)"
 msgstr ""
 
-#: g10/g10.c:114
+#: g10/g10.c:115
 msgid "|NAME|use cipher algorithm NAME"
 msgstr ""
 
-#: g10/g10.c:115
+#: g10/g10.c:116
 msgid "|NAME|use public key algorithm NAME"
 msgstr ""
 
-#: g10/g10.c:116
+#: g10/g10.c:117
 msgid "|NAME|use message digest algorithm NAME"
 msgstr ""
 
-#: g10/g10.c:117
+#: g10/g10.c:118
 msgid "|N|use compress algorithm N"
 msgstr ""
 
-#: g10/g10.c:126
+#: g10/g10.c:127
 msgid ""
 "@\n"
 "Examples:\n"
@@ -235,161 +239,161 @@
 " -kc  [userid]              show fingerprint\n"
 msgstr ""
 
-#: g10/g10.c:204
-msgid "Please report bugs to <gnupg-bugs@isil.d.shuttle.de>.\n"
+#: g10/g10.c:207
+msgid "Please report bugs to <gnupg-bugs@gnu.org>.\n"
 msgstr ""
 
-#: g10/g10.c:209
+#: g10/g10.c:212
 msgid "Usage: gpgm [options] [files] (-h for help)"
 msgstr ""
 
-#: g10/g10.c:211
+#: g10/g10.c:214
 msgid "Usage: gpg [options] [files] (-h for help)"
 msgstr ""
 
-#: g10/g10.c:216
+#: g10/g10.c:219
 msgid ""
 "Syntax: gpgm [options] [files]\n"
 "GNUPG maintenance utility\n"
 msgstr ""
 
-#: g10/g10.c:219
+#: g10/g10.c:222
 msgid ""
 "Syntax: gpg [options] [files]\n"
 "sign, check, encrypt or decrypt\n"
 "default operation depends on the input data\n"
 msgstr ""
 
-#: g10/g10.c:296
+#: g10/g10.c:299
 msgid "usage: gpgm [options] "
 msgstr ""
 
-#: g10/g10.c:298
+#: g10/g10.c:301
 msgid "usage: gpg [options] "
 msgstr ""
 
-#: g10/g10.c:338
+#: g10/g10.c:341
 msgid "conflicting commands\n"
 msgstr ""
 
-#: g10/g10.c:351
+#: g10/g10.c:354
 msgid "selected cipher algorithm is invalid\n"
 msgstr ""
 
-#: g10/g10.c:353
+#: g10/g10.c:356
 msgid "selected pubkey algorithm is invalid\n"
 msgstr ""
 
-#: g10/g10.c:355
+#: g10/g10.c:358
 msgid "selected digest algorithm is invalid\n"
 msgstr ""
 
-#: g10/g10.c:357
+#: g10/g10.c:360
 msgid "compress algorithm must be in range %d..%d\n"
 msgstr ""
 
-#: g10/g10.c:359
+#: g10/g10.c:362
 msgid "completes-needed must be greater than 0\n"
 msgstr ""
 
-#: g10/g10.c:361
+#: g10/g10.c:364
 msgid "marginals-needed must be greater than 1\n"
 msgstr ""
 
-#: g10/g10.c:458
+#: g10/g10.c:461
 msgid "note: no default option file '%s'\n"
 msgstr ""
 
-#: g10/g10.c:462
+#: g10/g10.c:465
 msgid "option file '%s': %s\n"
 msgstr ""
 
-#: g10/g10.c:469
+#: g10/g10.c:472
 msgid "reading options from '%s'\n"
 msgstr ""
 
-#: g10/g10.c:677
+#: g10/g10.c:686
 msgid "failed to initialize the TrustDB: %s\n"
 msgstr ""
 
 #. only store the file
-#: g10/g10.c:683
+#: g10/g10.c:692
 msgid "--store [filename]"
 msgstr ""
 
-#: g10/g10.c:691
+#: g10/g10.c:700
 msgid "--symmetric [filename]"
 msgstr ""
 
 #. encrypt the given file
-#: g10/g10.c:699
+#: g10/g10.c:708
 msgid "--encrypt [filename]"
 msgstr ""
 
-#: g10/g10.c:712
+#: g10/g10.c:721
 msgid "--sign [filename]"
 msgstr ""
 
-#: g10/g10.c:725
+#: g10/g10.c:734
 msgid "--sign --encrypt [filename]"
 msgstr ""
 
-#: g10/g10.c:739
+#: g10/g10.c:748
 msgid "--clearsign [filename]"
 msgstr ""
 
-#: g10/g10.c:751
+#: g10/g10.c:760
 msgid "--decrypt [filename]"
 msgstr ""
 
 #. sign the key given as argument
-#: g10/g10.c:759
+#: g10/g10.c:768
 msgid "--sign-key username"
 msgstr ""
 
-#: g10/g10.c:767
+#: g10/g10.c:776
 msgid "--edit-sig username"
 msgstr ""
 
-#: g10/g10.c:775
+#: g10/g10.c:784
 msgid "--delete-secret-key username"
 msgstr ""
 
-#: g10/g10.c:778
+#: g10/g10.c:787
 msgid "--delete-key username"
 msgstr ""
 
 #. Change the passphrase
 #. no arg: use default, 1 arg use this one
-#: g10/g10.c:786
+#: g10/g10.c:795
 msgid "--change-passphrase [username]"
 msgstr ""
 
-#: g10/g10.c:807
+#: g10/g10.c:819
 msgid "can't open %s: %s\n"
 msgstr ""
 
-#: g10/g10.c:818
+#: g10/g10.c:830
 msgid "-k[v][v][v][c] [userid] [keyring]"
 msgstr ""
 
-#: g10/g10.c:870
+#: g10/g10.c:882
 msgid "dearmoring failed: %s\n"
 msgstr ""
 
-#: g10/g10.c:878
+#: g10/g10.c:890
 msgid "enarmoring failed: %s\n"
 msgstr ""
 
-#: g10/g10.c:934
+#: g10/g10.c:946
 msgid "invalid hash algorithm '%s'\n"
 msgstr ""
 
-#: g10/g10.c:984
+#: g10/g10.c:996
 msgid "[filename]"
 msgstr ""
 
-#: g10/g10.c:986
+#: g10/g10.c:998
 msgid "can't open '%s'\n"
 msgstr ""
 
@@ -451,13 +455,17 @@
 "\n"
 msgstr ""
 
-#: g10/pkclist.c:304
+#: g10/pkclist.c:278
+msgid "WARNING: Using untrusted key!\n"
+msgstr ""
+
+#: g10/pkclist.c:308
 msgid ""
 "You did not specify a user ID. (you may use \"-r\")\n"
 "\n"
 msgstr ""
 
-#: g10/pkclist.c:308
+#: g10/pkclist.c:312
 msgid "Enter the user ID: "
 msgstr ""
 
@@ -465,30 +473,31 @@
 msgid "writing self signature\n"
 msgstr ""
 
-#: g10/keygen.c:360
-msgid "Key generation can only be used in interactive mode\n"
+#: g10/keygen.c:105
+msgid "writing key binding signature\n"
 msgstr ""
 
-#: g10/keygen.c:364
+#: g10/keygen.c:385
 msgid ""
 "Please select the algorithm to use:\n"
 "   (1) ElGamal is the suggested one.\n"
-"   (2) DSA can only be used for signatures.\n"
+"   (2) ElGamal using v4 packets (OpenPGP)\n"
+"   (3) DSA can only be used for signatures.\n"
 msgstr ""
 
-#: g10/keygen.c:368
-msgid "   (3) RSA cannot be used in the U.S.\n"
+#: g10/keygen.c:390
+msgid "   (4) RSA cannot be used in the U.S.\n"
 msgstr ""
 
-#: g10/keygen.c:373
-msgid "Your selection? (1,2,3) "
+#: g10/keygen.c:396
+msgid "Your selection? (1,2,3,4) "
 msgstr ""
 
-#: g10/keygen.c:375
-msgid "Your selection? (1,2) "
+#: g10/keygen.c:398
+msgid "Your selection? (1,2,3) "
 msgstr ""
 
-#: g10/keygen.c:401
+#: g10/keygen.c:431
 msgid ""
 "About to generate a new %s keypair.\n"
 "              minimum keysize is  768 bits\n"
@@ -496,43 +505,43 @@
 "    highest suggested keysize is 2048 bits\n"
 msgstr ""
 
-#: g10/keygen.c:406
+#: g10/keygen.c:437
 msgid "What keysize do you want? (1024) "
 msgstr ""
 
-#: g10/keygen.c:411
+#: g10/keygen.c:442
 msgid "DSA only allows keysizes from 512 to 1024\n"
 msgstr ""
 
-#: g10/keygen.c:413
+#: g10/keygen.c:444
 msgid "keysize too small; 768 is smallest value allowed.\n"
 msgstr ""
 
-#: g10/keygen.c:415
+#: g10/keygen.c:446
 msgid "Keysizes larger than 2048 are not suggested, because computations take REALLY long!\n"
 msgstr ""
 
-#: g10/keygen.c:417
+#: g10/keygen.c:448
 msgid "Are you sure, that you want this keysize? "
 msgstr ""
 
-#: g10/keygen.c:421
+#: g10/keygen.c:452
 msgid "Okay, but keep in mind that your monitor and keyboard radiation is also very vulnerable to attacks!\n"
 msgstr ""
 
-#: g10/keygen.c:429
+#: g10/keygen.c:460
 msgid "Do you really need such a large keysize? "
 msgstr ""
 
-#: g10/keygen.c:440
+#: g10/keygen.c:471
 msgid "Requested keysize is %u bits\n"
 msgstr ""
 
-#: g10/keygen.c:443 g10/keygen.c:447
+#: g10/keygen.c:474 g10/keygen.c:478
 msgid "rounded up to %u bits\n"
 msgstr ""
 
-#: g10/keygen.c:450
+#: g10/keygen.c:490
 msgid ""
 "Please specify how long the key should be valid.\n"
 "         0 = key does not expire\n"
@@ -542,27 +551,27 @@
 "      <n>y = key expires in n years\n"
 msgstr ""
 
-#: g10/keygen.c:465
+#: g10/keygen.c:505
 msgid "Key is valid for? (0) "
 msgstr ""
 
-#: g10/keygen.c:476
+#: g10/keygen.c:516
 msgid "invalid value\n"
 msgstr ""
 
-#: g10/keygen.c:481
+#: g10/keygen.c:521
 msgid "Key does not expire at all\n"
 msgstr ""
 
-#: g10/keygen.c:483
+#: g10/keygen.c:523
 msgid "Key expires at %s\n"
 msgstr ""
 
-#: g10/keygen.c:488
+#: g10/keygen.c:528
 msgid "Is this correct (y/n)? "
 msgstr ""
 
-#: g10/keygen.c:497
+#: g10/keygen.c:544
 msgid ""
 "\n"
 "You need a User-ID to identify your key; the software constructs the user id\n"
@@ -571,61 +580,60 @@
 "\n"
 msgstr ""
 
-#: g10/keygen.c:509
+#: g10/keygen.c:555
 msgid "Real name: "
 msgstr ""
 
-#: g10/keygen.c:513
+#: g10/keygen.c:559
 msgid "Invalid character in name\n"
 msgstr ""
 
-#: g10/keygen.c:515
+#: g10/keygen.c:561
 msgid "Name may not start with a digit\n"
 msgstr ""
 
-#: g10/keygen.c:517
+#: g10/keygen.c:563
 msgid "Name must be at least 5 characters long\n"
 msgstr ""
 
-#: g10/keygen.c:525
+#: g10/keygen.c:571
 msgid "Email address: "
 msgstr ""
 
-#: g10/keygen.c:537
+#: g10/keygen.c:583
 msgid "Not a valid email address\n"
 msgstr ""
 
-#: g10/keygen.c:545
+#: g10/keygen.c:591
 msgid "Comment: "
 msgstr ""
 
-#: g10/keygen.c:551
+#: g10/keygen.c:597
 msgid "Invalid character in comment\n"
 msgstr ""
 
-#: g10/keygen.c:571
+#: g10/keygen.c:617
 msgid ""
 "You selected this USER-ID:\n"
 "    \"%s\"\n"
 "\n"
 msgstr ""
 
-#. fixme: add a warning if this user-id already exists
-#: g10/keygen.c:574
+#: g10/keygen.c:620
 msgid "Edit (N)ame, (C)omment, (E)mail or (O)kay? "
 msgstr ""
 
-#: g10/keygen.c:605
+#: g10/keygen.c:659
 msgid ""
 "You need a Passphrase to protect your secret key.\n"
 "\n"
 msgstr ""
 
-#: g10/keygen.c:613
+#: g10/keygen.c:667
 msgid "passphrase not correctly repeated; try again.\n"
 msgstr ""
 
-#: g10/keygen.c:619
+#: g10/keygen.c:673
 msgid ""
 "You don't want a passphrase - this is probably a *bad* idea!\n"
 "I will do it anyway.  You can change your passphrase at any time,\n"
@@ -633,15 +641,7 @@
 "\n"
 msgstr ""
 
-#: g10/keygen.c:633
-msgid "writing public certificate to '%s'\n"
-msgstr ""
-
-#: g10/keygen.c:634
-msgid "writing secret certificate to '%s'\n"
-msgstr ""
-
-#: g10/keygen.c:646
+#: g10/keygen.c:694
 msgid ""
 "We need to generate a lot of random bytes. It is a good idea to perform\n"
 "some other action (work in another window, move the mouse, utilize the\n"
@@ -649,10 +649,32 @@
 "number generator a better chance to gain enough entropy.\n"
 msgstr ""
 
-#: g10/keygen.c:720
+#: g10/keygen.c:743 g10/keygen.c:871
+msgid "Key generation can only be used in interactive mode\n"
+msgstr ""
+
+#: g10/keygen.c:758
+msgid "writing public certificate to '%s'\n"
+msgstr ""
+
+#: g10/keygen.c:759
+msgid "writing secret certificate to '%s'\n"
+msgstr ""
+
+#: g10/keygen.c:822
 msgid "public and secret key created and signed.\n"
 msgstr ""
 
-#: g10/keygen.c:731
+#: g10/keygen.c:824
+msgid ""
+"Note that this key cannot be used for encryption.  You may want to use\n"
+"the command \"--add-key\" to generate a secondary key for this purpose.\n"
+msgstr ""
+
+#: g10/keygen.c:838 g10/keygen.c:989
 msgid "Key generation failed: %s\n"
+msgstr ""
+
+#: g10/keygen.c:984
+msgid "public and secret subkey created.\n"
 msgstr ""
diff -urN gnupg-0.2.18/po/it.po gnupg-0.2.19/po/it.po
--- gnupg-0.2.18/po/it.po	Thu May 14 16:54:41 1998
+++ gnupg-0.2.19/po/it.po	Thu May 28 10:44:07 1998
@@ -427,7 +427,7 @@
 #: g10/g10.c:936
 #, c-format
 msgid "can't open '%s'\n"
-msgstr "impossibile aprire '%s'"
+msgstr "impossibile aprire '%s'\n"
 
 # #### Md ???
 #: g10/pkclist.c:65
@@ -616,7 +616,7 @@
 #: g10/keygen.c:386 g10/keygen.c:390
 #, c-format
 msgid "rounded up to %u bits\n"
-msgstr "arrotondate a %u bit"
+msgstr "arrotondate a %u bit\n"
 
 #: g10/keygen.c:397
 msgid ""
diff -urN gnupg-0.2.18/tools/ChangeLog gnupg-0.2.19/tools/ChangeLog
--- gnupg-0.2.18/tools/ChangeLog	Tue Apr  7 19:51:03 1998
+++ gnupg-0.2.19/tools/ChangeLog	Mon May 18 15:39:28 1998
@@ -1,3 +1,7 @@
+Mon May 18 15:39:22 1998  Werner Koch  (wk@isil.d.shuttle.de)
+
+	* mk-tdata.c: New.
+
 Tue Apr  7 19:50:41 1998  Werner Koch  (wk@isil.d.shuttle.de)
 
 	* bftest.c: Now supports all availabe ciphers.
diff -urN gnupg-0.2.18/tools/Makefile.am gnupg-0.2.19/tools/Makefile.am
--- gnupg-0.2.18/tools/Makefile.am	Tue Apr  7 19:50:01 1998
+++ gnupg-0.2.19/tools/Makefile.am	Mon May 18 15:33:39 1998
@@ -4,13 +4,14 @@
 needed_libs = ../cipher/libcipher.a  ../util/libutil.a \
 	      ../mpi/libmpi.a ../util/libutil.a
 
-noinst_PROGRAMS = mpicalc bftest clean-sat
+noinst_PROGRAMS = mpicalc bftest clean-sat mk-tdata
 
 mpicalc_SOURCES = mpicalc.c
 
 bftest_SOURCES = bftest.c
 
 clean_sat_SOURCES  = clean-sat.c
+mk_tdata_SOURCES = mk-tdata.c
 
 
 mpicalc_LDADD = @INTLLIBS@  $(needed_libs)
diff -urN gnupg-0.2.18/tools/Makefile.in gnupg-0.2.19/tools/Makefile.in
--- gnupg-0.2.18/tools/Makefile.in	Fri May 15 18:45:38 1998
+++ gnupg-0.2.19/tools/Makefile.in	Fri May 29 12:56:24 1998
@@ -96,13 +96,14 @@
 needed_libs = ../cipher/libcipher.a  ../util/libutil.a \
 	      ../mpi/libmpi.a ../util/libutil.a
 
-noinst_PROGRAMS = mpicalc bftest clean-sat
+noinst_PROGRAMS = mpicalc bftest clean-sat mk-tdata
 
 mpicalc_SOURCES = mpicalc.c
 
 bftest_SOURCES = bftest.c
 
 clean_sat_SOURCES  = clean-sat.c
+mk_tdata_SOURCES = mk-tdata.c
 
 mpicalc_LDADD = @INTLLIBS@  $(needed_libs)
 bftest_LDADD = @INTLLIBS@  $(needed_libs)
@@ -128,6 +129,10 @@
 clean_sat_LDADD = $(LDADD)
 clean_sat_DEPENDENCIES = 
 clean_sat_LDFLAGS = 
+mk_tdata_OBJECTS =  mk-tdata.o
+mk_tdata_LDADD = $(LDADD)
+mk_tdata_DEPENDENCIES = 
+mk_tdata_LDFLAGS = 
 CFLAGS = @CFLAGS@
 COMPILE = $(CC) $(DEFS) $(INCLUDES) $(CPPFLAGS) $(CFLAGS)
 LINK = $(CC) $(CFLAGS) $(LDFLAGS) -o $@
@@ -138,8 +143,8 @@
 
 TAR = tar
 GZIP = --best
-SOURCES = $(mpicalc_SOURCES) $(bftest_SOURCES) $(clean_sat_SOURCES)
-OBJECTS = $(mpicalc_OBJECTS) $(bftest_OBJECTS) $(clean_sat_OBJECTS)
+SOURCES = $(mpicalc_SOURCES) $(bftest_SOURCES) $(clean_sat_SOURCES) $(mk_tdata_SOURCES)
+OBJECTS = $(mpicalc_OBJECTS) $(bftest_OBJECTS) $(clean_sat_OBJECTS) $(mk_tdata_OBJECTS)
 
 default: all
 
@@ -193,6 +198,10 @@
 	@rm -f clean-sat
 	$(LINK) $(clean_sat_LDFLAGS) $(clean_sat_OBJECTS) $(clean_sat_LDADD) $(LIBS)
 
+mk-tdata: $(mk_tdata_OBJECTS) $(mk_tdata_DEPENDENCIES)
+	@rm -f mk-tdata
+	$(LINK) $(mk_tdata_LDFLAGS) $(mk_tdata_OBJECTS) $(mk_tdata_LDADD) $(LIBS)
+
 tags: TAGS
 
 ID: $(HEADERS) $(SOURCES) $(LISP)
@@ -246,6 +255,7 @@
 	../include/../cipher/elgamal.h ../include/../cipher/dsa.h \
 	../include/../cipher/random.h ../include/i18n.h
 clean-sat.o: clean-sat.c
+mk-tdata.o: mk-tdata.c ../config.h
 mpicalc.o: mpicalc.c ../config.h ../include/util.h ../include/types.h \
 	../include/errors.h ../include/mpi.h ../include/iobuf.h \
 	../include/memory.h ../include/i18n.h
diff -urN gnupg-0.2.18/tools/mk-tdata.c gnupg-0.2.19/tools/mk-tdata.c
--- gnupg-0.2.18/tools/mk-tdata.c	Thu Jan  1 01:00:00 1970
+++ gnupg-0.2.19/tools/mk-tdata.c	Mon May 18 15:37:58 1998
@@ -0,0 +1,37 @@
+/* mk-tdata.c
+ *
+ *  Create some simple random testdata
+ *
+ */
+
+#include <config.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+
+
+#ifndef RAND_MAX   /* for SunOS */
+  #define RAND_MAX 32767
+#endif
+
+int
+main(int argc, char **argv)
+{
+    int i, c;
+    int limit =0;
+
+    limit = argc > 1 ? atoi(argv[1]) : 0;
+
+    srand(getpid());
+
+    for(i=0; !limit || i < limit; i++ ) {
+      #ifdef HAVE_RAND
+	c = ((unsigned)(1 + (int) (256.0*rand()/(RAND_MAX+1.0)))-1);
+      #else
+	c = ((unsigned)(1 + (int) (256.0*random()/(RAND_MAX+1.0)))-1);
+      #endif
+	putchar(c);
+    }
+    return 0;
+}
+
